<?php
/**
 * @Copyright Copyright 2006, 2007, 2008, 2009 MDIC - Ministério do Desenvolvimento, da Industria e do Comércio Exterior, Brasil.
 * @tutorial  Este arquivo é parte do programa OASIS - Sistema de Gestão de Demanda, Projetos e Serviços de TI.
 *			  O OASIS é um software livre; você pode redistribui-lo e/ou modifica-lo dentro dos termos da Licença
 *			  Pública Geral GNU como publicada pela Fundação do Software Livre (FSF; na versão 2 da Licença,
 *			  ou (na sua opnião) qualquer versão.
 *			  Este programa é distribuido na esperança que possa ser util, mas SEM NENHUMA GARANTIA;
 *			  sem uma garantia implicita de ADEQUAÇÂO a qualquer MERCADO ou APLICAÇÃO EM PARTICULAR.
 *			  Veja a Licença Pública Geral GNU para maiores detalhes.
 *			  Você deve ter recebido uma cópia da Licença Pública Geral GNU, sob o título "LICENCA.txt",
 *			  junto com este programa, se não, escreva para a Fundação do Software Livre(FSF) Inc., 51 Franklin St,
 *			  Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
 * ********************* OBSERVAÇÕES PARA OS PADROES DE MENSAGENS ***********************
 *
 * 1) QUANDO UMA MENSAGEM POSSUIR %value% :
 *    quer dizer que %value% será substituido por uma variável que será passada pela
 *    função Base_Util::getTranslator('XXX', 'YYY') onde YYY sera introduzido no lugar de %value% em XXX
 *    Obs: quando exitir mais de uma variável em uma mensagem devera ser passado um array para a função onde
 *         a key do array seja igual à string a ser substituida na mensagem.
 *         EX:
 *              $translationStrings['XXXXXXXXXX'] = 'O nr %value1% é maior que nr %value2%';
 *
 *              para traduzir esta frase basta fazer: Base_Util::getTranslator('XXXXXXXXXX', array('value1'=>10000, 'value2'=>500))
 *
 * 2) QUANDO UMA MENSAGEM POSSUIR %0%, %1% ... :
 *    Este padrão é utilizado na internacionalização de mensagens do javascript.
 *    Isto significa que %0%, %1%... serão substituidos pelos parametros passados no array da
 *    função getTranslaterJsComVariaveis(str, arrValue)
 *    Obs: no javascript sempre será passado um array mesmo que exista somente uma variável
 *
 */

$translationStrings = array();
 
/***** Menu do sistema ****/
$translationStrings['L_MENU_ACEITE_PARCELA']                                    = 'Aceite de Parcela';
$translationStrings['L_MENU_ACEITE_PROPOSTA']                                   = 'Aceite de Proposta';
$translationStrings['L_MENU_ACRESCENTAR_PRODUTOS']                              = 'Acrescentar Produtos Proposta';
$translationStrings['L_MENU_ACOMPANHAMENTO_INTERNO']                            = 'Acompanhamento Interno';
$translationStrings['L_MENU_ADMINISTRACAO']                                     = 'Administração';
$translationStrings['L_MENU_ALOCACAO_DE_RECURSOS_DE_CONTRATO']                  = 'Alocação de Recursos de Contrato';
$translationStrings['L_MENU_ALOCACAO_PROFISSIONAL']                             = 'Alocação Profissional';
$translationStrings['L_MENU_ALOCACAO_RECURSO']                                  = 'Alocação de Recurso';
$translationStrings['L_MENU_ALOCACAO_RECURSO_PROPOSTA']                         = 'Alocação de Recurso de Proposta';
$translationStrings['L_MENU_ALOCACAO_RECURSO_PROPOSTA_CONTRATO_ANTERIOR']       = 'Alocação de Recurso de Proposta de Contrato Anterior';
$translationStrings['L_MENU_ALTERACAO_PROPOSTA']                                = 'Alteração de Proposta';
$translationStrings['L_MENU_ANALISE_EXECUCAO_PROJETO']                          = 'Análise de Execução';
$translationStrings['L_MENU_ANALISE_EXECUCAO_PROJETO']                          = 'Análise de Execução de Projeto';
$translationStrings['L_MENU_ANALISE_MEDICAO']                                   = 'Análise de Medição';
$translationStrings['L_MENU_AREA_ATUACAO_TI']                                   = 'Área de Atuação TI';
$translationStrings['L_MENU_AREA_CONHECIMENTO']                                 = 'Área de Conhecimento';
$translationStrings['L_MENU_ASSOCIAR_ATIVIDADE_OBJETO_CONTRATO']                = 'Associar Atividade Objeto Contrato';
$translationStrings['L_MENU_ASSOCIAR_ITEM_INVENTARIO_CONTRATO']                 = 'Associar Item Inventario ao Contrato';
$translationStrings['L_MENU_ASSOCIAR_PERFIL_PAPEL_PROFISSIONAL_OBJETO_CONTRATO']= 'Associar Perfil Papel Profissional Objeto Contrato';
$translationStrings['L_MENU_ASSOCIAR_PROFISSIONAL_PROJETO']                     = 'Associar Profissional Projeto';
$translationStrings['L_MENU_ASSOCIAR_PROJETO_CONTRATO']                         = 'Associar Projeto Existente ao Contrato';
$translationStrings['L_MENU_ASSOCIAR_REQUISITO_CASO_DE_USO']                    = 'Associar Requisito/Caso de Uso';
$translationStrings['L_MENU_ASSOCIAR_REQUISITO_REGRA_NEGOCIO']                  = 'Associar Requisito/Regra de Negócio';
$translationStrings['L_MENU_ASSOCIAR_ROTINA_AO_OBJETO_DO_CONTRATO']             = 'Associar Rotina ao Objeto do Contrato';
$translationStrings['L_MENU_ATA_DE_REUNIAO']                                    = 'Ata de Reunião';
$translationStrings['L_MENU_ATA_DE_REUNIAO_GERAL']                              = 'Ata de Reunião Geral';
$translationStrings['L_MENU_ATIVIDADE']                                         = 'Atividade';
$translationStrings['L_MENU_AUTORIZACAO_PARCELA']                               = 'Autorização de Parcela';
$translationStrings['L_MENU_AVALIACAO_QUALIDADE']                               = 'Avaliação de Qualidade';
$translationStrings['L_MENU_BASELINE']                                          = 'Controle de Baseline';
$translationStrings['L_MENU_BASELINE']                                          = 'Baseline';
$translationStrings['L_MENU_BOX_INICIO']                                        = 'Box Início';
$translationStrings['L_MENU_CALCULADORA_METRICA']                               = 'Calculadora de Metríca';
$translationStrings['L_MENU_CASO_DE_USO']                                       = 'Caso de Uso';
$translationStrings['L_MENU_CASO_DE_USO_ATOR']                                  = 'Ator';
$translationStrings['L_MENU_CASO_DE_USO_COMPLEMENTO']                           = 'Complemento';
$translationStrings['L_MENU_CASO_DE_USO_DEFINICAO']                             = 'Definicao';
$translationStrings['L_MENU_CASO_DE_USO_INTERACAO']                             = 'Interacao';
$translationStrings['L_MENU_CATALOGO_PROJETO']                                  = 'Catálogo de Projetos';
$translationStrings['L_MENU_CHAMADO_TECNICO']                                   = 'Chamado Técnico';
$translationStrings['L_MENU_CHECKLIST_DE_PROJETO']                              = 'Checklist de Projeto';
$translationStrings['L_MENU_CHECKLIST_PARCELA']                                 = 'Checklist Parcela';
$translationStrings['L_MENU_CHECKLIST_PROPOSTA']                                = 'Checklist Proposta';
$translationStrings['L_MENU_COMPARATIVO_DIARIO']                                = 'Comparativo Históricos Por Dia Útil';
$translationStrings['L_MENU_COMPARATIVO_NIVEL_DE_SERVICO']                      = 'Comparativo de Nível de Serviço';
$translationStrings['L_MENU_CONDICAO_SUB_ITEM_METRICA']                         = 'Condição Sub-Item Métrica';
$translationStrings['L_MENU_CONHECIMENTO']                                      = 'Conhecimento';
$translationStrings['L_MENU_CONHECIMENTO_PROFISSIONAL']                         = 'Associar Conhecimento ao Profissional';
$translationStrings['L_MENU_CONTATO_EMPRESA']                                   = 'Contato da Empresa';
$translationStrings['L_MENU_CONTEUDO_BASELINE']                                 = 'Conteúdo de Baseline';
$translationStrings['L_MENU_CONTRATO']                                          = 'Cadastro';
$translationStrings['L_MENU_CONTRATO_DEFINICAO_METRICA']                        = 'Associar Métrica ao Contrato';
$translationStrings['L_MENU_CONTROLE']                                          = 'Controle';
$translationStrings['L_MENU_CONTROLE_ALTERACAO_PROPOSTA']                       = 'Controle Alteração Proposta';
$translationStrings['L_MENU_CONTROLE_ENCERRAMENTO_PROPOSTA']                    = 'Controle Encerramento Proposta';
$translationStrings['L_MENU_CONTROLE_PARCELA']                                  = 'Controle Parcela';
$translationStrings['L_MENU_CONTROLE_PROPOSTA']                                 = 'Controle Proposta';
$translationStrings['L_MENU_COORDENADOR_PRE_DEMANDA']                           = 'Pré-Demanda';
$translationStrings['L_MENU_CRIACAO_PARCELAS']                                  = 'Criação de Parcelas';
$translationStrings['L_MENU_CRIAR_PARCELA']                                     = 'Criar Parcela';
$translationStrings['L_MENU_CSS']                                               = 'CSS';
$translationStrings['L_MENU_CUSTO_CONTRATO_DEMANDA']                            = 'Custo de Contratos do Tipo Demanda';
$translationStrings['L_MENU_CUSTO_CONTRATO_TIPO_DEMANDA']                       = 'Custo de contrato do tipo de demanda';
$translationStrings['L_MENU_CUSTO_PROJETO']                                     = 'Custo do Projeto';
$translationStrings['L_MENU_DADOS_CONTRATO']                                    = 'Dados do Contrato';
$translationStrings['L_MENU_DADOS_TECNICOS']                                    = 'Dados Técnicos';
$translationStrings['L_MENU_DEFINICAO_METRICA']                                 = 'Definição de Métrica';
$translationStrings['L_MENU_DEFINICAO_PROCESSO']                                = 'Definição de Processos';
$translationStrings['L_MENU_DEMANDA']                                           = 'Demanda';
$translationStrings['L_MENU_DEMANDA_DETALHE']                                   = 'Demanda Detalhe';
$translationStrings['L_MENU_DEMANDA_EXECUTOR_DEMANDA']                          = 'Executar Demanda';
$translationStrings['L_MENU_DEMANDAS_EM_ABERTO']                                = 'Demandas em Aberto';
$translationStrings['L_MENU_DESALOCACAO_RECURSO_PROPOSTA']                      = 'Desalocação de Recurso de Proposta';
$translationStrings['L_MENU_DICIONARIO_DE_DADOS']                               = 'Dicionário de Dados';
$translationStrings['L_MENU_DICIONARIO_DE_DADOS']                               = 'Dicionário de Dados';
$translationStrings['L_MENU_DISPONIBILIDADE_SERVICO']                           = 'Disponibilidade de Serviço';
$translationStrings['L_MENU_DISTRIBUICAO_RECURSO']                              = 'Distribuição de Recurso';
$translationStrings['L_MENU_DOCUMENTACAO_CONTRATO']                             = 'Anexar Documentação de Contrato';
$translationStrings['L_MENU_DOCUMENTACAO_DE_CONTRATO']                          = 'Documentação de Contrato';
$translationStrings['L_MENU_DOCUMENTACAO_PROFISSIONAL']                         = 'Anexar documentação de profissional';
$translationStrings['L_MENU_DOCUMENTACAO_PROJETO']                              = 'Upload Arquivos Documentação Projeto';
$translationStrings['L_MENU_DOCUMENTACAO_PROJETO']                              = 'Documentação do Projeto';
$translationStrings['L_MENU_DOCUMENTACAO_PROJETO_ACOMPANHAMENTO_INTERNO']       = 'Documentacao do Projeto';
$translationStrings['L_MENU_DOCUMENTACAO_PROJETO_CONTINUO']                     = 'Documentação de Projeto Contínuo';
$translationStrings['L_MENU_DOCUMENTACAO_PROJETO_CONTROLE']                     = 'Documentação do Controle para o Projeto';
$translationStrings['L_MENU_DOCUMENTO_ACEITE']                                  = 'Documento Aceite Parcela';
$translationStrings['L_MENU_DOCUMENTO_PROPOSTA']                                = 'Documento Proposta';
$translationStrings['L_MENU_ELABORACAO_PROPOSTA']                               = 'Elaboração Proposta';
$translationStrings['L_MENU_EMPRESA']                                           = 'Empresa';
$translationStrings['L_MENU_ENCAMINHAR_PRE_DEMANDA']                            = 'Encaminhar Pré-Demanda';
$translationStrings['L_MENU_ENCAMINHAR_SOLICITACAO_TIPO_DEMANDA']               = 'Encaminhar Solicitação Tipo Demanda';
$translationStrings['L_MENU_ETAPA']                                             = 'Etapa';
$translationStrings['L_MENU_ETAPA_ATIVIDADE']                                   = 'Etapas e Atividades';
$translationStrings['L_MENU_ETAPA_ATIVIDADE_AREA_TI']                           = 'Etapas e Atividades Área de Atuação de TI';
$translationStrings['L_MENU_EVENTO']                                            = 'Evento Administrativo';
$translationStrings['L_MENU_EXECUCAO_PROPOSTA']                                 = 'Execucao de Proposta';
$translationStrings['L_MENU_EXECUTAR_ROTINA']                                   = 'Executar Rotina';
$translationStrings['L_MENU_EXTRATO_GERAL_EXECUCAO_CONTRATO']                   = 'Extrato Geral de Execução de Contrato';
$translationStrings['L_MENU_EXTRATO_GERAL_EXECUCAO_CONTRATO_CUSTO']             = 'Extrato Geral de Execução Contrato com Custo';
$translationStrings['L_MENU_EXTRATO_MENSAL']                                    = 'Extrato Mensal';
$translationStrings['L_MENU_FECHAMENTO_EXTRATO_MENSAL']                         = 'Fechar Extrato Mensal';
$translationStrings['L_MENU_FECHAMENTO_SOLICITACAO']                            = 'Fechamento Solicitação';
$translationStrings['L_MENU_FISCALIZACAO_PROPOSTA']                             = 'Acompanhar Proposta';
$translationStrings['L_MENU_FUNCIONALIDADE']                                    = 'Funcionalidade';
$translationStrings['L_MENU_GERENCIA_QUALIDADE']                                = 'Gerência de Qualidade';
$translationStrings['L_MENU_GERENCIAMENTO_MUDANCA']                             = 'Gerenciamento de Mudança';
$translationStrings['L_MENU_GERENCIAMENTO_MUDANCA_CASO_DE_USO']                 = 'Gerenciar Mudança de Caso de Uso';
$translationStrings['L_MENU_GERENCIAMENTO_MUDANCA_PROPOSTA']                    = 'Gerenciar Mudança de Proposta';
$translationStrings['L_MENU_GERENCIAMENTO_MUDANCA_REGRA_DE_NEGOCIO']            = 'Gerenciar Mudança de Regra de Negócio';
$translationStrings['L_MENU_GERENCIAMENTO_MUDANCA_REQUISITO']                   = 'Gerenciar Mudança de Requisito';
$translationStrings['L_MENU_GERENCIAMENTO_PROJETO']                             = 'Gerenciar Projeto';
$translationStrings['L_MENU_GERENCIAMENTO_RISCO']                               = 'Gerenciamento de Risco';
$translationStrings['L_MENU_GERENCIAMENTO_RISCO_PROJETO']                       = 'Gerenciamento de Risco do Projeto';
$translationStrings['L_MENU_GERENCIAMENTO_ROTINA']                              = 'Rotina';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE']                               = 'Gerenciamento de Teste';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_CASO_USO']                      = 'Caso de Uso';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_CASO_USO_ANALISE']              = 'Análise';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_CASO_USO_HOMOLOGACAO']          = 'Homologação';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_CASO_USO_SOLUCAO']              = 'Solução';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_REGRA_NEGOCIO']                 = 'Regra de Negócio';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_REGRA_NEGOCIO_ANALISE']         = 'Análise';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_REGRA_NEGOCIO_HOMOLOGACAO']     = 'Homologação';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_REGRA_NEGOCIO_SOLUCAO']         = 'Solução';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_REQUISITO']                     = 'Requisito';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_REQUISITO_ANALISE']             = 'Análise';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_REQUISITO_HOMOLOGACAO']         = 'Homologação';
$translationStrings['L_MENU_GERENCIAMENTO_TESTE_REQUISITO_SOLUCAO']             = 'Solução';
$translationStrings['L_MENU_GERENCIAR_PROJETOS']                                = 'Projeto';
$translationStrings['L_MENU_GERENCIAR_PROJETOS_ELABORACAO']                     = 'Gerenciar Projetos Elaboração';
$translationStrings['L_MENU_GERENCIAR_PROJETOS_EXECUCAO_PROPOSTA']              = 'Gerenciar Projetos Execucao Proposta';
$translationStrings['L_MENU_GERENCIAR_PROJETOS_PRE_PROJETO']                    = 'Gerenciar Projetos Pré-Projeto';
$translationStrings['L_MENU_GERENCIAR_PROJETOS_SOLICITACAO']                    = 'Gerenciar Projetos Solicitação';
$translationStrings['L_MENU_GERENCIAR_PROJETOS_SOLICITACAO_DETALHES']           = 'Solicitação Serviço - Detalhes';
$translationStrings['L_MENU_GRUPO_FATOR']                                       = 'Grupo Fator';
$translationStrings['L_MENU_GRUPO_FATOR_ITEM']                                  = 'Item de Grupo Fator';
$translationStrings['L_MENU_HISTORICO']                                         = 'Histórico';
$translationStrings['L_MENU_HISTORICO_DE_PROPOSTA']                             = 'Histórico de Proposta';
$translationStrings['L_MENU_HISTORICO_DEMANDA']                                 = 'Histórico Geral Demanda';
$translationStrings['L_MENU_HISTORICO_PROJETO']                                 = 'Histórico Geral de Projeto';
$translationStrings['L_MENU_HISTORICO_PROJETO_CONTINUADO']                      = 'Histórico Projeto Contínuo';
$translationStrings['L_MENU_HOMOLOGACAO_PARCELA']                               = 'Homologação Parcela';
$translationStrings['L_MENU_HOMOLOGACAO_PROPOSTA']                              = 'Homologação Proposta';
$translationStrings['L_MENU_HW_INVENTARIO']                                     = 'Inventário';
$translationStrings['L_MENU_INFORMACAO_TECNICA']                                = 'Informação Técnica';
$translationStrings['L_MENU_INFORMACOES_BASICAS']                               = 'Informações Básicas';
$translationStrings['L_MENU_INICIO']                                            = 'Início';
$translationStrings['L_MENU_ITEM_CONTROLE_BASELINE']                            = 'Item de Controle de Baseline';
$translationStrings['L_MENU_ITEM_INVENTARIO']                                   = 'Subitem de Inventário';
$translationStrings['L_MENU_ITEM_METRICA']                                      = 'Item Métrica';
$translationStrings['L_MENU_ITEM_PARECER_TECNICO']                              = 'Item de Parecer Técnico';
$translationStrings['L_MENU_ITEM_RISCO']                                        = 'Item de Risco';
$translationStrings['L_MENU_ITEM_TESTE']                                        = 'Item de Teste';
$translationStrings['L_MENU_JUSTIFICATIVA_DEMANDA']                             = 'Justificativa Demanda';
$translationStrings['L_MENU_JUSTIFICATIVA_SOLICITACAO']                         = 'Justificativas de Solicitações';
$translationStrings['L_MENU_JUSTIFICATIVA_SOLICITACAO']                         = 'Justificativa Solicitação';
$translationStrings['L_MENU_LOG']                                               = 'Registro de Log';
$translationStrings['L_MENU_MATRIZ_RASTREABILIDADE']                            = 'Matriz de Rastreabilidade';
$translationStrings['L_MENU_MATRIZ_RASTREABILIDADE_CASO_DE_USO']                = 'Rastreabilidade de Caso de Uso';
$translationStrings['L_MENU_MATRIZ_RASTREABILIDADE_REGRA_DE_NEGOCIO']           = 'Rastreabilidade de Regra De Negócio';
$translationStrings['L_MENU_MATRIZ_RASTREABILIDADE_REQUISITO']                  = 'Rastreabilidade de Requisito';
$translationStrings['L_MENU_MEDIA_NIVEL_DE_SERVICO']                            = 'Media de Nível de Serviço';
$translationStrings['L_MENU_MEDICAO']                                           = 'Medição';
$translationStrings['L_MENU_MEDIDA']                                            = 'Medidas';
$translationStrings['L_MENU_MENSAGERIA']                                        = 'Mensageria';
$translationStrings['L_MENU_MENU']                                              = 'Menu';
$translationStrings['L_MENU_MENU_CONTRATO']                                     = 'Contrato';
$translationStrings['L_MENU_MENU_PROFISSIONAL']                                 = 'Profissional';
$translationStrings['L_MENU_MENU_PROJETO_CONTINUO']                             = 'Projeto Contínuo';
$translationStrings['L_MENU_MENU_REGISTRO_ATIVIDADE']                           = 'Registro de Atividades';
$translationStrings['L_MENU_METRICA']                                           = 'Métrica';
$translationStrings['L_MENU_MODULO']                                            = 'Módulos';
$translationStrings['L_MENU_MODULO_CONTINUADO']                                 = 'Módulo Contínuo';
$translationStrings['L_MENU_MOSTRAR_PARCELAS_ORCAMENTO']                        = 'Mostrar Parcelas de Orçamento';
$translationStrings['L_MENU_NIVEL_SERVICO']                                     = 'Nível de Serviço';
$translationStrings['L_MENU_OBJETO_CONTRATO']                                   = 'Objeto do Contrato';
$translationStrings['L_MENU_OBJETO_PERFIL_PROFISSIONAL']                        = 'Associar Permissão a Usuário';
$translationStrings['L_MENU_OCORRENCIA_ADMINISTRATIVA']                         = 'Ocorrência Administrativa';
$translationStrings['L_MENU_PAGAMENTO_CONTRATO']                                = 'Extrato de Pagamento do Contrato';
$translationStrings['L_MENU_PAINEL_CONTRATO']                                   = 'Contratos';
$translationStrings['L_MENU_PAINEL_DEMANDA']                                    = 'Demanda';
$translationStrings['L_MENU_PAINEL_PROFISSIONAL']                               = 'Profissionais';
$translationStrings['L_MENU_PAPEL_PROFISSIONAL']                                = 'Papel Profissional';
$translationStrings['L_MENU_PAPEL_PROFISSIONAL']                                = 'Papel Profissional';
$translationStrings['L_MENU_PARECER_TECNICO_PARCELA']                           = 'Parecer Técnico Parcela';
$translationStrings['L_MENU_PARECER_TECNICO_PARCELA']                           = 'Parecer Técnico da Parcela';
$translationStrings['L_MENU_PARECER_TECNICO_PROPOSTA']                          = 'Parecer Técnico Proposta';
$translationStrings['L_MENU_PARECER_TECNICO_PROPOSTA']                          = 'Parecer Técnico da Proposta';
$translationStrings['L_MENU_PEDIDO_ADMIN']                                      = 'Pedidos';
$translationStrings['L_MENU_PEDIDO_AUTORIDADE']                                 = 'Autoridade Competente';
$translationStrings['L_MENU_PEDIDO_DECISAO_ENCAMINHADA_COMITE']                 = 'Decisões encaminhadas pelo comitê';
$translationStrings['L_MENU_PEDIDO_DEPENDENCIA']                                = 'Dependência entre Perguntas';
$translationStrings['L_MENU_PEDIDO_EMITIR_SOLICITACAO_PROPOSTA']                = 'Emitir Solicitação da Proposta';
$translationStrings['L_MENU_PEDIDO_MUDANCA']                                    = 'Pedido de Mudança';
$translationStrings['L_MENU_PEDIDO_MUDANCA_CASO_DE_USO']                        = 'Mudança de Caso de Uso';
$translationStrings['L_MENU_PEDIDO_MUDANCA_PROPOSTA']                           = 'Mudança de Proposta';
$translationStrings['L_MENU_PEDIDO_MUDANCA_REGRA_DE_NEGOCIO']                   = 'Mudança de Regra de Negócio';
$translationStrings['L_MENU_PEDIDO_MUDANCA_REQUISITO']                          = 'Mudança de Requisito';
$translationStrings['L_MENU_PEDIDO_OPCAO']                                      = 'Opções de Resposta das Perguntas';
$translationStrings['L_MENU_PEDIDO_PERGUNTA']                                   = 'Cadastro de Perguntas';
$translationStrings['L_MENU_PEDIDO_RELATORIO']                                  = 'Relatório de Solicitações';
$translationStrings['L_MENU_PEDIDO_RESERVADO_PROXIMO_CONTRATO']                 = 'Pedido Reservado Próximo Contrato';
$translationStrings['L_MENU_PEDIDO_RESPOSTA']                                   = 'Cadastro de Respostas';
$translationStrings['L_MENU_PEDIDO_VALIDA']                                     = 'Validação de Solicitações';
$translationStrings['L_MENU_PEDIDO_VALIDADO_ENCAMINHAR']                        = 'Pedidos Validados';
$translationStrings['L_MENU_PENALIDADE']                                        = 'Penalidade';
$translationStrings['L_MENU_PENALIZACAO']                                       = 'Penalização';
$translationStrings['L_MENU_PERFIL']                                            = 'Perfil';
$translationStrings['L_MENU_PERFIL_BOX_INICIO']                                 = 'Perfil Box Início';
$translationStrings['L_MENU_PERFIL_MENU']                                       = 'Perfil Menu por Objeto';
$translationStrings['L_MENU_PERFIL_MENU_SISTEMA']                               = 'Perfil e Menu';
$translationStrings['L_MENU_PERFIL_PROFISSIONAL']                               = 'Perfil Profissional';
$translationStrings['L_MENU_PERFIL_PROFISSIONAL']                               = 'Relatório Perfil Profissional';
$translationStrings['L_MENU_PERFIL_PROFISSIONAL_PAPEL_PROFISSIONAL']            = 'Associar Papel Profissional ao Perfil Profissinal';
$translationStrings['L_MENU_PLANEJAMENTO']                                      = 'Planejamento';
$translationStrings['L_MENU_PLANO_DE_IMPLANTACAO']                              = 'Plano de Implantação';
$translationStrings['L_MENU_PLANO_IMPLANTACAO']                                 = 'Plano de Implantação';
$translationStrings['L_MENU_PRE_DEMANDA']                                       = 'Cadastro';
$translationStrings['L_MENU_PRE_DEMANDA_ANDAMENTO']                             = 'Pré-Demanda Andamento';
$translationStrings['L_MENU_PRE_DEMANDA_EXECUTADA']                             = 'Pré-Demanda Executada';
$translationStrings['L_MENU_PRE_DEMANDA_PAINEL']                                = 'Pré-Demanda';
$translationStrings['L_MENU_PRE_PROJETO']                                       = 'Pré-Projeto';
$translationStrings['L_MENU_PRE_PROJETO_EVOLUTIVO']                             = 'Pré-Projeto Evolutivo';
$translationStrings['L_MENU_PREVISAO_MENSAL']                                   = 'Previsão Mensal';
$translationStrings['L_MENU_PREVISAO_MENSAL_PRODUTOS_PARCELAS']                 = 'Previsao Mensal Produtos das Parcelas';
$translationStrings['L_MENU_PRIORIDADE']                                        = 'Prioridade';
$translationStrings['L_MENU_PROCESSAMENTO_PARCELA']                             = 'Processamento Parcela';
$translationStrings['L_MENU_PRODUTO_PARCELA']                                   = 'Produto da Parcela';
$translationStrings['L_MENU_PROFISSIONAL']                                      = 'Cadastro';
$translationStrings['L_MENU_PROFISSIONAL']                                      = 'Profissional';
$translationStrings['L_MENU_PROFISSIONAL_OBJETO_CONTRATO']                      = 'Associar Profissional ao Objeto do Contrato';
$translationStrings['L_MENU_PROFISSIONAL_PROJETO']                              = 'Profissional Projeto';
$translationStrings['L_MENU_PROJETO']                                           = 'Projeto';
$translationStrings['L_MENU_PROJETO_CONTINUADO']                                = 'Projeto Contínuo - Cadastro';
$translationStrings['L_MENU_PROJETO_DESENVOLVIDO_CONTRATO']                     = 'Desenvolvidos no Período do Contrato';
$translationStrings['L_MENU_PROJETO_PREVISTO']                                  = 'Projeto Previsto';
$translationStrings['L_MENU_PROPOSTA']                                          = 'Proposta';
$translationStrings['L_MENU_QUESTAO_ANALISE_RISCO']                             = 'Questão de Análise de Risco';
$translationStrings['L_MENU_QUESTAO_RISCO']                                     = 'Questão de Risco';
$translationStrings['L_MENU_QUESTIONARIO']                                      = 'Questionário';
$translationStrings['L_MENU_QUESTIONARIO']                                      = 'Questionário';
$translationStrings['L_MENU_REENCAMINHAR_SOLICITACAO_TIPO_DEMANDA']             = 'Reencaminhar Solicitação Tipo Demanda';
$translationStrings['L_MENU_REGISTRO_HISTORICO']                                = 'Registro de Histórico';
$translationStrings['L_MENU_REGISTRO_LOG']                                      = 'Registros de Log';
$translationStrings['L_MENU_REGRA_DE_NEGOCIO']                                  = 'Regras de Negócio';
$translationStrings['L_MENU_REGRA_NEGOCIO']                                     = 'Regra de Negócio';
$translationStrings['L_MENU_RELACAO_CONTRATUAL']                                = 'Relação Contratual';
$translationStrings['L_MENU_RELATORIO']                                         = 'Relatório';
$translationStrings['L_MENU_RELATORIO_CONTRATO']                                = 'Relatórios de Contrato';
$translationStrings['L_MENU_RELATORIO_CONTROLE_ACOMPANHAMENTO']                 = 'Relatorios de Controle e Acompanhamento';
$translationStrings['L_MENU_RELATORIO_DEMANDA']                                 = 'Relatórios de Demanda';
$translationStrings['L_MENU_RELATORIO_GERAL']                                   = 'Relatorios Gerais';
$translationStrings['L_MENU_RELATORIO_GERENCIAMENTO_PROJETO']                   = 'Relatórios de Gerência de Projeto';
$translationStrings['L_MENU_RELATORIO_PROJETO']                                 = 'Relatórios de Projeto';
$translationStrings['L_MENU_RELATORIO_PROPOSTA']                                = 'Relatórios de Proposta';
$translationStrings['L_MENU_RELATORIO_ROTINA']                                  = 'Rotina';
$translationStrings['L_MENU_REQUISITO_PROJETO']                                 = 'Requisitos';
$translationStrings['L_MENU_REQUISITO_PROPOSTA']                                = 'Requisito de Proposta';
$translationStrings['L_MENU_REUNIAO']                                           = 'Reunião';
$translationStrings['L_MENU_REUNIAO_GERAL']                                     = 'Reunião Geral';
$translationStrings['L_MENU_REUNIAO_PROFISSIONAL']                              = 'Reunião Profissional';
$translationStrings['L_MENU_ROTINA']                                            = 'Rotina';
$translationStrings['L_MENU_SITUACAO_PROJETO']                                  = 'Situação do Projeto';
$translationStrings['L_MENU_SITUACAO_PROJETO']                                  = 'Situação do Projeto';
$translationStrings['L_MENU_SITUACAO_PROJETO_ANALISE_EXECUCAO']                 = 'Situação do Projeto X Análise de Execução do Projeto';
$translationStrings['L_MENU_SOLICITACAO']                                       = 'Solicitação';
$translationStrings['L_MENU_SOLICITACAO_SERVICE_DESK']                          = 'Solicitação Service Desk';
$translationStrings['L_MENU_SOLICITACAO_SERVICO']                               = 'Solicitação de Serviço';
$translationStrings['L_MENU_SOLICITACAO_SERVICO_SERVICE_DESK']                  = 'Service Desk';
$translationStrings['L_MENU_SOLICITACAO_SERVICO_CONSULTA_OBJETO_DEMANDA']       = 'Consulta Tipo Demanda';
$translationStrings['L_MENU_SOLICITACAO_SERVICO_CONSULTA_OBJETO_PROJETO']       = 'Consulta Tipo Projeto';
$translationStrings['L_MENU_SOLICITACAO_TIPO_DEMANDA']                          = 'Solicitação de Demanda';
$translationStrings['L_MENU_SUSPENSAO_PROPOSTA']                                = 'Suspensão de Proposta';
$translationStrings['L_MENU_STATUS']                                            = 'Status';
$translationStrings['L_MENU_STATUS_DE_ATENDIMENTO']                             = 'Status de Atendimento';
$translationStrings['L_MENU_SUB_ITEM_METRICA']                                  = 'Sub Item Métrica';
$translationStrings['L_MENU_SUBITEM_INV_DESCRI']                                = 'Descrição Subitem Inventário';
$translationStrings['L_MENU_TIPO_CONHECIMENTO']                                 = 'Tipo de Conhecimento';
$translationStrings['L_MENU_TIPO_DADO_TECNICO']                                 = 'Tipo de Dado Técnico';
$translationStrings['L_MENU_TIPO_DOCUMENTACAO']                                 = 'Tipo de Documentação';
$translationStrings['L_MENU_TIPO_INVENTARIO']                                   = 'Item de Inventário';
$translationStrings['L_MENU_TIPO_PRODUTO']                                      = 'Tipo de Produto';
$translationStrings['L_MENU_TREINAMENTO']                                       = 'Treinamento';
$translationStrings['L_MENU_TREINAMENTO_PROFISSIONAL']                          = 'Associar Profissional ao Treinamento';
$translationStrings['L_MENU_UNIDADE']                                           = 'Unidade';

/**Label's de titulos do módulo Default **/
$translationStrings['L_TIT_ACEITE_PARCELA']                                     = 'Aceite de Parcela';
$translationStrings['L_TIT_ACEITE_PROPOSTA']                                    = 'Aceite de Proposta';
$translationStrings['L_TIT_ACOMPANHAMENTO_PROPOSTA']                            = 'Acompanhamento Proposta';
$translationStrings['L_TIT_ADMINISTRACAO']                                      = 'Administração';
$translationStrings['L_TIT_AJUDA']                                              = 'Ajuda';
$translationStrings['L_TIT_ALOCACAO_RECURSO']                                   = 'Alocação de Recurso de Proposta';
$translationStrings['L_TIT_ALTERACAO_PROPOSTA']                                 = 'Alteração de Proposta';
$translationStrings['L_TIT_ALTERACAO_SENHA']                                    = 'Alteração de Senha';
$translationStrings['L_TIT_ALTERAR_GRUPO_FATOR']                                = 'Alterar Grupo Fator';
$translationStrings['L_TIT_AREA_CONHECIMENTO']                                  = 'Área de Conhecimento';
$translationStrings['L_TIT_ASSOCIAR_PROFISSIONAL']                              = 'Associar Profissional a Projeto';
$translationStrings['L_TIT_AUTORIZACAO_PARCELA']                                = 'Autorização de Parcela';
$translationStrings['L_TIT_ATIVIDADE']                                          = 'Atividade';
$translationStrings['L_TIT_BASE_CONHECIMENTO']                                  = 'Base Conhecimento';
$translationStrings['L_TIT_BOXES_INICIO']                                       = 'Boxes do Inicio';
$translationStrings['L_TIT_CONHECIMENTO']                                       = 'Conhecimento';
$translationStrings['L_TIT_CONTATO_EMPRESA']                                    = 'Contato de Empresa';
$translationStrings['L_TIT_CONTRATO']                                           = 'Contrato';
$translationStrings['L_TIT_CONTROLE']                                           = 'Controle';
$translationStrings['L_TIT_CONTROLE_PARCELAS']                                  = 'Controle de Parcelas';
$translationStrings['L_TIT_CONTROLE_PROPOSTA']                                  = 'Controle de Proposta';
$translationStrings['L_TIT_CRIAR_PROPOSTA']                                     = 'Criar Proposta';
$translationStrings['L_TIT_CUSTO_CONTRATO_DEMANDA']                             = 'Custo de Contratos do Tipo Demanda';
$translationStrings['L_TIT_DEFINICAO_PROCESSOS']                                = 'Definição de Processos';
$translationStrings['L_TIT_DEMANDA']                                            = 'Demanda';
$translationStrings['L_TIT_DEMANDAS']                                           = 'Demandas';
$translationStrings['L_TIT_ENCAMINHAR_PRE_DEMANDA']                             = 'Encaminhar Pré-Demanda';
$translationStrings['L_TIT_EMPRESA']                                            = 'Empresa';
$translationStrings['L_TIT_ETAPA']                                              = 'Etapa';
$translationStrings['L_TIT_ELABORACAO_PROPOSTA']                                = 'Elaboração de Proposta';
$translationStrings['L_TIT_ENCAMINHAR_PRE_DEMANDA']                             = 'Encaminhar Pré-Demanda';
$translationStrings['L_TIT_EXECUCAO_PRODUTOS_PARCELA']                          = 'Execução de Produtos de Parcela';
$translationStrings['L_TIT_EXECUCAO_PROPOSTA']                                  = 'Execução de Proposta';
$translationStrings['L_TIT_EXTRATO_MENSAL']                                     = 'Extrato Mensal';
$translationStrings['L_TIT_FUNCIONALIDADE']                                     = 'Funcionalidade';
$translationStrings['L_TIT_FALE_CONOSCO']                                       = 'Fale Conosco';
$translationStrings['L_TIT_FECHAMENTO_EXTRATO_MENSAL']                          = 'Fechamento de Extrato Mensal';
$translationStrings['L_TIT_FISCALIZACAO_PROPOSTA']                              = 'Acompanhar Proposta';
$translationStrings['L_TIT_GRUPO_FATOR']                                        = 'Grupo Fator';
$translationStrings['L_TIT_GERENCIAR_PROJETO']                                  = 'Gerenciar Projetos';
$translationStrings['L_TIT_GERENCIAMENTO_PROJETO']                              = 'Gerenciamento de Projeto';
$translationStrings['L_TIT_HISTORICO']                                          = 'Histórico';
$translationStrings['L_TIT_HISTORICO_PROJETO_CONTINUADO']                       = 'Histórico de Projeto Continuado';
$translationStrings['L_TIT_HISTORICO_GERAL_PROJETO']                            = 'Histórico Geral do Projeto';
$translationStrings['L_TIT_HOMOLOGACAO_PARCELA']                                = 'Homologação de Parcela';
$translationStrings['L_TIT_HOMOLOGACAO_PROPOSTA']                               = 'Homologação de Proposta';
$translationStrings['L_TIT_INFORMACOES_TECNICAS']                               = 'Informações Técnicas';
$translationStrings['L_TIT_INVENTARIO_HW']                                      = 'Inventário de Hardware';
$translationStrings['L_TIT_ITEM_BASELINE']                                      = 'Item de Controle de Baseline';
$translationStrings['L_TIT_ITEM_RISCO']                                         = 'Item de Risco';
$translationStrings['L_TIT_ITEM_TESTE']                                         = 'Item Teste';
$translationStrings['L_TIT_ITEM_PARECER_TECNICO']                               = 'Item de Parecer Técnico';
$translationStrings['L_TIT_ITEM_INFORMACOES_BASICAS']                           = 'Informações Básicas';
$translationStrings['L_TIT_MENU']                                               = 'Menu';
$translationStrings['L_TIT_MODULO_CONTINUADO']                                  = 'Módulo Continuado';
$translationStrings['L_TIT_NIVEL_SERVICO']                                      = 'Nível de Serviço';
$translationStrings['L_TIT_OBJETO_CONTRATO']                                    = 'Objeto de Contrato';
$translationStrings['L_TIT_PENALIDADE']                                         = 'Penalidade';
$translationStrings['L_TIT_PERFIL']                                             = 'Perfil';
$translationStrings['L_TIT_PROFISSIONAL']                                       = 'Profissional';
$translationStrings['L_TIT_PROJETO_CONTINUADO']                                 = 'Projeto Continuado';
$translationStrings['L_TIT_PROJETO_PREVISTO']                                   = 'Projeto Previsto';
$translationStrings['L_TIT_PAINEL_DEMANDA']                                     = 'Painel Demanda';
$translationStrings['L_TIT_PARECER_TECNICO_PARCELA']                            = 'Parecer Técnico de Parcela';
$translationStrings['L_TIT_PARECER_TECNICO_PROPOSTA']                           = 'Parecer Técnico de Proposta';
$translationStrings['L_TIT_PLANEJAR_EXECUCAO_ATIVIDADE']                        = 'Planejar Execução de Atividades';
$translationStrings['L_TIT_PRE_DEMANDA']                                        = 'Pré-Demanda';
$translationStrings['L_TIT_PRE_DEMANDA_ANDAMENTO']                              = 'Pré-Demanda em Andamento';
$translationStrings['L_TIT_PRE_PROJETO']                                        = 'Pré-projeto';
$translationStrings['L_TIT_PREVISAO_PRODUTOS_PARCELAS']                         = 'Previsão Mensal de Produtos de Parcelas';
$translationStrings['L_TIT_PREVISAO_RELATORIO']                                 = $translationStrings['L_MENU_RELATORIO'];
$translationStrings['L_TIT_QUESTAO_RISCO']                                      = 'Questão de Análise de Risco';
$translationStrings['L_TIT_RELACAO_CONTRATUAL']                                 = 'Relação Contratual';
$translationStrings['L_TIT_REUNIAO']                                            = 'Reunião';
$translationStrings['L_TIT_REUNIAO_GERAL']                                      = 'Reunião Geral';
$translationStrings['L_TIT_REGISTRO_ATIVIDADE']                                 = 'Registro de Atividades';
$translationStrings['L_TIT_REENCAMINHAMENTO_SOLICITACAO_SERVICO']               = 'Reencaminhamento de Solicitação de Serviço';
$translationStrings['L_TIT_ROTINAS']                                            = 'Rotinas';
$translationStrings['L_TIT_STATUS']                                             = 'Status';
$translationStrings['L_TIT_SOLICITACAO_SERVICO_TIPO_DEMANDA']                   = 'Solicitação de Serviço - Tipo Demanda';
$translationStrings['L_TIT_SOLICITACOES_DE_SERVICO']                            = 'Solicitações de Serviço';
$translationStrings['L_TIT_SOLICITACOES_DE_SERVICO_DETALHE']                    = 'Solicitações de Serviço - Detalhes';
$translationStrings['L_TIT_TIPO_CONHECIMENTO']                                  = 'Tipo de Conhecimento';
$translationStrings['L_TIT_TIPO_DADOS_TECNICOS']                                = 'Tipo de Dados Técnicos';
$translationStrings['L_TIT_TIPO_DOCUMENTACAO']                                  = 'Tipo de Documentação';
$translationStrings['L_TIT_TREINAMENTO']                                        = 'Treinamento';
$translationStrings['L_TIT_TREINAMENTO_PROFISSIONAL']                           = 'Treinamento de Profissional';
$translationStrings['L_TIT_TIPO_PRODUTO']                                       = 'Tipo de Produto';
$translationStrings['L_TIT_UNIDADE']                                            = 'Unidade';

/**Label's de titulos do módulo de Pedido **/
$translationStrings['L_TIT_PED_EMITIR_SOLICITACAO']                             = 'Emitir Solicitação Proposta';
$translationStrings['L_TIT_PED_SOLICITACAO']                                    = 'Solicitação de Pedido';

/**Label's de Titulo dos módulos de Relatório **/
$translationStrings['L_TIT_REL_ACEITE_PARCELA']                                 = 'Relatório de Documento Aceite da Parcela';
$translationStrings['L_TIT_REL_ACOMPANHAMENTO_PROPOSTA']                        = 'Registro de Acompanhamento de Proposta';
$translationStrings['L_TIT_REL_ALOCACAO_PROFISSIONAL']                          = 'Relatório de Alocação de Profissional';
$translationStrings['L_TIT_REL_ALOCACAO_RECURSO']                               = 'Relatório de Alocação de Recurso';
$translationStrings['L_TIT_REL_ALOCACAO_RECURSO_CONTRATO']                      = 'Relatório de Alocação de Recurso de Contrato';
$translationStrings['L_TIT_REL_ANALISE_EXECUCAO_PROJETO']                       = 'Relatório de Análise de Execução do Projeto';
$translationStrings['L_TIT_REL_ANALISE_MEDICAO']                                = 'Relatório de Análise de Medição';
$translationStrings['L_TIT_REL_ATA_REUNIAO']                                    = 'Relatório de Ata de Reunião';
$translationStrings['L_TIT_REL_ATA_REUNIAO_GERAL']                              = 'Relatório de Ata de Reunião Geral';
$translationStrings['L_TIT_REL_AVALIACAO_QUALIDADE']                            = 'Relatório de Avaliação de Qualidade';
$translationStrings['L_TIT_REL_AVALIACAO_QUALIDADE_GLOBAL']                     = 'Relatório de Avaliacao Qualidade Global do Contrato';
$translationStrings['L_TIT_REL_BASELINE']                                       = 'Relatório de Baseline';
$translationStrings['L_TIT_REL_CASO_DE_USO']                                    = 'Relatório de Caso de Uso';
$translationStrings['L_TIT_REL_CATALOGO_PROJETO']                               = 'Relatório de Catálago dos Projetos';
$translationStrings['L_TIT_REL_CHECKLIST_PARCELA']                              = 'Relatório de CheckList de Parcela';
$translationStrings['L_TIT_REL_CHAMADO_TECNICO']                                = 'Relatório de Chamado Técnico';
$translationStrings['L_TIT_REL_CHECKLIST_PROJETO']                              = 'Relatório de CheckList de Projetos';
$translationStrings['L_TIT_REL_CHECKLIST_PROPOSTA']                             = 'Relatório de CheckList de Proposta';
$translationStrings['L_TIT_REL_CONTEUDO_BASELINE']                              = 'Relatório de Histórico de Conteúdo de Baseline';
$translationStrings['L_TIT_REL_COMPARATIVO_DEMANDA']                            = 'Relatório de Comparativo de Demanda Por Dia Útil';
$translationStrings['L_TIT_REL_COMPARATIVO_DIARIO_HISTORICO']                   = 'Relatório de Comparativo de Histórico(s) Diário(s)';
$translationStrings['L_TIT_REL_COMPARATIVO_NIVEL_SERVICO']                      = 'Relatório de Comparativo de Nível de Serviço';
$translationStrings['L_TIT_REL_CUSTO_CONTRATO_TIPO_DEMANDA']                    = 'Relatório de Custo de Contratos do Tipo Demanda';
$translationStrings['L_TIT_REL_CUSTO_PROJETO']                                  = 'Relatório de Custo de Projeto';
$translationStrings['L_TIT_REL_DADOS_CONTRATO']                                 = 'Relatório de Dados do Contrato';
$translationStrings['L_TIT_REL_DEMANDA']                                        = 'Relatório de Demanda';
$translationStrings['L_TIT_REL_DEMANDA_EM_ABERTO']                              = 'Relatório de Demanda em Aberto';
$translationStrings['L_TIT_REL_PROJETO_DESENVOLVIDO_CONTRATO']                  = 'Desenvolvidos no Período do Contrato';
$translationStrings['L_TIT_REL_DICIONARIO_DADOS']                               = 'Relatório de Dicionário de Dados';
$translationStrings['L_TIT_REL_DISTRIBUICAO_RECURSO']                           = 'Relatório de Distribuição de Recursos';
$translationStrings['L_TIT_REL_DOCUMENTACAO_PROJETO']                           = 'Relatório de Documentação do Projeto';
$translationStrings['L_TIT_REL_DOCUMENTO_PROPOSTA']                             = 'Relatório de Documento Proposta';
$translationStrings['L_TIT_REL_ETAPA_ATIVIDADE']                                = 'Relatório de Etapa e Atividade';
$translationStrings['L_TIT_REL_EXTRATO_GERAL_EXECUCAO_CONTRATO']                = 'Relatório de Extrato Geral de Execução do Contrato';
$translationStrings['L_TIT_REL_EXTRATO_GERAL_EXECUCAO_CONTRATO_CUSTO']          = 'Relatório de Extrato Geral de Execução do Contrato com Custo';
$translationStrings['L_TIT_REL_EXTRATO_MENSAL']                                 = 'Relatório de Extrato Mensal';
$translationStrings['L_TIT_REL_EXTRATO_PAGAMENTO_CONTRATO']                     = 'Relatório de Extrato de Pagamento de Contrato';
$translationStrings['L_TIT_REL_GERENCIAMENTO_RISCO']                            = 'Relatório de Gerenciamento de Risco do Projeto';
$translationStrings['L_TIT_REL_HISTORICO_DEMANDA']                              = 'Relatório de Histórico de Demanda';
$translationStrings['L_TIT_REL_HISTORICO_GERAL_PROJETO']                        = 'Relatório de Histórico Geral do Projeto';
$translationStrings['L_TIT_REL_HISTORICO_PROPOSTA']                             = 'Relatório de Histórico de Proposta';
$translationStrings['L_TIT_REL_HISTORICO_TESTE_CASO_DE_USO']                    = 'Relatório de Histórico de Teste do Caso de Uso';
$translationStrings['L_TIT_REL_HISTORICO_TESTE_REQUISITOS']                     = 'Relatório de Histórico de Teste Requisitos';
$translationStrings['L_TIT_REL_HISTORICO_TESTE_REGRA_DE_NEGOCIO']               = 'Relatório de Histórico de Teste Regra de Negócio';
$translationStrings['L_TIT_REL_INVENTARIO']                                     = 'Relatório de Inventário';
$translationStrings['L_TIT_REL_ITEM_PARECER_TECNICO']                           = 'Relatório de Item de Parecer Técnico';
$translationStrings['L_TIT_REL_JUSTIFICATIVA_SOLICITCAO']                       = 'Relatório de Justificativa de Solicitção';
$translationStrings['L_TIT_REL_MEDICAO']                                        = 'Relatório de Medição';
$translationStrings['L_TIT_REL_MEDIA_NIVEL_DE_SERVICO']                         = 'Relatório de Media de Nível de serviço';
$translationStrings['L_TIT_REL_PARECER_TECNICO_PROPOSTA']                       = 'Relatório de Parecer Técnico Proposta';
$translationStrings['L_TIT_REL_PARECER_TECNICO_PARCELA']                        = 'Relatório de Parecer Técnico Parcela';
$translationStrings['L_TIT_REL_PAPEL_PROFISSIONAL']                             = 'Relatório de Papel Profissional';
$translationStrings['L_TIT_REL_PENALIZACAO']                                    = 'Relatório de Penalização';
$translationStrings['L_TIT_REL_PERFIL_PROFISSIONAL']                            = 'Relatório de Perfil Profissional';
$translationStrings['L_TIT_REL_PLANO_IMPLANTACAO']                              = 'Relatório de Plano de Implantação';
$translationStrings['L_TIT_REL_PREVISAO_MENSAL']                                = 'Relatório de Previsão Mensal';
$translationStrings['L_TIT_REL_PREVISAO_MENSAL_PRODUTO_PACELA']                 = 'Relatório de Previsão Mensal de Produto de Parcela';
$translationStrings['L_TIT_REL_PROFISSIONAL']                                   = 'Relatório de Profissional';
$translationStrings['L_TIT_REL_QUESTAO_RISCO']                                  = 'Relatório de Questão de Risco';
$translationStrings['L_TIT_REL_QUESTIONARIO']                                   = 'Relatório de Questionário';
$translationStrings['L_TIT_REL_REGISTRO_ATIVIDADE']                             = 'Relatório de Registro de Histórico de Atividade';
$translationStrings['L_TIT_REL_REGISTRO_LOG']                                   = 'Relatório de Registro de Log';
$translationStrings['L_TIT_REL_REGRA_NEGOCIO']                                  = 'Relatório de Regras de Negócio';
$translationStrings['L_TIT_REL_REQUISITO']                                      = 'Relatório de Requisitos';
$translationStrings['L_TIT_REL_SITUACAO_PROJETO']                               = 'Relatório de Situação do Projeto';
$translationStrings['L_TIT_REL_SITUACAO_PROJETO_ANALISE_EXECUCAO_PROJETO']      = 'Relatório de Situação do Projeto X Análise de Execução do Projeto';




/***Label's para a view****/
$translationStrings['L_VIEW_A']                                                 = 'a';
$translationStrings['L_VIEW_A_ALOCAR']                                          = 'A Alocar';
$translationStrings['L_VIEW_A_CONTENTO']                                        = 'A Contento';
$translationStrings['L_VIEW_A_DEFINIR']                                         = 'A definir';
$translationStrings['L_VIEW_ABERTA']                                            = 'Aberta';
$translationStrings['L_VIEW_ABERTA(S)']                                         = 'Aberta(s)';
$translationStrings['L_VIEW_ABERTO']                                            = 'Aberto';
$translationStrings['L_VIEW_ABERTOS_FECHADOS']                                  = 'Abertos e Fechados';
$translationStrings['L_VIEW_ABRANGENCIA_PROJETO']                               = 'Abrangência do Projeto';
$translationStrings['L_VIEW_ABRE_CONFIGURACOES_BOXES']                          = 'Abre as configurações dos boxes';
$translationStrings['L_VIEW_ABRIR']                                             = 'Abrir';
$translationStrings['L_VIEW_ABRIR_MENSAGENS_ANTIGAS']                           = 'Abrir Mensagens Antigas';
$translationStrings['L_VIEW_ACAO']                                              = 'Ação';
$translationStrings['L_VIEW_ACEITE']                                            = 'Aceite';
$translationStrings['L_VIEW_ACEITE_DA_PROPOSTA']                                = 'Aceite da Proposta';
$translationStrings['L_VIEW_ACEITE_MUDANCA']                                    = 'Aceite de Mudança';
$translationStrings['L_VIEW_ACEITE_PRE_DEMANDA']                                = 'Aceite da Pré-Demanda';
$translationStrings['L_VIEW_ACEITO_TERMO_LICENCA']                              = 'Aceito os termos da licença';
$translationStrings['L_VIEW_ACOMPANHAMENTO']                                    = 'Acompanhamento';
$translationStrings['L_VIEW_ACOMPANHAMENTO_PROPOSTA']                           = 'Acompanhamento da Proposta';
$translationStrings['L_VIEW_ACOMPANHAMENTO_SOLICITACAO']                        = 'Acompanhamento da Solicitação';
$translationStrings['L_VIEW_ACOMPANHAR']                                        = 'Acompanhar';
$translationStrings['L_VIEW_ADICIONAR_MODULO']                                  = 'Adicionar Módulo';
$translationStrings['L_VIEW_ADITIVO']                                           = 'Aditivo';
$translationStrings['L_VIEW_ADMINISTRACAO_PEDIDO']                              = 'Administração de Pedidos';
$translationStrings['L_VIEW_AGENDA_PLANO_IMPLANTACAO']                          = 'Agenda do Plano de Implantação';
$translationStrings['L_VIEW_AGUARDANDO_ACEITE']                                 = 'Aguardando Aceite';
$translationStrings['L_VIEW_AGUARDANDO_ANALISE_JUSTIFICATIVA']                  = 'Aguardando Analise Justificativa';
$translationStrings['L_VIEW_AGUARDANDO_EXECUCAO']                               = 'Aguardando Execução';
$translationStrings['L_VIEW_AGUARDANDO_FECHAR_SOLICITACAO']                     = 'Aguardando Fechar Solicitação';
$translationStrings['L_VIEW_AGUARDANDO_HOMOLOGACAO']                            = 'Aguardando Homologação';
$translationStrings['L_VIEW_AGUARDANDO_LEITURA']                                = 'Aguardando Leitura';
$translationStrings['L_VIEW_AGUARDE']                                           = 'Aguarde';
$translationStrings['L_VIEW_AJUDA']                                             = 'Ajuda';
$translationStrings['L_VIEW_ALOCACAO']                                          = 'Alocação';
$translationStrings['L_VIEW_ALOCACAO_RECURSO']                                  = 'Alocação de Recurso';
$translationStrings['L_VIEW_ALOCACAO_RECURSO_PROPOSTA']                         = 'Alocação de Recurso de Proposta';
$translationStrings['L_VIEW_ALOCACAO_RECURSO_PROPOSTA_CONTRATO_ANTERIOR']       = 'Alocação de Recurso de Proposta de Contrato Anterior';
$translationStrings['L_VIEW_ALOCADO']                                           = 'Alocado';
$translationStrings['L_VIEW_ALTA']                                              = 'Alta';
$translationStrings['L_VIEW_ALTERA_CONTRATO_VISUALIZAR_BOX']                    = 'Altera o Contrato da visualização dos boxes';
$translationStrings['L_VIEW_ALTERAR_SENHA']                                     = 'Alterar Senha';
$translationStrings['L_VIEW_AMBOS']                                             = 'Ambos';
$translationStrings['L_VIEW_ANALISE']                                           = 'Análise';
$translationStrings['L_VIEW_ANALISE_ANDAMENTO']                                 = 'Análise em Andamento';
$translationStrings['L_VIEW_ANALISE_JUSTIFICATIVA']                             = 'Análise de Justificativa';
$translationStrings['L_VIEW_ANALISE_MEDICAO']                                   = 'Análise de Medição';
$translationStrings['L_VIEW_ANALISE_RISCO']                                     = 'Análise do Risco';
$translationStrings['L_VIEW_ANALISE_SITUACAO']                                  = 'Análise de Situação';
$translationStrings['L_VIEW_ANALISTA']                                          = 'Analista';
$translationStrings['L_VIEW_ANEXAR_VISUALIZAR']                                 = 'Anexar / Visualizar';
$translationStrings['L_VIEW_ANO']                                               = 'Ano';
$translationStrings['L_VIEW_ANO_SOLICITACAO']                                   = 'Ano Solicitacao';
$translationStrings['L_VIEW_ANO_FINAL']                                         = 'Ano Final';
$translationStrings['L_VIEW_ANO_INICIAL']                                       = 'Ano Inicial';
$translationStrings['L_VIEW_ANTERIOR']                                          = 'Anterior';
$translationStrings['L_VIEW_APROVADO']                                          = 'Aprovado';
$translationStrings['L_VIEW_AREA_ATUACAO']                                      = 'Área de Atuação';
$translationStrings['L_VIEW_AREA_ATUACAO_TI']                                   = 'Área de Atuação TI';
$translationStrings['L_VIEW_AREA_CONHECIMENTO']                                 = 'Área de Conhecimento';
$translationStrings['L_VIEW_ARQUIVO']                                           = 'Arquivo';
$translationStrings['L_VIEW_ASSOCIADO_PROFISSIONAL']                            = 'Associado a este profissional';
$translationStrings['L_VIEW_ASSUNTO']                                           = 'Assunto';
$translationStrings['L_VIEW_ATA']                                               = 'Ata';
$translationStrings['L_VIEW_ATENDIDO_CORRETAMENTO']                             = 'Atendido Corretamente';
$translationStrings['L_VIEW_ALTERACAO_REGISTRO']                                = 'Alteração de Registro';
$translationStrings['L_VIEW_ATENDIDO']                                          = 'Atendido';
$translationStrings['L_VIEW_ATIVIDADE']                                         = 'Atividade';
$translationStrings['L_VIEW_ATIVIDADES']                                        = 'Atividades';
$translationStrings['L_VIEW_ATIVIDADE_ASSOCIADA']                               = 'Atividade Associada';
$translationStrings['L_VIEW_ATIVA']                                             = 'Ativa';
$translationStrings['L_VIEW_ATIVO']                                             = 'Ativo';
$translationStrings['L_VIEW_ATOR']                                              = 'Ator';
$translationStrings['L_VIEW_ATOR_ENVOLVIDO']                                    = 'Ator Envolvido';
$translationStrings['L_VIEW_ATUALIZAR_SOLICITACAO']                             = 'Atualizar Solicitação';
$translationStrings['L_VIEW_AUTORIDADE']                                        = 'Autoridade';
$translationStrings['L_VIEW_AUTORIZACAO']                                       = 'Autorização';
$translationStrings['L_VIEW_AUTORIZACOES']                                      = 'Autorizações';
$translationStrings['L_VIEW_AUTORIZAR']                                         = 'Autorizar';
$translationStrings['L_VIEW_AVALIACAO']                                         = 'Avaliação';
$translationStrings['L_VIEW_AVALIACAO_CONTRATO']                                = 'Avaliação do Contrato';
$translationStrings['L_VIEW_AVALIACAO_PROJETO']                                 = 'Avaliação do Projeto';

$translationStrings['L_VIEW_BAIXA']                                             = 'Baixa';
$translationStrings['L_VIEW_BANCO_DADOS']                                       = 'Banco de Dados';
$translationStrings['L_VIEW_BASE_CONHECIMENTO']                                 = 'Base de Conhecimento';
$translationStrings['L_VIEW_BASE_CONHECIMENTO_SOLUCAO']                         = 'Base de Conhecimento - Solução';
$translationStrings['L_VIEW_BASELINE']                                          = 'Baseline';
$translationStrings['L_VIEW_BASELINE_ATIVA']                                    = 'Baseline Ativa';
$translationStrings['L_VIEW_BASELINE_REGISTRADA']                               = 'Baselines Registradas';
$translationStrings['L_VIEW_BOM']                                               = 'Bom';
$translationStrings['L_VIEW_BOX']                                               = 'Box';
$translationStrings['L_VIEW_BOXES']                                             = 'Boxes';
$translationStrings['L_VIEW_BOXES_ASSOCIADOS']                                  = 'Boxes Associados';

$translationStrings['L_VIEW_CADASTRO']                                          = 'Cadastro';
$translationStrings['L_VIEW_CALCULADO_METRICA']                                 = 'Calculado pela métrica';
$translationStrings['L_VIEW_CALCULO_FORMULA_ITEM_METRICA']                      = 'Cálculo da fórmula do item da métrica';
$translationStrings['L_VIEW_CALCULO_FORMULA_METRICA']                           = 'Cálculo da fórmula da métrica';
$translationStrings['L_VIEW_CAMINHO_FISICO']                                    = 'Caminho físico';
$translationStrings['L_VIEW_CAMINHO_VIRTUAL']                                   = 'Caminho virtual';
$translationStrings['L_VIEW_CAMPO_OBRIGATORIO']                                 = 'Campo obrigatório';
$translationStrings['L_VIEW_CAMPOS_TABELA']                                     = 'Campo(s) da Tabela';
$translationStrings['L_VIEW_CARGO']                                             = 'Cargo';
$translationStrings['L_VIEW_CARACTERES_NAO_ACEITOS']                            = 'Caractéres não aceitos';
$translationStrings['L_VIEW_CASO_DE_USO']                                       = 'Caso de uso';
$translationStrings['L_VIEW_CASOS_DE_USO']                                      = 'Casos de uso';
$translationStrings['L_VIEW_CASOS_DE_USO_ASSOCIADO']                            = 'Casos de uso Associado';
$translationStrings['L_VIEW_CATALOGO']                                          = 'Catálogo';
$translationStrings['L_VIEW_CELULAR']                                           = 'Celular';
$translationStrings['L_VIEW_CHECKLIST_PARCELA_MES']                             = 'CheckList de Parcela do Mês';
$translationStrings['L_VIEW_CHECKLIST_PROPOSTA_MES']                            = 'CheckList de Proposta do Mês';
$translationStrings['L_VIEW_CIFRAO_MOEDA']                                      = 'R$';
$translationStrings['L_VIEW_CLASSIFICACAO']                                     = 'Classificação';
$translationStrings['L_VIEW_CNPJ']                                              = 'CNPJ';
$translationStrings['L_VIEW_CODIGO_CLASSIFICACAO']                              = 'Código de Classificação';
$translationStrings['L_VIEW_CO_GESTOR_CONTRATO']                                = 'Co-gestor do Contrato';
$translationStrings['L_VIEW_CO_GESTOR_PROJETO']                                 = 'Co-gestor do Projeto';
$translationStrings['L_VIEW_COLUNA_PREENCHIDA']                                 = 'Coluna já preenchida';
$translationStrings['L_VIEW_COLUNA']                                            = 'Coluna';
$translationStrings['L_VIEW_COMBO_DIARIA']                                      = 'Diária';
$translationStrings['L_VIEW_COMBO_SEMANAL']                                     = 'Semanal';
$translationStrings['L_VIEW_COMBO_MENSAL']                                      = 'Mensal';
$translationStrings['L_VIEW_COM_ATRASO']                                        = 'Com Atraso';
$translationStrings['L_VIEW_COM_JUSTIFICATIVA']                                 = 'Com justificativa';
$translationStrings['L_VIEW_COM_PRODUTO_CADASTRADO']                            = 'Com produto cadastrado';
$translationStrings['L_VIEW_COMENTARIO_BANCO']                                  = 'Comentário do Banco de Dados';
$translationStrings['L_VIEW_COMENTARIO_OASIS']                                  = 'Comentário do Banco do Oasis';
$translationStrings['L_VIEW_COMENTARIO_REGISTRADO_BANCO']                       = 'Comentário registrado no Banco';
$translationStrings['L_VIEW_COMENTARIO_REGISTRADO_SISTEMA']                     = 'Comentário registrado no sistema';
$translationStrings['L_VIEW_COMITE']                                            = 'Comitê';
$translationStrings['L_VIEW_COMPARATIVO']                                       = 'Comparativo';
$translationStrings['L_VIEW_COMPLETA']                                          = 'Completa';
$translationStrings['L_VIEW_COMPLETADO']                                        = 'Completado';
$translationStrings['L_VIEW_COMPLETAR']                                         = 'Completar';
$translationStrings['L_VIEW_COMPLETO']                                          = 'Completo';
$translationStrings['L_VIEW_COMPLEXO']                                          = 'Complexo';
$translationStrings['L_VIEW_CONCLUIDA']                                         = 'Concluída';
$translationStrings['L_VIEW_CONDICAO']                                          = 'Condição';
$translationStrings['L_VIEW_CONFIGURACAO_BANCO_DADOS']                          = 'Configuração do Banco de Dados';
$translationStrings['L_VIEW_CONFIGURACOES_EMAIL']                               = 'Configurações do E-mail';
$translationStrings['L_VIEW_CONFIGURACOES_GERAIS']                              = 'Configurações Gerais';
$translationStrings['L_VIEW_CONFIRMA']                                          = 'Confirma';
$translationStrings['L_VIEW_CONFIRMAR_LEITURA']                                 = 'Confirmar Leitura';
$translationStrings['L_VIEW_CONFIRMAR_NOVA_SENHA']                              = 'Confirmar nova senha';
$translationStrings['L_VIEW_CONFIRMAR_SENHA']                                   = 'Confirmar Senha';
$translationStrings['L_VIEW_CONHECIMENTO']                                      = 'Conhecimento';
$translationStrings['L_VIEW_CONHECIMENTO_PROFISSIONAL']                         = 'Para Profissional';
$translationStrings['L_VIEW_CONSTANTE']                                         = 'Constante';
$translationStrings['L_VIEW_CONSTANTES_CRIADAS']                                = 'Constantes Criadas';
$translationStrings['L_VIEW_CONSULTA_SOLICITACAO_SERVICO']                      = 'Consulta de Solicitações de Serviço';
$translationStrings['L_VIEW_CONTATO']                                           = 'Contato';
$translationStrings['L_VIEW_CONTATO_EMPRESA']                                   = 'Contato da Empresa';
$translationStrings['L_VIEW_CONTEUDO']                                          = 'Conteúdo';
$translationStrings['L_VIEW_CONTEXTO_GERAL']                                    = 'Contexto Geral';
$translationStrings['L_VIEW_CONTEXTO_PROJETO']                                  = 'Contexto do Projeto';
$translationStrings['L_VIEW_CONTEXTUALIZACAO_PROJETO']                          = 'Contextualização do Projeto';
$translationStrings['L_VIEW_CONTRATO']                                          = 'Contrato';
$translationStrings['L_VIEW_CONTRATO_ATIVO']                                    = 'Contrato Ativo';
$translationStrings['L_VIEW_CONTROLE']                                          = 'Controle';
$translationStrings['L_VIEW_CONTROLES']                                         = 'Controles';
$translationStrings['L_VIEW_CONTROLES_ASSOCIADOS']                              = 'Controles Associados';
$translationStrings['L_VIEW_COR_PRIORIDADE']                                    = 'Cor da Prioridade';
$translationStrings['L_VIEW_COR_STATUS_ATENDIMENTO']                            = 'Cor do Status de Atendimento';
$translationStrings['L_VIEW_CPF_CO_GESTOR']                                     = 'CPF do Co-gestor';
$translationStrings['L_VIEW_CPF_GESTOR']                                        = 'CPF do Gestor';
$translationStrings['L_VIEW_CRIACAO_CONSTANTES']                                = 'Criação das constantes';
$translationStrings['L_VIEW_CRIACAO_PARCELA']                                   = 'Criação de proposta';
$translationStrings['L_VIEW_CRONOGRAMA']                                        = 'Cronograma';
$translationStrings['L_VIEW_CRONOGRAMA_EXECUCAO']                               = 'Cronograma de Execução';
$translationStrings['L_VIEW_CUSTO']                                             = 'Custo';
$translationStrings['L_VIEW_CUSTO_PROJETO']                                     = 'Custo do Projeto';

$translationStrings['L_VIEW_DADOS_BD_INVALIDOS']                                = 'Dados de BD Inválidos';
$translationStrings['L_VIEW_DADOS_CONTRATO']                                    = 'Dados do Contrato';
$translationStrings['L_VIEW_DADOS_MEDICAO']                                     = 'Dados da Medição';
$translationStrings['L_VIEW_DADOS_PARCELA']                                     = 'Dados da Parcela';
$translationStrings['L_VIEW_DADOS_PROJETO']                                     = 'Dados do Projeto';
$translationStrings['L_VIEW_DADOS_PROPOSTA']                                    = 'Dados da Proposta';
$translationStrings['L_VIEW_DATA']                                              = 'Data';
$translationStrings['L_VIEW_DATA_ACEITE']                                       = 'Data do Aceite';
$translationStrings['L_VIEW_DATA_AGENDA']                                       = 'Data de Agenda';
$translationStrings['L_VIEW_DATA_ALOCACAO']                                     = 'Data da Alocação de Recursos';
$translationStrings['L_VIEW_DATA_ANALISE']                                      = 'Data da Análise';
$translationStrings['L_VIEW_DATA_AUTORIZACAO']                                  = 'Data de Autorização';
$translationStrings['L_VIEW_DATA_DECISAO']                                      = 'Data de Decisão';
$translationStrings['L_VIEW_DATA_DECISAO_ANALISE']                              = 'Data de Decisão da Análise';
$translationStrings['L_VIEW_DATA_DEMANDA']                                      = 'Data da Demanda';
$translationStrings['L_VIEW_DATA_ENCERRAMENTO']                                 = 'Data de Encerramento';
$translationStrings['L_VIEW_DATA_EXECUCAO_DECISAO']                             = 'Data da Execução da Decisão';
$translationStrings['L_VIEW_DATA_FECHAMENTO']                                   = 'Data de Fechamento';
$translationStrings['L_VIEW_DATA_FECHAMENTO_PROPOSTA']                          = 'Data de Fechamento desta Proposta';
$translationStrings['L_VIEW_DATA_FIM']                                          = 'Data de Fim';
$translationStrings['L_VIEW_DATA_FINAL']                                        = 'Data Final';
$translationStrings['L_VIEW_DATA_FINAL_MENOR_INICIO']                           = 'Data final menor que a de inicio';
$translationStrings['L_VIEW_DATA_FINAL_PREVISTO']                               = 'Data Final Previsto';
$translationStrings['L_VIEW_DATA_GERACAO_BASELINE']                             = 'Data de geração da Baseline';
$translationStrings['L_VIEW_DATA_HOMOLOGACAO']                                  = 'Data Homologação';
$translationStrings['L_VIEW_DATA_HORA']                                         = 'Data e Hora';
$translationStrings['L_VIEW_DATA_HORA_DEMANDA']                                 = 'Data e Hora da Demanda';
$translationStrings['L_VIEW_DATA_HORA_LOCAL']                                   = 'Brasília, %value1% de %value2% de %value3%.';
$translationStrings['L_VIEW_DATA_HORA_NIVEL_SERVICO']                           = 'Data e Hora do Nível de Serviço';
$translationStrings['L_VIEW_DATA_HORA_PRE_DEMANDA']                             = 'Data e Hora da Pré-Demanda';
$translationStrings['L_VIEW_DATA_INICIO']                                       = 'Data de Início';
$translationStrings['L_VIEW_DATA_INICIO_PREVISTO']                              = 'Data Inicio Previsto';
$translationStrings['L_VIEW_DATA_INICIAL']                                      = 'Data Inicial';
$translationStrings['L_VIEW_DATA_JUSTIFICATIVA']                                = 'Data da Justificativa';
$translationStrings['L_VIEW_DATA_LEITURA']                                      = 'Data de Leitura';
$translationStrings['L_VIEW_DATA_LIMITE']                                       = 'Data de Limite';
$translationStrings['L_VIEW_DATA_NASCIMENTO']                                   = 'Data de Nascimento';
$translationStrings['L_VIEW_DATA_OCORRENCIA']                                   = 'Data da Ocorrência';
$translationStrings['L_VIEW_DATA_PARECER_TECNICO']                              = 'Data do Parecer Técnico';
$translationStrings['L_VIEW_DATA_POSTAGEM']                                     = 'Data de Postagem';
$translationStrings['L_VIEW_DATA_PENALIZACAO']                                  = 'Data da Penalização';
$translationStrings['L_VIEW_DATA_REUNIAO']                                      = 'Data da Reunião';
$translationStrings['L_VIEW_DATA_SAIDA']                                        = 'Data de Saída';
$translationStrings['L_VIEW_DATA_SOLICITACAO']                                  = 'Data da Solicitação';
$translationStrings['L_VIEW_DATA_SOLUCAO']                                      = 'Data Solução';
$translationStrings['L_VIEW_DATA_TERMINO']                                      = 'Data de Término';
$translationStrings['L_VIEW_DATA_VERSAO']                                       = 'Data da Versão';
$translationStrings['L_VIEW_DECISAO']                                           = 'Decisão';
$translationStrings['L_VIEW_DECISAO_ANALISE']                                   = 'Decisão da Análise';
$translationStrings['L_VIEW_DECISAO_EXECUTADA']                                 = 'Decisão Executada';
$translationStrings['L_VIEW_DADOS_ITEM_INVENTARIADO']                           = 'Dados do Item Inventariado';
$translationStrings['L_VIEW_DADOS_PENALIDADE']                                  = 'Dados da Penalidade';
$translationStrings['L_VIEW_DEFINICAO']                                         = 'Definição';
$translationStrings['L_VIEW_DEFINICAO_DADOS']                                   = 'Definição dos Dados';
$translationStrings['L_VIEW_DEFINICOES_METRICA']                                = 'Definições de Métrica';
$translationStrings['L_VIEW_DEFINICOES_METRICA_ASSOCIADAS']                     = 'Definições de Métrica Associadas';
$translationStrings['L_VIEW_DEFINIR_IDIOMA']                                    = 'Definir Idioma';
$translationStrings['L_VIEW_DEMANDA']                                           = 'Demanda';
$translationStrings['L_VIEW_DEMANDA_NAO_LIDA']                                  = ' - Demanda Não Lida';
$translationStrings['L_VIEW_DESCRICAO']                                         = 'Descrição';
$translationStrings['L_VIEW_DESCRICAO_ANALISE']                                 = 'Descrição da Análise';
$translationStrings['L_VIEW_DESCRICAO_DEMANDA']                                 = 'Descrição da Demanda';
$translationStrings['L_VIEW_DESCRICAO_EXECUCAO']                                = 'Descrição da Execução';
$translationStrings['L_VIEW_DESCRICAO_HOMOLOGACAO']                             = 'Descrição da Homologação';
$translationStrings['L_VIEW_DESCRICAO_INVENTARIO']                              = 'Descrição do Inventário';
$translationStrings['L_VIEW_DESCRICAO_PLANO_IMPLANTACAO']                       = 'Descrição do Plano de Implantação';
$translationStrings['L_VIEW_DESCRICAO_PRE_DEMANDA']                             = 'Descrição da Pré-Demanda';
$translationStrings['L_VIEW_DESCRICAO_RESUMIDA']                                = 'Descrição Resumida';
$translationStrings['L_VIEW_DESCRICAO_SISTEMA']                                 = 'Descrição do Sistema';
$translationStrings['L_VIEW_DESCRICAO_SOLICITACAO']                             = 'Descrição da Solicitação';
$translationStrings['L_VIEW_DESCRICAO_SOLUCAO']                                 = 'Descrição da Solução';
$translationStrings['L_VIEW_DESIGNAR_PROFISSIONAL']                             = 'Designar Profissional';
$translationStrings['L_VIEW_DESTINACAO_ALOCACAO_RECURSO']                       = 'Destinação da Alocação de Recursos';
$translationStrings['L_VIEW_DETALHAMENTO']                                      = 'Detalhamento';
$translationStrings['L_VIEW_DETALHE_DEMANDA']                                   = 'Detalhes da Demanda';
$translationStrings['L_VIEW_DETALHE_DEMANDA_EXECUTADA']                         = 'Detalhes da Demanda Executada';
$translationStrings['L_VIEW_DETALHE_EXECUCAO']                                  = 'Detalhes da Execução';
$translationStrings['L_VIEW_DETALHE_PRE_DEMANDA']                               = 'Detalhes da Pré-Demanda';
$translationStrings['L_VIEW_DETALHE_SOLICITACAO']                               = 'Detalhes da Solicitação';
$translationStrings['L_VIEW_DETALHE_SOLICITACAO_EXECUTADA']                     = 'Detalhes da Solicitação Executada';
$translationStrings['L_VIEW_DIA_MES']                                           = 'Dia do Mês'; 
$translationStrings['L_VIEW_DIA_SEMANA']                                        = 'Dia da Semana'; 
$translationStrings['L_VIEW_DIA_SEMANA_DOMINGO']                                = 'D'; // APENAS A PRIMEIRA LETRA DO DIA DA SEMANA
$translationStrings['L_VIEW_DIA_SEMANA_DOMINGO_EXTENSO']                        = 'Domingo';
$translationStrings['L_VIEW_DIA_SEMANA_SEGUNDA']                                = 'S'; // APENAS A PRIMEIRA LETRA DO DIA DA SEMANA
$translationStrings['L_VIEW_DIA_SEMANA_SEGUNDA_EXTENSO']                        = 'Segunda';
$translationStrings['L_VIEW_DIA_SEMANA_TERCA']                                  = 'T'; // APENAS A PRIMEIRA LETRA DO DIA DA SEMANA
$translationStrings['L_VIEW_DIA_SEMANA_TERCA_EXTENSO']                          = 'Terça';
$translationStrings['L_VIEW_DIA_SEMANA_QUARTA']                                 = 'Q'; // APENAS A PRIMEIRA LETRA DO DIA DA SEMANA
$translationStrings['L_VIEW_DIA_SEMANA_QUARTA_EXTENSO']                         = 'Quarta';
$translationStrings['L_VIEW_DIA_SEMANA_QUINTA']                                 = 'Q'; // APENAS A PRIMEIRA LETRA DO DIA DA SEMANA
$translationStrings['L_VIEW_DIA_SEMANA_QUINTA_EXTENSO']                         = 'Quinta';
$translationStrings['L_VIEW_DIA_SEMANA_SEXTA']                                  = 'S'; // APENAS A PRIMEIRA LETRA DO DIA DA SEMANA
$translationStrings['L_VIEW_DIA_SEMANA_SEXTA_EXTENSO']                          = 'Sexta';
$translationStrings['L_VIEW_DIA_SEMANA_SABADO']                                 = 'S'; // APENAS A PRIMEIRA LETRA DO DIA DA SEMANA
$translationStrings['L_VIEW_DIA_SEMANA_SABADO_EXTENSO']                         = 'Sábado';
$translationStrings['L_VIEW_DIAS']                                              = 'Dias';
$translationStrings['L_VIEW_DIFERENCA_HORAS_SEREM_ALOCADAS_MODULO_PROPOSTA_RECURSO_ALOCADO']  = 'Diferença Horas a Serem Alocadas Módulo Proposta X Recurso Alocado';
$translationStrings['L_VIEW_DIFERENCA_HORAS_SEREM_ALOCADAS_PERIODO_CONTRATO_RECURSO_ALOCADO'] = 'Diferença Horas a Serem Alocadas dentro do Período do Contrato X Recurso Alocado';
$translationStrings['L_VIEW_DISTRIBUICAO']                                      = 'Distribuição';
$translationStrings['L_VIEW_DICIONARIO']                                        = 'Dicionário';
$translationStrings['L_VIEW_DICIONARIO_DADOS']                                  = 'Dicionário de Dados';
$translationStrings['L_VIEW_DOCUMENTACAO']                                      = 'Documentação';
$translationStrings['L_VIEW_DOCUMENTO']                                         = 'Documento';
$translationStrings['L_VIEW_DOCUMENTO_PROPOSTA']                                = 'Documento Proposta';
$translationStrings['L_VIEW_DOCUMENTOS']                                        = 'Documento(s)';
$translationStrings['L_VIEW_DOMINIO_EMAIL']                                     = 'Domínio de E-mail';
$translationStrings['L_VIEW_DOMINIO_LDAP']                                      = 'Domínio';
$translationStrings['L_VIEW_DURACAO']                                           = 'Duração';

$translationStrings['L_VIEW_EDITAR_POSICIONAMENTO']                             = 'Editar posicionamento';
$translationStrings['L_VIEW_ELABORACAO_PROPOSTA']                               = 'Elaboração de Proposta';
$translationStrings['L_VIEW_EM_PROCESSAMENTO']                                  = 'Em Processamento';
$translationStrings['L_VIEW_EMAIL']                                             = 'E-mail';
$translationStrings['L_VIEW_EMAIL_LOGIN']                                       = 'E-mail Login';
$translationStrings['L_VIEW_EMAIL_INSTITUCIONAL']                               = 'E-mail Institucional';
$translationStrings['L_VIEW_EMAIL_OUTRO']                                       = 'Outro E-mail';
$translationStrings['L_VIEW_EMAIL_PESSOAL']                                     = 'E-mail Pessoal';
$translationStrings['L_VIEW_EMAIL_PRINCIPAL']                                   = 'E-mail Principal';
$translationStrings['L_VIEW_EMPRESA']                                           = 'Empresa';
$translationStrings['L_VIEW_ENCAMINHAMENTO']                                    = 'Encaminhamento';
$translationStrings['L_VIEW_ENCAMINHAR']                                        = 'Encaminhar';
$translationStrings['L_VIEW_ENCAMINHAR_PARA_SOLICITACAO_PROPOSTA']              = 'Encaminhar para Solicitação de Proposta';
$translationStrings['L_VIEW_ENCERRADA']                                         = 'Encerrada';
$translationStrings['L_VIEW_ENCERRAMENTO']                                      = 'Encerramento';
$translationStrings['L_VIEW_EMCESSADA']                                         = 'Encerrada';
$translationStrings['L_VIEW_ENDERECO']                                          = 'Endereço';
$translationStrings['L_VIEW_ERRO_OCORRIDO']                                     = 'Erro Ocorrido';
$translationStrings['L_VIEW_ESCOPO']                                            = 'Escopo';
$translationStrings['L_VIEW_ESCOPO_RESUMIDO']                                   = 'Escopo Resumido';
$translationStrings['L_VIEW_ESCOLHA_OBJETO_CONTRATO']                           = 'Escolha o Objeto do Contrato';
$translationStrings['L_VIEW_ESCOLHER_CONTRATO_VISUALIZAR_BOX']                  = 'Escolher o Contrato para visualização dos boxes';
$translationStrings['L_VIEW_ESPECIFICACAO_CASO_USO']                            = 'Especificação de Caso de Uso';
$translationStrings['L_VIEW_ESTRATEGICO']                                       = 'Estratégico';
$translationStrings['L_VIEW_ETAPA']                                             = 'Etapa';
$translationStrings['L_VIEW_ETAPAS']                                            = 'Etapas';
$translationStrings['L_VIEW_EVENTO']                                            = 'Evento';
$translationStrings['L_VIEW_EVENTO_ADMINISTRATIVO']                             = 'Evento Administrativo';
$translationStrings['L_VIEW_EVENTOS_ADMINISTRATIVOS']                           = 'Eventos Administrativos';
$translationStrings['L_VIEW_EVENTOS_ADMINISTRATIVOS_CONTRATO']                  = 'Eventos Administrativos Associados ao Contrato';
$translationStrings['L_VIEW_EVOLUTIVO']                                         = 'Evolutivo';
$translationStrings['L_VIEW_EXCECAO']                                           = 'Exceção';
$translationStrings['L_VIEW_EXCECOES']                                          = 'Exceções';
$translationStrings['L_VIEW_EXECUCAO']                                          = 'Execução';
$translationStrings['L_VIEW_EXCLUSAO_REGISTRO']                                 = 'Exclusão de Registro';
$translationStrings['L_VIEW_EXECUCAO_DEMANDA']                                  = 'Execução de Demanda';
$translationStrings['L_VIEW_EXECUCAO_PROJETO']                                  = 'Execução de Projeto';
$translationStrings['L_VIEW_EXECUCAO_PROPOSTA']                                 = 'Execução de Proposta';
$translationStrings['L_VIEW_EXECUCAO_SERVICO']                                  = 'Execução de Serviço';
$translationStrings['L_VIEW_EXECUTADAS_EM_VARIAVEL']                            = 'Executadas em <b>%value%</b>';
$translationStrings['L_VIEW_EXECUTADO']                                         = 'Executado';
$translationStrings['L_VIEW_EXTENSAO_ARQUIVO']                                  = 'Extensão do Arquivo';
$translationStrings['L_VIEW_EXTENSOES']                                         = 'Extensões';
$translationStrings['L_VIEW_EXTERNO']                                           = 'Externo';
$translationStrings['L_VIEW_EXTRATO']                                           = 'Extrato';
$translationStrings['L_VIEW_EXTRATO_MENSAL']                                    = 'Extrato Mensal';

$translationStrings['L_VIEW_FALE_CONOSCO']                                      = 'Fale Conosco';
$translationStrings['L_VIEW_FASE']                                              = 'Fase';
$translationStrings['L_VIEW_FATOR_RELACAO_METRICA_PADRAO']                      = 'Fator em relação a métrica padrão';
$translationStrings['L_VIEW_FAX']                                               = 'Fax';
$translationStrings['L_VIEW_FECHADA']                                           = 'Fechada';
$translationStrings['L_VIEW_FECHADAS']                                          = 'Fechadas';
$translationStrings['L_VIEW_FECHADA(S)']                                        = 'Fechada(s)';
$translationStrings['L_VIEW_FECHADO']                                           = 'Fechado';
$translationStrings['L_VIEW_FECHADOS']                                          = 'Fechados';
$translationStrings['L_VIEW_FECHAMENTO']                                        = 'Fechamento';
$translationStrings['L_VIEW_FECHAR_NIVEL_SERVICO']                              = 'Fechar Nível de serviço';
$translationStrings['L_VIEW_FILTRO']                                            = 'Filtro';
$translationStrings['L_VIEW_FIM']                                               = 'Fim';
$translationStrings['L_VIEW_FIM_ANALISE']                                       = 'Fim da Análise';
$translationStrings['L_VIEW_FINALIZACAO']                                       = 'Finalização';
$translationStrings['L_VIEW_FISCALIZACAO']                                      = 'Fiscalização';
$translationStrings['L_VIEW_FLUXO_ALTERNATIVO']                                 = 'Fluxo Alternativo';
$translationStrings['L_VIEW_FLUXO_BASICO']                                      = 'Fluxo Básico';
$translationStrings['L_VIEW_FONE_CELULAR']                                      = 'Tel. Celular';
$translationStrings['L_VIEW_FONE_RESIDENCIA']                                   = 'Tel. Residência';
$translationStrings['L_VIEW_FONTE']                                             = 'Fonte';
$translationStrings['L_VIEW_FORMATACAO_HTML']                                   = 'Formatação em HTML';
$translationStrings['L_VIEW_FORMULA']                                           = 'Fórmula';
$translationStrings['L_VIEW_FORMULA_CALCULO_VARIAVEL']                          = 'Fórmula para cálculo do %value%';
$translationStrings['L_VIEW_FORMULA_METRICA']                                   = 'Fórmula da Métrica';
$translationStrings['L_VIEW_FORMULA_PADRAO']                                    = 'Fórmula Padrão';
$translationStrings['L_VIEW_FORMULA_ITEM_METRICA']                              = 'Fórmula do item da métrica';
$translationStrings['L_VIEW_FORMULARIO']                                        = 'Formulário';
$translationStrings['L_VIEW_FORMULARIO_SOLICITACAO']                            = 'Formulário de Solicitação';
$translationStrings['L_VIEW_FRASE']                                             = 'Frase';
$translationStrings['L_VIEW_FUNCIONAL']                                         = 'Funcional';
$translationStrings['L_VIEW_FUNCIONALIDADE']                                    = 'Funcionalidade';
$translationStrings['L_VIEW_FUNCIONALIDADES']                                   = 'Funcionalidades';
$translationStrings['L_VIEW_FUNCIONALIDADES_ASSOCIADAS']                        = 'Funcionalidade Associadas';

$translationStrings['L_VIEW_GERAR_ATA_BRANCO']                                  = 'Gerar Ata em Branco';
$translationStrings['L_VIEW_GERENCIAR_PROJETO']                                 = 'Gerenciar Projeto';
$translationStrings['L_VIEW_GERENTE']                                           = 'Gerente';
$translationStrings['L_VIEW_GERENTE_DO_PROJETO']                                = 'Gerente do Projeto';
$translationStrings['L_VIEW_GESTOR']                                            = 'Gestor';
$translationStrings['L_VIEW_GESTOR_CONTRATO']                                   = 'Gestor do Contrato';
$translationStrings['L_VIEW_GESTOR_PROJETO']                                    = 'Gestor do Projeto';
$translationStrings['L_VIEW_GESTOR_SOLICITANTE']                                = 'Gestor Solicitante';
$translationStrings['L_VIEW_GESTOR_SUBSTITUTO_PROJETO']                         = 'Gestor Substituto do Projeto';
$translationStrings['L_VIEW_GLOSAS']                                            = 'Glosa(s)';
$translationStrings['L_VIEW_GRAFICO_GANTT']                                     = 'Gráfico de Gantt';
$translationStrings['L_VIEW_GRAU_SATISFACAO']                                   = 'Grau de Satistação';
$translationStrings['L_VIEW_GRUPO_FATOR']                                       = 'Grupo Fator';

$translationStrings['L_VIEW_HISTORICO']                                         = 'Histórico';
$translationStrings['L_VIEW_HISTORICO_EXECUCAO']                                = 'Histórico de Execução';
$translationStrings['L_VIEW_HISTORICO_PREENCHIMENTO']                           = 'Histórico de preenchimento';
$translationStrings['L_VIEW_HISTORICO_SOLICITACAO']                             = 'Histórico da Solicitação';
$translationStrings['L_VIEW_HOMOLOGACAO']                                       = 'Homologação';
$translationStrings['L_VIEW_HORA']                                              = 'Hora';
$translationStrings['L_VIEW_HORAS']                                             = 'Horas';
$translationStrings['L_VIEW_HORAS_ALOCADAS_MOLUDO_PROPOSTA']                    = 'Horas já Alocadas para Módulo Proposta';
$translationStrings['L_VIEW_HORAS_ALOCADAS_PERIODO_CONTRATO']                   = 'Horas já Alocadas dentro do Período do Contrato';
$translationStrings['L_VIEW_HORAS_ALOCADAS_PROPOSTA']                           = 'Horas já Alocadas para a Proposta';
$translationStrings['L_VIEW_HORAS_MODULO_PROPOSTA']                             = 'Horas de Módulo Proposta';
$translationStrings['L_VIEW_HORAS_PROJETO']                                     = 'Horas do Projeto';
$translationStrings['L_VIEW_HORAS_PROPOSTA']                                    = 'Horas de Proposta';
$translationStrings['L_VIEW_HORAS_SEREM_ALOCADAS_PERIODO_CONTRATO']             = 'Horas a Serem Alocadas dentro do Período do Contrato';
$translationStrings['L_VIEW_HOST']                                              = 'Host';

$translationStrings['L_VIEW_IMPACTO']                                           = 'Impacto';
$translationStrings['L_VIEW_IMPACTO_CRONOGRAMA']                                = 'Impacto no Cronograma';
$translationStrings['L_VIEW_IMPACTO_CUSTO']                                     = 'Impacto de Custo';
$translationStrings['L_VIEW_IMPACTO_PROJETO']                                   = 'Impacto do Projeto';
$translationStrings['L_VIEW_IMPACTO_TECNICO']                                   = 'Impacto Técnico';
$translationStrings['L_VIEW_IMPLANTACAO']                                       = 'Implantação';
$translationStrings['L_VIEW_IMPRIMIR_ACOMPANHAMENTO']                           = 'Imprimir Acompanhamento';
$translationStrings['L_VIEW_IMPRIMIR_RELATORIO_DEMANDA']                        = 'Imprimir Relatório de Demanda';
$translationStrings['L_VIEW_IMPRIMIR_CHAMADO_TECNICO']                          = 'Imprimir Chamado Técnico';
$translationStrings['L_VIEW_INDICE']                                            = 'Índice';
$translationStrings['L_VIEW_INDICE_AVALIACAO']                                  = 'Índice de Avaliação';
$translationStrings['L_VIEW_INDICE_GRUPO']                                      = 'Índice do Grupo';
$translationStrings['L_VIEW_INDICE_OBTIDO']                                     = 'Índice obtido';
$translationStrings['L_VIEW_INDICE_OBTIDO_ANALISE']                             = 'Índice obtido na análise';
$translationStrings['L_VIEW_INATIVA']                                           = 'Inativa';
$translationStrings['L_VIEW_INATIVO']                                           = 'Inativo';
$translationStrings['L_VIEW_INCLUIR_ACOMPANHAMENTO']                            = 'Incluir Acompanhamento';
$translationStrings['L_VIEW_INCLUSAO_REGISTRO']                                 = 'Inclusão de Registro';
$translationStrings['L_VIEW_INF_TECNICAS']                                      = 'Inf. Técnicas';
$translationStrings['L_VIEW_INFO_CHAMADO_TECNICO']                              = 'Inf. para Chamado Técnico';
$translationStrings['L_VIEW_INFORMACAO_TECNICA']                                = 'Informação Técnica';
$translationStrings['L_VIEW_INFORMACOES_BASICAS']                               = 'Informações Básicas';
$translationStrings['L_VIEW_INFORMACOES_GERAIS']                                = 'Informações Gerais';
$translationStrings['L_VIEW_INFORMACOES_PROJETO']                               = 'Informações do Projeto';
$translationStrings['L_VIEW_INFORMACOES_QUESTIONARIO']                          = 'Informações do questionário';
$translationStrings['L_VIEW_INFORMACOES_RODAPE']                                = 'Informações do Rodapé';
$translationStrings['L_VIEW_INFRACAO']                                          = 'Infração';
$translationStrings['L_VIEW_INICIO']                                            = 'Início';
$translationStrings['L_VIEW_INICIO_ANALISE']                                    = 'Início da Análise';
$translationStrings['L_VIEW_INICIO_PREVISTO']                                   = 'Início Previsto';
$translationStrings['L_VIEW_INSATISFEITO']                                      = 'Insatisfeito';
$translationStrings['L_VIEW_INSIRA_PRODUTO']                                    = 'Insira os produtos';
$translationStrings['L_VIEW_INSTALACAO']                                        = 'Instalação';
$translationStrings['L_VIEW_INTERACAO']                                         = 'Interação';
$translationStrings['L_VIEW_INTERACAO_ENTRE']                                   = 'Interações entre';
$translationStrings['L_VIEW_INTERNO']                                           = 'Interno';
$translationStrings['L_VIEW_INTERVALO_TEMPO_RESPOSTA']                          = 'Intervalo de Tempo de Resposta (%)';
$translationStrings['L_VIEW_INTRODUCAO']                                        = 'Introdução';
$translationStrings['L_VIEW_INVENTARIOS']                                       = 'Inventario';
$translationStrings['L_VIEW_IP']                                                = 'IP';
$translationStrings['L_VIEW_ITEM']                                              = 'Item';
$translationStrings['L_VIEW_ITEM_CONTROLE_BASELINE']                            = 'Item de Controle de Baseline';
$translationStrings['L_VIEW_ITEM_GRUPO_FATOR']                                  = 'Item Grupo Fator';
$translationStrings['L_VIEW_ITEM_INVENTARIADO']                                 = 'Item Inventariado';
$translationStrings['L_VIEW_ITEM_INVENTARIO']                                   = 'Item de Inventário';
$translationStrings['L_VIEW_ITEM_INVENTARIO_VINCULADOS_CONTRATO']              = 'Item Inventarios vinculados ao Contrato';
$translationStrings['L_VIEW_ITEM_METRICA']                                      = 'Item da Métrica';
$translationStrings['L_VIEW_ITEM_NAO_APLICA']                                   = 'Item Não Aplica';
$translationStrings['L_VIEW_ITEM_PARECER']                                      = 'Intem de Parecer';
$translationStrings['L_VIEW_ITEM_PARECER_TECNICO']                              = 'Item de Parecer Técnico';
$translationStrings['L_VIEW_ITEM_RISCO']                                        = 'Item de Risco';
$translationStrings['L_VIEW_ITEM_TESTE']                                        = 'Item de Teste';
$translationStrings['L_VIEW_ITEM_AVALIDADO']                                    = 'Item(ns) Avaliado(s)';

$translationStrings['L_VIEW_DADOS_JUSTIFICATIVA']                               = 'Dados da Justificativa';
$translationStrings['L_VIEW_JUSTIFICADA']                                       = 'Justificada';
$translationStrings['L_VIEW_JUSTIFICAR']                                        = 'Justificar';
$translationStrings['L_VIEW_JUSTIFICATIVA']                                     = 'Justificativa';
$translationStrings['L_VIEW_JUSTIFICATIVA_METRICA']                             = 'Justificativa da métrica';
$translationStrings['L_VIEW_JUSTIFICATIVA_NAO_APLICACAO_METRICA']               = 'Justificativa de utilização da métrica';
$translationStrings['L_VIEW_JUSTIFICATIVA_PENDENTE']                            = 'Justificativa Pendente';

$translationStrings['L_VIEW_LEGENDA']                                           = 'Legenda';
$translationStrings['L_VIEW_LISTA']                                             = 'Lista';
$translationStrings['L_VIEW_LISTA_PARCELAS']                                    = 'Lista de Parcelas';
$translationStrings['L_VIEW_LISTA_PROJETO']                                     = 'Lista de Projeto';
$translationStrings['L_VIEW_LIVRE']                                             = 'Livre';
$translationStrings['L_VIEW_LOCAL']                                             = 'Local';
$translationStrings['L_VIEW_LOCAL_DOCUMENTOS_AREA_TI']                          = 'Local dos documentos da área de TI';
$translationStrings['L_VIEW_LOCAL_REUNIAO']                                     = 'Local da Reunião';
$translationStrings['L_VIEW_LOG']                                               = 'Log';
$translationStrings['L_VIEW_LOGIN']                                             = 'Login';

$translationStrings['L_VIEW_MAIOR_REALIZADO']                                   = 'Maior Realizado';
$translationStrings['L_VIEW_MAPA_SITE']                                         = 'Mapa do Site';
$translationStrings['L_VIEW_MATRIZ_RASTREABILIDADE_CASO_DE_USO']                = 'Matriz de Rastreabilidade de Caso de Uso';
$translationStrings['L_VIEW_MATRIZ_RASTREABILIDADE_REGRA_DE_NEGOCIO']           = 'Matriz de Rastreabilidade de Regra de Negócio';
$translationStrings['L_VIEW_MATRIZ_RASTREABILIDADE_REQUISITOS']                 = 'Matriz de Rastreabilidade de Requisitos';
$translationStrings['L_VIEW_MEDIA_METRICA_MENSAL']                              = 'Média de %value% Mensal (TUM/PE)';
$translationStrings['L_VIEW_MEDIA']                                             = 'Media';
$translationStrings['L_VIEW_MEDICAO']                                           = 'Medição';
$translationStrings['L_VIEW_MEDIDA']                                            = 'Medida';
$translationStrings['L_VIEW_MEDIDA_ASSOCIADA']                                  = 'Medida Associada';
$translationStrings['L_VIEW_MEDIDAS']                                           = 'Medidas';
$translationStrings['L_VIEW_MENOR_REALIZADO']                                   = 'Menor Realizado';
$translationStrings['L_VIEW_MENSAGEM']                                          = 'Mensagem';
$translationStrings['L_VIEW_MENSAGENS']                                         = 'Mensagens';
$translationStrings['L_VIEW_MENSAGENS_ANTIGAS']                                 = 'Mensagens Antigas';
$translationStrings['L_VIEW_MENSAL']                                            = 'Mensal';
$translationStrings['L_VIEW_MENU']                                              = 'Menu';
$translationStrings['L_VIEW_MENU_PAI']                                          = 'Menu Pai';
$translationStrings['L_VIEW_MES']                                               = 'Mês';
$translationStrings['L_VIEW_MESES']                                             = 'Meses';
$translationStrings['L_VIEW_MES_ANO']                                           = 'Mês/Ano';
$translationStrings['L_VIEW_MES_ANTERIOR']                                      = 'Mês anterior';
$translationStrings['L_VIEW_MES_FIM']                                           = 'Mês Fim';
$translationStrings['L_VIEW_MES_FINAL']                                         = 'Mês Final';
$translationStrings['L_VIEW_MES_INICIAL']                                       = 'Mês Inicial';
$translationStrings['L_VIEW_MES_INICIO']                                        = 'Mês Início';
$translationStrings['L_VIEW_METRICA']                                           = 'Métrica';
$translationStrings['L_VIEW_MINUTOS_PARA_LEITURA']                              = 'Minutos para Leitura';
$translationStrings['L_VIEW_MITIGACAO']                                         = 'Mitigação';
$translationStrings['L_VIEW_MODELO_DADOS']                                      = 'Modelo de Dados';
$translationStrings['L_VIEW_MODIFICAR']                                         = 'Modificar';
$translationStrings['L_VIEW_MODULO']                                            = 'Módulo';
$translationStrings['L_VIEW_MODULO_CONTINUADO']                                 = 'Módulo Continuado';
$translationStrings['L_VIEW_MODULO_CONTINUO']                                   = 'Módulo Contínuo';
$translationStrings['L_VIEW_MODULO_TRABALHADO_PROPOSTA']                        = 'Módulos Trabalhados na Proposta';
$translationStrings['L_VIEW_MODULOS']                                           = 'Módulos';
$translationStrings['L_VIEW_MODULOS_DISPONIVEIS']                               = 'Módulos Disponíveis';
$translationStrings['L_VIEW_MODULOS_VINCULADOS_PROPOSTA']                       = 'Módulos vinculados à proposta selecionada';
$translationStrings['L_VIEW_MOTIVO_FECHAMENTO']                                 = 'Motivo do fechamento';
$translationStrings['L_VIEW_MOTIVO_MUDANCA']                                    = 'Motivo da Mudança';
$translationStrings['L_VIEW_MOTIVO_REABERTURA']                                 = 'Motivo da Reabertura';
$translationStrings['L_VIEW_MOSTRAR_OBJETO_CONTRATO_INATIVO']                   = 'Mostrar Objetos de Contratos Inativos';
$translationStrings['L_VIEW_MOSTRAR_TODOS']                                     = 'Mostrar Todos';
$translationStrings['L_VIEW_MUITO_INSATISFEITO']                                = 'Muito Insatisfeito';
$translationStrings['L_VIEW_MUITO_SATISFEITO']                                  = 'Muito Satisfeito';
$translationStrings['L_VIEW_MULTA']                                             = 'Multa(s)';
$translationStrings['L_VIEW_MULTIPLA_RESPOSTA']                                 = 'Múltipla Resposta';

$translationStrings['L_VIEW_NASCIMENTO']                                        = 'Nascimento';
$translationStrings['L_VIEW_NAO']                                               = 'Não';
$translationStrings['L_VIEW_NAO_ACOMPANHAMENTO']                                = 'Não Acompanhamento';
$translationStrings['L_VIEW_NAO_ALOCADO']                                       = 'Não Alocado';
$translationStrings['L_VIEW_NAO_ALOCADO_PROPOSTA']                              = 'Não Alocado (Proposta)';
$translationStrings['L_VIEW_NAO_APLICA']                                        = 'Não se Aplica';
$translationStrings['L_VIEW_NAO_ATENDIDO']                                      = 'Não Atendido';
$translationStrings['L_VIEW_NAO_ATENDIDO_CORRETAMENTO']                         = 'Não Atendido Corretamente';
$translationStrings['L_VIEW_NAO_EXECUTADO']                                     = 'Não Executado';
$translationStrings['L_VIEW_NAO_ESPECIFICADO']                                  = 'Não Especificado';
$translationStrings['L_VIEW_NAO_FUNCIONAL']                                     = 'Não Funcional';
$translationStrings['L_VIEW_NAO_OK']                                            = 'Não OK';
$translationStrings['L_VIEW_NAO_SOU_CADASTRATO']                                = 'Não sou cadastrado';
$translationStrings['L_VIEW_NECESSITA_JUSTIFICATIVA_SOLICITACAO_SERVICO']       = 'Necessita de Justificativa para Solicitação de Serviço';
$translationStrings['L_VIEW_NIVEL']                                             = 'Nível';
$translationStrings['L_VIEW_NIVEL_SERVICO']                                     = 'Nível de Serviço';
$translationStrings['L_VIEW_NIVEL_SOLICITANTE']                                 = 'Nível Solicitante';
$translationStrings['L_VIEW_NOME']                                              = 'Nome';
$translationStrings['L_VIEW_NOME_AREA_TI']                                      = 'Nome da área de TI';
$translationStrings['L_VIEW_NOME_BANCO_DADOS']                                  = 'Nome do Banco de Dados';
$translationStrings['L_VIEW_NOME_BOX']                                          = 'Nome do Box';
$translationStrings['L_VIEW_NOME_CASO_DE_USO']                                  = 'Nome do Caso de Uso';
$translationStrings['L_VIEW_NOME_CONHECIDO']                                    = 'Nome Conhecido';
$translationStrings['L_VIEW_NOME_INVENTARIO']                                   = 'Nome Inventário';
$translationStrings['L_VIEW_NOME_MODULO']                                       = 'Nome do Módulo';
$translationStrings['L_VIEW_NOME_PRE_PROJETO']                                  = 'Nome do Pré Projeto';
$translationStrings['L_VIEW_NOME_PROJETO']                                      = 'Nome do Projeto';
$translationStrings['L_VIEW_NOVA_PROPOSTA']                                     = 'Nova Proposta';
$translationStrings['L_VIEW_NOVA_SENHA']                                        = 'Nova Senha';
$translationStrings['L_VIEW_NOVO_POSICIONAMENTO']                               = 'Novo Posicionamento';
$translationStrings['L_VIEW_NOVO_REQUISITO']                                    = 'Novo Requisito';
$translationStrings['L_VIEW_NR_CONTRATO']                                       = 'Nr Contrato';
$translationStrings['L_VIEW_NR_DEMANDA']                                        = 'Número Demanda';
$translationStrings['L_VIEW_NR_PROCESSO']                                       = 'Nr Processo';
$translationStrings['L_VIEW_NR_PROFISSIONAL_REGISTRO_ATIVIDADE']                = 'Nr Profissionais que Registraran';
$translationStrings['L_VIEW_NR_PROPOSTA']                                       = 'Nr Proposta';
$translationStrings['L_VIEW_NR_ORDEM']                                          = 'Nr Ordem';
$translationStrings['L_VIEW_NUCLEO']                                            = 'Núcleo';
$translationStrings['L_VIEW_NULO']                                              = 'Nulo';
$translationStrings['L_VIEW_NUMERO']                                            = 'Número';
$translationStrings['L_VIEW_NUMERO2']                                           = 'No.';
$translationStrings['L_VIEW_NUMERO_CONTRATO']                                   = 'Número do Contrato';
$translationStrings['L_VIEW_NUMERO_PARCELA']                                    = 'Número da Parcela';
$translationStrings['L_VIEW_NUMERO_PARCELAS']                                   = 'Número de Parcelas';
$translationStrings['L_VIEW_NUMERO_PENALIDADE']                                 = 'Número da Penalidade';
$translationStrings['L_VIEW_NUMERO_SOLICITACAO']                                = 'Número da solicitação';

$translationStrings['L_VIEW_OCORRENCIA']                                        = 'Ocorrência';
$translationStrings['L_VIEW_OBJETIVO']                                          = 'Objetivo';
$translationStrings['L_VIEW_OBJETIVO_MEDIDA']                                   = 'Objetivo da Medida';
$translationStrings['L_VIEW_OBJETIVO_PRE_PROJETO_EVOLUTIVO']                    = 'Objetivo do Pré Projeto Evolutivo';
$translationStrings['L_VIEW_OBJETIVO_PROPOSTA']                                 = 'Objetivo Proposta';
$translationStrings['L_VIEW_OBJETO']                                            = 'Objeto';
$translationStrings['L_VIEW_OBJETO_CONTRATO']                                   = 'Objeto do Contrato';
$translationStrings['L_VIEW_OBJETO_EXECUTOR']                                   = 'Objeto Executor';
$translationStrings['L_VIEW_OBJETO_SOLICITANTE']                                = 'Objeto Solicitante';
$translationStrings['L_VIEW_OBRIGATORIA']                                       = 'Obrigatória';
$translationStrings['L_VIEW_OBRIGATORIO']                                       = 'Obrigatório';
$translationStrings['L_VIEW_OBSERVACAO']                                        = 'Observação';
$translationStrings['L_VIEW_OBSERVACAO_ACEITE']                                 = 'Observação do Aceite';
$translationStrings['L_VIEW_OBSERVACAO_EXECUCAO_DECISAO']                       = 'Observação da Execução da Decisão';
$translationStrings['L_VIEW_OBSERVACAO_GERAL']                                  = 'Observação Geral';
$translationStrings['L_VIEW_OBSERVACAO_INVENTARIO']                             = 'Observação do Inventário';
$translationStrings['L_VIEW_OBSERVACAO_METRICA']                                = 'Observação da Métrica';
$translationStrings['L_VIEW_OBSERVACAO_PROJETO']                                = 'Observação do Projeto';
$translationStrings['L_VIEW_OBSERVACOES']                                       = 'Observações';
$translationStrings['L_VIEW_OBSERVACOES_ANTERIORES']                            = 'Observações Anteriores';
$translationStrings['L_VIEW_OBSERVACOES_ENCAMINHAMENTO']                        = 'Observações do Encaminhamento';
$translationStrings['L_VIEW_OBSERVACOES_EXECUCAO']                              = 'Observações de Execução';
$translationStrings['L_VIEW_OBSERVACOES_PARTICULARIADES_PROJETO']               = 'Observações ou particularidades do projeto';
$translationStrings['L_VIEW_OK']                                                = 'OK';
$translationStrings['L_VIEW_OLA']                                               = 'Olá, <b>%value%</b>';
$translationStrings['L_VIEW_OPCAO']                                             = 'Opção';
$translationStrings['L_VIEW_ORDEM']                                             = 'Ordem';
$translationStrings['L_VIEW_ORDEM_ITEM_TESTE']                                  = 'Ordem do Item de Teste';
$translationStrings['L_VIEW_O_QUE_E_OASIS']                                     = 'O Que é o OASIS?';
$translationStrings['L_VIEW_OTIMO']                                             = 'Ótimo';

$translationStrings['L_VIEW_PADRAO']                                            = 'Padrão';
$translationStrings['L_VIEW_PAGINA']                                            = 'Página';
$translationStrings['L_VIEW_PAGINAS']                                           = 'Páginas';
$translationStrings['L_VIEW_PAINEL_HORAS']                                      = 'Painel de horas';
$translationStrings['L_VIEW_PAINEL_UNIDADE_METRICA_VARIAVEL']                   = 'Painel de %value%';
$translationStrings['L_VIEW_PAPEIS_PROFISSIONAIS']                              = 'Papéis Profissionais';
$translationStrings['L_VIEW_PAPEIS_PROFISSIONAIS_ASSOCIADOS']                   = 'Papéis Profissionais Associados';
$translationStrings['L_VIEW_PAPEL']                                             = 'Papel';
$translationStrings['L_VIEW_PAPEL_PROFISSIONAL']                                = 'Papel Profissional';
$translationStrings['L_VIEW_PAPEL_PROFISSIONAL_ASSOCIADO']                      = 'Papel Profissional Associado';
$translationStrings['L_VIEW_PARCELA']                                           = 'Parcela';
$translationStrings['L_VIEW_PARCELAS']                                          = 'Parcelas';
$translationStrings['L_VIEW_PARCELA_NR']                                        = 'Parcela Nr';
$translationStrings['L_VIEW_PARCELA_NR_DT_PREVISAO']                            = 'Parcela %value1% (%value2%)';
$translationStrings['L_VIEW_PARECER']                                           = 'Parecer';
$translationStrings['L_VIEW_PARECER_TECNICO']                                   = 'Parecer Técnico';
$translationStrings['L_VIEW_PARECER_TECNICO_PARCELA']                           = 'Parecer Técnico da Parcela';
$translationStrings['L_VIEW_PARECER_TECNICO_PROPOSTA']                          = 'Parecer Técnico da Proposta';
$translationStrings['L_VIEW_PARTICIPANTE']                                      = 'Participante';
$translationStrings['L_VIEW_PARTICIPANTES']                                     = 'Participantes';
$translationStrings['L_VIEW_PARTICIPANTES_VARIAVEL']                            = 'Participantes (%value%)';
$translationStrings['L_VIEW_PASSO']                                             = 'Passo';
$translationStrings['L_VIEW_PAUTA']                                             = 'Pauta';
$translationStrings['L_VIEW_PEDIDO_MUDANCA']                                    = 'Pedido de Mudança';
$translationStrings['L_VIEW_PEDIDO_MUDANCA_SOLICITADO']                         = 'Pedido de Mudança Solicitado';
$translationStrings['L_VIEW_PENALIDADE']                                        = 'Penalidade';
$translationStrings['L_VIEW_PENALIZACAO']                                       = 'Penalização';
$translationStrings['L_VIEW_PENDENTE']                                          = 'Pendente';
$translationStrings['L_VIEW_PERFIL']                                            = 'Perfil';
$translationStrings['L_VIEW_PERFIL_PROFISSIONAL']                               = 'Perfil Profissional';
$translationStrings['L_VIEW_PERFIL_PROFISSIONAL_ASSOCIADO']                     = 'Perfil Profissional Associado';
$translationStrings['L_VIEW_PERFIS_ALOCADOS']                                   = 'Perfis Alocados';
$translationStrings['L_VIEW_PERGUNTA']                                          = 'Pergunta';
$translationStrings['L_VIEW_PERGUNTAS']                                         = 'Perguntas';
$translationStrings['L_VIEW_PERGUNTAS_DEPENDENTES']                             = 'Pergunta(s) dependente(s)';
$translationStrings['L_VIEW_PERGUNTAS_OBRIGATORIAS']                            = 'Perguntas obrigatórias';
$translationStrings['L_VIEW_PERIODICIDADE']                                     = 'Periodicidade';
$translationStrings['L_VIEW_PERIODICIDADE_DIARIA']                              = 'Diária';
$translationStrings['L_VIEW_PERIODICIDADE_MENSAL']                              = 'Mensal';
$translationStrings['L_VIEW_PERIODICIDADE_SEMANAL']                             = 'Semanal';
$translationStrings['L_VIEW_PERIODO']                                           = 'Período';
$translationStrings['L_VIEW_PERIODO_ANALISE']                                   = 'Período da Análise';
$translationStrings['L_VIEW_PERIODO_CONTRATO']                                  = 'Período do Contrato';
$translationStrings['L_VIEW_PERIODO_EXECUCAO']                                  = 'Período de Execução';
$translationStrings['L_VIEW_PERMITE_PARCELA_ORCAMENTO']                         = 'Permite Parcela de Orçamento';
$translationStrings['L_VIEW_PESO']                                              = 'Peso';
$translationStrings['L_VIEW_PLANEJADO']                                         = 'Planejado';
$translationStrings['L_VIEW_PLANEJAMENTO']                                      = 'Planejamento';
$translationStrings['L_VIEW_PLANO']                                             = 'Plano';
$translationStrings['L_VIEW_PLANO_IMPLANTACAO']                                 = 'Plano de Implantação';
$translationStrings['L_VIEW_PORCENTAGEM']                                       = 'Porcentagem';
$translationStrings['L_VIEW_PORCENTAGEM_EXECUCAO']                              = 'Porcentagem de Execução';
$translationStrings['L_VIEW_PORCENTAGEM_PARCELA_ORCAMENTO']                     = 'Porcentagem da Parcela de Orçamento';
$translationStrings['L_VIEW_PORCENTAGEM_PARCELA_ORCAMENTO_PROJETO']             = '%value%% do projeto';
$translationStrings['L_VIEW_PORCENTAGEM_TOTAL_PROJETO']                         = '2% do total do projeto';
$translationStrings['L_VIEW_PORTA']                                             = 'Porta';
$translationStrings['L_VIEW_POR_BOX']                                           = 'Por Box';
$translationStrings['L_VIEW_POR_MEDICAO']                                       = 'Por Medição';
$translationStrings['L_VIEW_POR_OBJETO']                                        = 'Por Objeto';
$translationStrings['L_VIEW_POR_OCORRENCIA']                                    = 'Por Ocorrência';
$translationStrings['L_VIEW_POR_PROJETO']                                       = 'Por Projeto';
$translationStrings['L_VIEW_POR_UNIDADE']                                       = 'Por Unidade';
$translationStrings['L_VIEW_POSICIONAMENTO_ATUAL_PROJETO']                      = 'Posicionamento atual do projeto';
$translationStrings['L_VIEW_PRAZO_ATENDIMENTO']                                 = 'Prazo de Atendimento';
$translationStrings['L_VIEW_PRAZO_EXECUCAO_HORAS']                              = 'Prazo de Execução (Horas)';
$translationStrings['L_VIEW_PRE_PROJETO_EVOLUTIVO']                             = 'Pré Projeto Evolutivo';
$translationStrings['L_VIEW_PRE_PROJETO_NOVO']                                  = 'Pré Projeto Novo';
$translationStrings['L_VIEW_PRECISAO']                                          = 'Precisão';
$translationStrings['L_VIEW_PREFIXO_TELEFONE']                                  = 'Prefixo do Telefone';
$translationStrings['L_VIEW_PREPOSTO']                                          = 'Preposto';
$translationStrings['L_VIEW_PREVISAO']                                          = 'Previsão';
$translationStrings['L_VIEW_PREVISAO_EXECUCAO']                                 = 'Previsão de Execução';
$translationStrings['L_VIEW_PREVISAO_INICIO']                                   = 'Previsão Início';
$translationStrings['L_VIEW_PREVISAO_TERMINO']                                  = 'Previsão Término';
$translationStrings['L_VIEW_PREVISTO']                                          = 'Previsto';
$translationStrings['L_VIEW_PRIORIDADE']                                        = 'Prioridade';
$translationStrings['L_VIEW_PRIORIDADE_DEMANDA']                                = 'Prioridade da Demanda';
$translationStrings['L_VIEW_PRIORIDADE_REQUISITO']                              = 'Prioridade requisito';
$translationStrings['L_VIEW_PROBLEMA']                                          = 'Problema';
$translationStrings['L_VIEW_PROBLEMA_ENCONTRADO']                               = 'Problema Encontrado';
$translationStrings['L_VIEW_PROCEDIMENTO_ANALISE']                              = 'Procedimento de Análise';
$translationStrings['L_VIEW_PROCEDIMENTO_COLETA']                               = 'Procedimento de Coleta';
$translationStrings['L_VIEW_PROCESSADA']                                        = 'Processada';
$translationStrings['L_VIEW_PRODUTO']                                           = 'Produto';
$translationStrings['L_VIEW_PRODUTOS']                                          = 'Produtos';
$translationStrings['L_VIEW_PRODUTOS_ASSOCIADOS']                               = 'Produtos Associados';
$translationStrings['L_VIEW_PROFISSIONAIS']                                     = 'Profissionais';
$translationStrings['L_VIEW_PROFISSIONAIS_ALOCADOS']                            = 'Profissionais Alocados';
$translationStrings['L_VIEW_PROFISSIONAIS_ASSOCIADOS']                          = 'Profissionais Associados';
$translationStrings['L_VIEW_PROFISSIONAIS_TREINAMENTO']                         = 'Profissionais em treinamento';
$translationStrings['L_VIEW_PROFISSIONAL']                                      = 'Profissional';
$translationStrings['L_VIEW_PROFISSIONAL_DESIGNADO']                            = 'Profissional Designado';
$translationStrings['L_VIEW_PROFISSIONAL_EXECUTAR']                             = 'Profissional a Executar';
$translationStrings['L_VIEW_PROFISSIONAL_EXECUTOR']                             = 'Profissional Executor';
$translationStrings['L_VIEW_PROFISSIONAL_EXECUTOU_FECHAMENTO']                  = 'Profissional que Executou o Fechamento';
$translationStrings['L_VIEW_PROFISSIONAL_PROJETO']                              = 'Profissional por Projeto';
$translationStrings['L_VIEW_PROJETO']                                           = 'Projeto';
$translationStrings['L_VIEW_PROJETO_EVOLUTIVO']                                 = 'Projeto Evolutivo';
$translationStrings['L_VIEW_PROJETO_EXECUCAO']                                  = 'Projeto(s) em Execução';
$translationStrings['L_VIEW_PROJETO_PROFISSIONAL']                              = 'Projeto por Profissional';
$translationStrings['L_VIEW_PROJETO_NOVO']                                      = 'Projeto Novo';
$translationStrings['L_VIEW_PROJETO_CONTINUADO']                                = 'Projeto Continuado';
$translationStrings['L_VIEW_PROJETO_CONTINUO']                                  = 'Projeto Contínuo';
$translationStrings['L_VIEW_PROJETO_DESENVOLVIDO_PERIODO_CONTRATO']             = 'Projetos Desenvolvidos no Périodo do Contrato';
$translationStrings['L_VIEW_PROJETO_PREVISTO']                                  = 'Projeto Previsto';
$translationStrings['L_VIEW_PROJETOS']                                          = 'Projetos';
$translationStrings['L_VIEW_PROJETOS_VINCULADOS_CONTRATO']                      = 'Projetos vinculados ao Contrato';
$translationStrings['L_VIEW_PROPOSTA']                                          = 'Proposta';
$translationStrings['L_VIEW_PROPOSTA_EVOLUTIVA']                                = 'Proposta Evolutiva';
$translationStrings['L_VIEW_PROPOSTA_INICIAL']                                  = 'Proposta Inicial';
$translationStrings['L_VIEW_PROPOSTA_NR']                                       = 'Proposta Nr';
$translationStrings['L_VIEW_PROPOSTA_SEM_AGENDA_PLANO_IMPLANTACAO']             = 'Proposta Nr %value1% do Projeto %value2% não possui Agenda de Plano de Implantação';
$translationStrings['L_VIEW_PROPOSTAS_EM_EXECUCAO']                             = 'Propostas em Execução';
$translationStrings['L_VIEW_PROPOSTAS_SUSPENSAS']                               = 'Propostas Suspensas';
$translationStrings['L_VIEW_PROXIMA']                                           = 'Próxima';
$translationStrings['L_VIEW_PROXIMO']                                           = 'Próximo';
$translationStrings['L_VIEW_PROXIMO_MES']                                       = 'Próximo mês';
$translationStrings['L_VIEW_PUBLICO_ALVO']                                      = 'Público Alvo';
$translationStrings['L_VIEW_PUBLICO_SER_ALCANCADO']                             = 'Público a ser alcançado';


$translationStrings['L_VIEW_QUALIDADE']                                         = 'Qualidade';
$translationStrings['L_VIEW_QUEM_FAZ']                                          = 'Quem Faz';
$translationStrings['L_VIEW_QUESTAO']                                           = 'Questão';
$translationStrings['L_VIEW_QUESTAO_ANALISE_RISCO']                             = 'Questão de Análise de Risco';
$translationStrings['L_VIEW_QUESTAO_RISCO']                                     = 'Questão de Risco';
$translationStrings['L_VIEW_QUESTAO_RISCO_ITEM']                                = 'Questão do Risco de Item';
$translationStrings['L_VIEW_QUESTIONARIO']                                      = 'Questionário';
$translationStrings['L_VIEW_QUESTIONARIO_NAO_RESPONDIDO']                       = 'Questionário não respondido';
$translationStrings['L_VIEW_QTD']                                               = 'Quantidade';
$translationStrings['L_VIEW_QTD_HORAS']                                         = 'Quantidade de horas';
$translationStrings['L_VIEW_QTD_OCORRENCIA']                                    = 'Qtd. Ocorrência';
$translationStrings['L_VIEW_QTD_PARCELA']                                       = 'Quantidade de Parcela';
$translationStrings['L_VIEW_QTD_PROJETO']                                       = 'Quantidade de Projeto';
$translationStrings['L_VIEW_QTD_VARIAVEL']                                      = 'Quantidade de %value%';

$translationStrings['L_VIEW_RAMAL']                                             = 'Ramal';
$translationStrings['L_VIEW_RECURSO']                                           = 'Recurso';
$translationStrings['L_VIEW_RECUSAR']                                           = 'Recusar';
$translationStrings['L_VIEW_REJEITAR']                                          = 'Rejeitar';
$translationStrings['L_VIEW_REGISTRO']                                          = 'Registro';
$translationStrings['L_VIEW_REGISTRO_ATIVIDADE']                                = 'Registro de Atividade';
$translationStrings['L_VIEW_REGISTRO_HISTORICO_DEMANDA']                        = 'Registro de Histórico da Demanda';
$translationStrings['L_VIEW_REGRA']                                             = 'Regra';
$translationStrings['L_VIEW_REGRA_DE_NEGOCIO']                                  = 'Regra de Negócio';
$translationStrings['L_VIEW_REGRAS_DE_NEGOCIO']                                 = 'Regras de Negócio';
$translationStrings['L_VIEW_REGRAS_DE_NEGOCIO_ASSOCIADAS']                      = 'Regras de Negócio Associadas';
$translationStrings['L_VIEW_REGULAR']                                           = 'Regular';
$translationStrings['L_VIEW_RELACAO_CONTRATUAL']                                = 'Relação Contratual';
$translationStrings['L_VIEW_RELATO_TESTE']                                      = 'Relato de Teste';
$translationStrings['L_VIEW_RELATORIO']                                         = 'Relatório';
$translationStrings['L_VIEW_RELATORIO_SOLICITACOES']                            = 'Relatório de Solicitações';
$translationStrings['L_VIEW_REQUISITO']                                         = 'Requisito';
$translationStrings['L_VIEW_REQUISITO_PAI_FECHADO']                             = 'Requisito Pai fechado';
$translationStrings['L_VIEW_REQUISITO_PAI_NAO_FECHADO']                         = 'Requisito Pai não fechado';
$translationStrings['L_VIEW_REQUISITOS']                                        = 'Requisitos';
$translationStrings['L_VIEW_REQUISITOS_ASSOCIADOS']                             = 'Requisitos associados';
$translationStrings['L_VIEW_REQUISITOS_NAO_ASSOCIADOS']                         = 'Requisitos não associados';
$translationStrings['L_VIEW_RESERVAR_PROXIMO_CONTRATO']                         = 'Reservar Para Próximo Contrato';
$translationStrings['L_VIEW_RESPONSAVEL_ACAO']                                  = 'Responsável pela ação';
$translationStrings['L_VIEW_RESPOSTA']                                          = 'Resposta';
$translationStrings['L_VIEW_RESPOSTAS']                                         = 'Respostas';
$translationStrings['L_VIEW_RESTRITO']                                          = 'Restrito';
$translationStrings['L_VIEW_RESULTADO']                                         = 'Resultado';
$translationStrings['L_VIEW_RESULTADO_DECISAO_ANALISE']                         = 'Resultado da Decisão da Análise';
$translationStrings['L_VIEW_RESULTADO_ANALISE']                                 = 'Resultado da Análise';
$translationStrings['L_VIEW_RESUMIDA']                                          = 'Resumida';
$translationStrings['L_VIEW_RESUMIDO']                                          = 'Resumido';
$translationStrings['L_VIEW_RESUMO_PROPOSTA']                                   = 'Resumo da Proposta';
$translationStrings['L_VIEW_RESUMO_SOLICITACAO']                                = 'Resumo da Solicitação';
$translationStrings['L_VIEW_REUNIAO']                                           = 'Reunião';
$translationStrings['L_VIEW_REUNIAO_GERAL']                                     = 'Reunião Geral';
$translationStrings['L_VIEW_RISCO']                                             = 'Risco';
$translationStrings['L_VIEW_ROTINA']                                            = 'Rotina';
$translationStrings['L_VIEW_ROTINA_ASSOCIADA']                                  = 'Rotina Associada';
$translationStrings['L_VIEW_RUIM']                                              = 'Ruim';

$translationStrings['L_VIEW_SAIR']                                              = 'Sair';
$translationStrings['L_VIEW_SALA']                                              = 'Sala';
$translationStrings['L_VIEW_SALDO_ALOCAR']                                      = 'Saldo a Alocar';
$translationStrings['L_VIEW_SALDO_CONTRATO']                                    = 'Saldo do Contrato'; 
$translationStrings['L_VIEW_SALDO_DISPONIVEL']                                  = 'Saldo disponível';
$translationStrings['L_VIEW_SATISFEITO']                                        = 'Satisfeito';
$translationStrings['L_VIEW_SCHEMA']                                            = 'Schema';
$translationStrings['L_VIEW_SELECIONE_CONTRATO']                                = 'Selecione um Contrato';
$translationStrings['L_VIEW_SELECT']                                            = 'Select';
$translationStrings['L_VIEW_SEM_BASELINE']                                      = 'Sem Baseline';
$translationStrings['L_VIEW_SEM_BASELINE_ATIVA']                                = 'Nenhuma Baseline Ativa';
$translationStrings['L_VIEW_SEM_BASELINE_INATIVA']                              = 'Nenhuma Baseline Inativa';
$translationStrings['L_VIEW_SEM_CONFIG_BD']                                     = 'Sem Config. de BD';
$translationStrings['L_VIEW_SEM_DADOS_ITEM_INVENTARIADO']                       = 'Nenhum Dados de Item de Inventário Cadastrado';
$translationStrings['L_VIEW_SEM_ITEM_CADASTRDO']                                = 'Nenhum Item Cadastrado';
$translationStrings['L_VIEW_SEM_GRUPO_FATOR_ITEM_CADASTRDO']                    = 'Nenhum Grupo Fator ou Item cadastrado';
$translationStrings['L_VIEW_SEM_PARCELA']                                       = 'Não possui parcela';
$translationStrings['L_VIEW_SEM_PRODUTO_CADASTRADO']                            = 'Sem produto cadastrado';
$translationStrings['L_VIEW_SEM_PRODUTO_PARCELA']                               = 'Não possui produto para parcela';
$translationStrings['L_VIEW_SEM_PROFISSIONAL_ALOCADO_PROJETO']                  = 'Nenhum profissional alocado neste projeto';
$translationStrings['L_VIEW_SEM_REGISTRO']                                      = 'Sem registro';
$translationStrings['L_VIEW_SEM_REGISTRO_PARA_VARIAVEL']                        = 'Sem registro para %value%';
$translationStrings['L_VIEW_SEM_TEMPO_LIMITE_LEITURA']                          = 'Sem tempo limite p/ leitura';
$translationStrings['L_VIEW_SENHA']                                             = 'Senha';
$translationStrings['L_VIEW_SENHA_ACESSO']                                      = 'Senha de Acesso';
$translationStrings['L_VIEW_SENHA_ATUAL']                                       = 'Senha Atual';
$translationStrings['L_VIEW_SENHA_USUARIO']                                     = 'Senha do usuário';
$translationStrings['L_VIEW_SERVIDOR']                                          = 'Servidor';
$translationStrings['L_VIEW_SETOR']                                             = 'Setor';
$translationStrings['L_VIEW_SIGLA']                                             = 'Sigla';
$translationStrings['L_VIEW_SIGLA_METRICA_VARIAVEL_EXECUTAR_MES']               = '%value% à Executar no Mês';
$translationStrings['L_VIEW_SIGLA_METRICA_VARIAVEL_PREVISTA_MES']               = '%value% Previstas no Mês';
$translationStrings['L_VIEW_SIGLA_METRICA_VARIAVEL_RESTANTE_CONTRATO']          = '%value% Restante do Contrato';
$translationStrings['L_VIEW_SIGLA_PROJETO']                                     = 'Sigla Projeto';
$translationStrings['L_VIEW_SIGLA_UNIDADE']                                     = 'Sigla da Unidade';
$translationStrings['L_VIEW_SIGLA_UNIDADE_MEDIDA']                              = 'Sigla da Unidade de Medida';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_A_ALOCAR']                       = '%value% a ser Alocado';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_A_ALOCAR_PERIODO_CONTRATO']      = '%value% a serem Alocadas dentro do Período do Contrato';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_ALOCADA_MODULO_PROPOSTA']        = '%value% já Alocadas para Módulo Proposta';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_ALOCADA_PERIODO_CONTRATO']       = '%value% já Alocadas dentro do Período do Contrato';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_ALOCADA_PROPOSTA']               = '%value% já Alocadas para a Proposta';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_DIFERENCA_A_ALOCADAR_MODULO_PROPOSTA']  = 'Diferença %value% a Serem Alocadas Módulo Proposta X Recurso Alocado';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_DIFERENCA_A_ALOCADAR_PERIODO_CONTRATO'] = 'Diferença %value% a Serem Alocadas dentro do Período do Contrato X Recurso Alocado';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_EXECUTADO_PERIODO_CONTRATO']     = '%value% Executados Dentro do Período do Contrato';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_MODULO_PROPOSTA']                = '%value% de Módulo Proposta';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_PROJETO']                        = '%value% do Projeto';
$translationStrings['L_VIEW_SIGLA_UNID_METRICA_PROPOSTA']                       = '%value% de Proposta';
$translationStrings['L_VIEW_SIM']                                               = 'Sim';
$translationStrings['L_VIEW_SIMPLIFICADO']                                      = 'Simplificado';
$translationStrings['L_VIEW_SISTEMA']                                           = 'Sistema';
$translationStrings['L_VIEW_SISTEMAS']                                          = 'Sistemas';
$translationStrings['L_VIEW_SITUACAO']                                          = 'Situação';
$translationStrings['L_VIEW_SITUACAO_MES_ANO']                                  = 'Situação Mês/Ano';
$translationStrings['L_VIEW_SITUACAO_PROJETO']                                  = 'Situação do Projeto';
$translationStrings['L_VIEW_SOL_SERVICO_DEMANDA']                               = 'Sol. de Serviço/Demanda';
$translationStrings['L_VIEW_SOLICITACAO']                                       = 'Solicitação';
$translationStrings['L_VIEW_SOLICITACAO_EXECUCAO']                              = 'Solicitação de Execução';
$translationStrings['L_VIEW_SOLICITACAO_PROPOSTA']                              = 'Solicitação de Proposta';
$translationStrings['L_VIEW_SOLICITACAO_SERVICO']                               = 'Solicitação de Serviço';
$translationStrings['L_VIEW_SOLICITACAO_SERVICE_DESK']                          = 'Socicitação Service Desk';
$translationStrings['L_VIEW_SOLICITACAO_SERVICO_TIPO_DEMANDA']                  = $translationStrings['L_TIT_SOLICITACAO_SERVICO_TIPO_DEMANDA'];
$translationStrings['L_VIEW_SOLICITACOES_EM_EXECUCAO']                          = 'Solicitação em Execução';
$translationStrings['L_VIEW_SOLICITACOES_CONCLUIDAS']                           = 'Solicitações concluídas';
$translationStrings['L_VIEW_SOLICITACOES_PARA_LEITURA']                         = 'Solicitações para Leitura';
$translationStrings['L_VIEW_SOLICITANTE']                                       = 'Solicitante';
$translationStrings['L_VIEW_SOLUCAO']                                           = 'Solução';
$translationStrings['L_VIEW_SOLUCAO_PROBLEMA']                                  = 'Solução do Problema';
$translationStrings['L_VIEW_STATUS']                                            = 'Status';
$translationStrings['L_VIEW_STATUS_ACAO']                                       = 'Status da Ação';
$translationStrings['L_VIEW_STATUS_ATENDIMENTO']                                = 'Status de Atendimento';
$translationStrings['L_VIEW_STATUS_BASELINE']                                   = 'Status atual da Baseline';
$translationStrings['L_VIEW_STATUS_PROJETO']                                    = 'Status do Projeto';
$translationStrings['L_VIEW_STATUS_REQUISITO']                                  = 'Status requisito';
$translationStrings['L_VIEW_SUB_ITEM']                                          = 'Sub Item';
$translationStrings['L_VIEW_SUB_ITEM_METRICA']                                  = 'Sub Item Métrica';
$translationStrings['L_VIEW_SUBITEM_INVENTARIO']                                = 'SubItem de Inventário';
$translationStrings['L_VIEW_SUBITEM_INV_DESCRI']                                = 'Descrição do SubItem de Inventário';
$translationStrings['L_VIEW_SUBMETIDO']                                         = 'Submetido';

$translationStrings['L_VIEW_TABELA']                                            = 'Tabela';
$translationStrings['L_VIEW_TABELAS']                                           = 'Tabelas';
$translationStrings['L_VIEW_TAMANHO']                                           = 'Tamanho';
$translationStrings['L_VIEW_TAMANHO_FONTE']                                     = 'Tamanho da fonte';
$translationStrings['L_VIEW_TECNICO']                                           = 'Técnico';
$translationStrings['L_VIEW_TECNICO_ATENDIMENTO']                               = 'Técnico(s) de Atendimento';
$translationStrings['L_VIEW_TELEFONE']                                          = 'Telefone';
$translationStrings['L_VIEW_TELEFONE_CELULAR']                                  = 'Telefone Celular';
$translationStrings['L_VIEW_TELEFONE_CO_GESTOR']                                = 'Telefone do Co-Gestor';
$translationStrings['L_VIEW_TELEFONE_GESTOR']                                   = 'Telefone do Gestor';
$translationStrings['L_VIEW_TELEFONE_PRINCIPAL']                                = 'Telefone Principal';
$translationStrings['L_VIEW_TELEFONE_RESIDENCIAL']                              = 'Telefone Residencial';
$translationStrings['L_VIEW_TEMPO_LEITURA_SOLICITACAO_SERVICO']                 = 'Tempo para Leitura de Solicitação de Serviço (minutos)';
$translationStrings['L_VIEW_TEMPO_RESPOSTA']                                    = 'Tempo de Resposta';
$translationStrings['L_VIEW_TERMINO_PREVISTO']                                  = 'Término Previsto';
$translationStrings['L_VIEW_TERMOS_LICENCA']                                    = 'Termos da Licença';
$translationStrings['L_VIEW_TEXTO']                                             = 'Texto';
$translationStrings['L_VIEW_TEXTO_APOIO']                                       = 'Texto de Apoio';
$translationStrings['L_VIEW_TIPO']                                              = 'Tipo';
$translationStrings['L_VIEW_TIPO_ARQUIVO']                                      = 'Tipo do Arquivo';
$translationStrings['L_VIEW_TIPO_AVALIACAO']                                    = 'Tipo de Avaliação';
$translationStrings['L_VIEW_TIPO_BOX']                                          = 'Tipo do Box';
$translationStrings['L_VIEW_TIPO_CASO_DE_USO']                                  = 'Tipo do Caso de Uso';
$translationStrings['L_VIEW_TIPO_CONHECIMENTO']                                 = 'Tipo do Conhecimento';
$translationStrings['L_VIEW_TIPO_CONHECIMENTO_UTILIZADO']                       = 'Tipo de conhecimento utilizado';
$translationStrings['L_VIEW_TIPO_DADO']                                         = 'Tipo de Dado';
$translationStrings['L_VIEW_TIPO_DADO_TECNICO']                                 = 'Tipo de Dado Técnico';
$translationStrings['L_VIEW_TIPO_DOCUMENTACAO']                                 = 'Tipo de Documentação';
$translationStrings['L_VIEW_TIPO_DOCUMENTO']                                    = 'Tipo do Documento';
$translationStrings['L_VIEW_TIPO_INVENTARIO']                                   = 'Tipo de Inventário';
$translationStrings['L_VIEW_TIPO_ITEM_INVENTARIO']                              = 'Item de Inventário';
$translationStrings['L_VIEW_TIPO_ITEM_PARECER']                                 = 'Tipo Item de Parecer';
$translationStrings['L_VIEW_TIPO_MENU']                                         = 'Tipo de Menu';
$translationStrings['L_VIEW_TIPO_PROCESSO']                                     = 'Tipo de Processo';
$translationStrings['L_VIEW_TIPO_PRODUTO']                                      = 'Tipo do Produto';
$translationStrings['L_VIEW_TIPO_PROJETO']                                      = 'Tipo do Projeto';
$translationStrings['L_VIEW_TIPO_PROPOSTA']                                     = 'Tipo de Proposta';
$translationStrings['L_VIEW_TIPO_RELATORIO']                                    = 'Tipo de Relatório';
$translationStrings['L_VIEW_TIPO_SOLICITACAO']                                  = 'Tipo da Solicitação';
$translationStrings['L_VIEW_TIPO_TESTE']                                        = 'Tipo de Teste';
$translationStrings['L_VIEW_TITULO_BOX']                                        = 'Titulo do Box';
$translationStrings['L_VIEW_TODAS']                                             = 'Todas';
$translationStrings['L_VIEW_TODAS_PROPOSTAS']                                   = 'Todas as Propostas';
$translationStrings['L_VIEW_TODOS']                                             = 'Todos';
$translationStrings['L_VIEW_TODOS_PROJETOS']                                    = 'Todos os Projetos';
$translationStrings['L_VIEW_TOTAIS']                                            = 'Totais';
$translationStrings['L_VIEW_TOTAL']                                             = 'Total';
$translationStrings['L_VIEW_TOTAL_ALOCADO']                                     = 'Total Alocado';
$translationStrings['L_VIEW_TOTAL_GERAL']                                       = 'Total Geral';
$translationStrings['L_VIEW_TOTAL_PENALIDADE']                                  = 'Total Penalidade';
$translationStrings['L_VIEW_TOTAL_SIGLA_METRICA_VARIAVEL_CONTRATO']             = 'Total de %value% do contrato';
$translationStrings['L_VIEW_TOTAL_SIGLA_METRICA_VARIAVEL_PROJETO']              = 'Total de %value% desse Projeto';
$translationStrings['L_VIEW_TOTAL_UNIDADE_METRICA']                             = 'Total Unidades de Métrica';
$translationStrings['L_VIEW_TOTAL_UNIDADE_METRICA_MES']                         = 'Total de Unidades de Métrica no mês';
$translationStrings['L_VIEW_TOTAL_UNIDADE_METRICA_PREVISTA']                    = 'Total Unidades de Métrica Prevista';
$translationStrings['L_VIEW_TOTAL_UNIDADE_REGISTRADA']                          = 'Total de Unidades registradas';
$translationStrings['L_VIEW_TOTAL_VARIAVEL']                                    = 'Total de %value%';
$translationStrings['L_VIEW_TREINAMENTO']                                       = 'Treinamento';
$translationStrings['L_VIEW_TROCA_VISUALIZACAO']                                = 'Troca Visualização de Box';

$translationStrings['L_VIEW_ULTIMO_ACESSO']                                     = 'Seu último acesso foi %value1% às %value2%';
$translationStrings['L_VIEW_ULTIMO_POSICIONAMENTO_INSERIDO']                    = 'Último posicionamento inserido';
$translationStrings['L_VIEW_UNIDADE']                                           = 'Unidade';
$translationStrings['L_VIEW_UNIDADE_GESTORA']                                   = 'Unidade Gestora';
$translationStrings['L_VIEW_UNIDADE_MEDIDA']                                    = 'Unidade de Medida';
$translationStrings['L_VIEW_UNIDADE_SOLICITANTE']                               = 'Unidade Solicitante';
$translationStrings['L_VIEW_UNIDADES']                                          = 'Unidades';
$translationStrings['L_VIEW_UNIDADES_METRICA']                                  = 'Unidades de Métrica';
$translationStrings['L_VIEW_UNIDADES_VARIAVEL']                                 = 'Unidades de %value%';
$translationStrings['L_VIEW_UNID_METRICA']                                      = 'Unid. de Métrica';
$translationStrings['L_VIEW_UNID_METRICA_ALOCADA']                              = 'Unidades de Métrica Alocadas';
$translationStrings['L_VIEW_UNID_METRICA_ESTIMADA']                             = 'Unidades de Métrica Estimadas';
$translationStrings['L_VIEW_UNID_METRICA_PREVISTA']                             = 'Unidades de Métrica Previstas';
$translationStrings['L_VIEW_UNID_METRICA_PROJETO']                              = 'Unidades de Métrica do Projeto';
$translationStrings['L_VIEW_UNID_METRICA_REALIZACAO_PRODUTO_PARCELA']           = 'Unidades de métrica para a realização dos produtos da Parcela: %value1% %value2%';
$translationStrings['L_VIEW_UNID_METRICA_SERVICOS_REALIZACAO_PRODUTO_PARCELA']  = 'Unidades de métrica de serviços para a realização dos produtos da Parcela';
$translationStrings['L_VIEW_USADO_PARCER_TECNICO_PARCELA']                      = 'Usado no Parecer Técnico de Parcela';
$translationStrings['L_VIEW_USADO_PARCER_TECNICO_PROPOSTA']                     = 'Usado no Parecer Técnico de Proposta';
$translationStrings['L_VIEW_USAR_SSL']                                          = 'Usar SSL';
$translationStrings['L_VIEW_USUARIO']                                           = 'Usuário';
$translationStrings['L_VIEW_USUARIO_ACESSO']                                    = 'Usuário de acesso';
$translationStrings['L_VIEW_USUARIO_SOLICITANTE']                               = 'Usuário Solicitante';
$translationStrings['L_VIEW_UTIL']                                              = 'Útil';
$translationStrings['L_VIEW_UTILIZADO_PROPOSTA']                                = 'Utilizados nesta proposta';

$translationStrings['L_VIEW_VALIDAR']                                           = 'Validar';
$translationStrings['L_VIEW_VALOR']                                             = 'Valor';
$translationStrings['L_VIEW_VALOR_A_ALOCAR']                                    = 'Valor a Ser Alocado';
$translationStrings['L_VIEW_VALOR_CONTRATO']                                    = 'Valor do Contrato';
$translationStrings['L_VIEW_VALOR_CONTRATO_MENSAL']                             = 'Valor do Contrato (Mensal)';
$translationStrings['L_VIEW_VALOR_PAGO']                                        = 'Valor Pago';
$translationStrings['L_VIEW_VALOR_PENALIDADE']                                  = 'Valor Penalidade';
$translationStrings['L_VIEW_VALOR_TOTAL']                                       = 'Valor Total';
$translationStrings['L_VIEW_VALOR_TOTAL_ITEM_METRICA']                          = 'Valor total de %value% do item da métrica';
$translationStrings['L_VIEW_VALOR_TOTAL_METRICA_VARIAVEL']                      = 'Valor total de %value% da métrica';
$translationStrings['L_VIEW_VALOR_UNIT_UNID_METRICA']                           = 'Valor Unitário Unidade de Métrica';
$translationStrings['L_VIEW_VARIAVEL']                                          = 'Variável';
$translationStrings['L_VIEW_VARIAVEL_ITEM']                                     = 'Variável Item';
$translationStrings['L_VIEW_VARIAVEL_SUB_ITEM']                                 = 'Variável Sub Item';
$translationStrings['L_VIEW_VER_ARQUIVO']                                       = 'Ver Arquivo';
$translationStrings['L_VIEW_VER_CASO_DE_USO']                                   = 'Ver Caso de Uso';
$translationStrings['L_VIEW_VER_DICIONARIO_DADOS']                              = 'Ver Dicionário de Dados';
$translationStrings['L_VIEW_VER_HISTORICO']                                     = 'Ver Histórico';
$translationStrings['L_VIEW_VER_HISTORICO_GERAL']                               = 'Ver histórico Geral';
$translationStrings['L_VIEW_VER_TODOS_CONTRATOS']                               = 'Ver Todos os Contratos?';
$translationStrings['L_VIEW_VERIFICACAO_PERMISSOES']                            = 'Verificação das Permissões';
$translationStrings['L_VIEW_VERSAO']                                            = 'Versão';
$translationStrings['L_VIEW_VIGENCIA_INICIO']                                   = 'Vigência Início';
$translationStrings['L_VIEW_VIGENCIA_TERMINO']                                  = 'Vigência Término';
$translationStrings['L_VIEW_VISTO_TECNICO']                                     = 'Visto do Técnico';
$translationStrings['L_VIEW_VISTO_SOLICITANTE']                                 = 'Visto do Solicitante';
$translationStrings['L_VIEW_WIREFRAME']                                         = 'Wireframe';

/**Label's dos botões do sistema **/
$translationStrings['L_BTN_ACEITE_JUSTIFICATIVA']                               = 'Aceite Justificativa';
$translationStrings['L_BTN_ABRIR_ANEXOS']                                       = 'Abrir Anexo(s)';
$translationStrings['L_BTN_ABRIR_CASO_DE_USO']                                  = 'Abrir Caso de Uso';
$translationStrings['L_BTN_ABRIR_PROPOSTA']                                     = 'Abrir Proposta';
$translationStrings['L_BTN_ABRIR_REGRA_DE_NEGOCIO']                             = 'Abrir Regra de Negócio';
$translationStrings['L_BTN_ABRIR_REQUISITO']                                    = 'Abrir Requisito';
$translationStrings['L_BTN_ACEITAR_PRE_DEMANDA']                                = 'Aceitar Pré-Demanda';
$translationStrings['L_BTN_ACESSAR']                                            = 'Acessar';
$translationStrings['L_BTN_ADICIONAR']                                          = 'Adicionar';
$translationStrings['L_BTN_ADICIONAR_PARCELA']                                  = 'Adicionar Parcela';
$translationStrings['L_BTN_ALTERAR']                                            = 'Alterar';
$translationStrings['L_BTN_ALOCAR_RECURSO']                                     = 'Alocar Recurso';
$translationStrings['L_BTN_ALTERAR_ANALISE']                                    = 'Alterar Análise';
$translationStrings['L_BTN_ALTERAR_ENCAMINHAMENTO']                             = 'Alterar Encaminhamento';
$translationStrings['L_BTN_ALTERAR_PARCELA']                                    = 'Alterar Parcela';
$translationStrings['L_BTN_ANALISAR_JUSTIFICATIVA']                             = 'Analisar Just.';
$translationStrings['L_BTN_ANALISAR_PEDIDO']                                    = 'Analisar Pedido';
$translationStrings['L_BTN_ANEXAR_ARQUIVO']                                     = 'Anexar Arquivo';
$translationStrings['L_BTN_ANEXAR_IMAGEM']                                      = 'Anexar Imagem';
$translationStrings['L_BTN_ANTERIOR']                                           = 'Anterior';
$translationStrings['L_BTN_ATUALIZAR']                                          = 'Atualizar';
$translationStrings['L_BTN_ATUALIZAR_VERSAO_CASO_DE_USO']                       = 'Atualizar Versão dos Casos de Uso';
$translationStrings['L_BTN_ATUALIZAR_VERSAO_REGRA_DE_NEGOCIO']                  = 'Atualizar Versão das Regras de Negócio';
$translationStrings['L_BTN_ATUALIZAR_VERSAO_REQUISITO_DEPENDENTE']              = 'Atualizar Versão dos Requisitos Dependentes';
$translationStrings['L_BTN_CADASTRAR']                                          = 'Cadastrar';
$translationStrings['L_BTN_CALCULAR']                                           = 'Calcular';
$translationStrings['L_BTN_CALCULAR_AVALIACAO']                                 = 'Calcular Avaliação';
$translationStrings['L_BTN_CANCELAR']                                           = 'Cancelar';
$translationStrings['L_BTN_CONCLUIR']                                           = 'Concluir';
$translationStrings['L_BTN_CONFIRMAR']                                          = 'Confirmar';
$translationStrings['L_BTN_CONFIRMAR_DESIGNACAO']                               = 'Confirmar Designação';
$translationStrings['L_BTN_CONSULTAR']                                          = 'Consultar';
$translationStrings['L_BTN_CRIAR_PROPOSTA']                                     = 'Criar Proposta';
$translationStrings['L_BTN_DECISAO']                                            = 'Decisão';
$translationStrings['L_BTN_DESALOCAR_RECURSO']                                  = 'Desalocar Recurso';
$translationStrings['L_BTN_DESIGNAR_PROFISSIONAL']                              = 'Designar Profissional';
$translationStrings['L_BTN_EMITIR_SOLICITACAO']                                 = 'Emitir Solicitação';
$translationStrings['L_BTN_ENCAMINHAR']                                         = 'Encaminhar';
$translationStrings['L_BTN_ENCAMINHAR_COMITE']                                  = 'Encaminhar para Comitê';
$translationStrings['L_BTN_ENCAMINHAR_PRE_DEMANDA_EXECUCAO']                    = 'Encaminhar Pré-Demanda para Execução';
$translationStrings['L_BTN_ENCERRAR_PROPOSTA']                                  = 'Encerrar Proposta';
$translationStrings['L_BTN_ENVIAR']                                             = 'Enviar';
$translationStrings['L_BTN_EXCLUIR']                                            = 'Excluir';
$translationStrings['L_BTN_EXECUCAO_DECISAO']                                   = 'Execução de Decisão';
$translationStrings['L_BTN_EXECUTAR']                                           = 'Excutar';
$translationStrings['L_BTN_FECHAR']                                             = 'Fechar';
$translationStrings['L_BTN_FECHAR_SOLICITACAO']                                 = 'Fechar Solicitação';
$translationStrings['L_BTN_FECHAR_ANALISE']                                     = 'Fechar Análise';
$translationStrings['L_BTN_FECHAR_CASO_DE_USO']                                 = 'Fechar Caso de Uso';
$translationStrings['L_BTN_FECHAR_DEMANDA']                                     = 'Fechar Demanda';
$translationStrings['L_BTN_FECHAR_EXTRATO']                                     = 'Fechar Extrato';
$translationStrings['L_BTN_FECHAR_PARCELA']                                     = 'Fechar Parcela';
$translationStrings['L_BTN_FECHAR_PROPOSTA']                                    = 'Fechar Proposta';
$translationStrings['L_BTN_FECHAR_VERSAO']                                      = 'Fechar Versão';
$translationStrings['L_BTN_FINALIZAR_EXECUCAO']                                 = 'Finalizar Execução';
$translationStrings['L_BTN_GERAR']                                              = 'Gerar...';
$translationStrings['L_BTN_GERAR_GRAFICO']                                      = 'Gerar Gráfico';
$translationStrings['L_BTN_GERAR_PRE_PROJETO_EVOLUTIVO']                        = 'Gerar Pré-Projeto Evolutivo';
$translationStrings['L_BTN_GERAR_RELATORIO']                                    = 'Gerar Relatório';
$translationStrings['L_BTN_HOMOLOGADO']                                         = 'Homologado';
$translationStrings['L_BTN_HOMOLOGAR']                                          = 'Homologar';
$translationStrings['L_BTN_IMPRIMIR']                                           = 'Imprimir';
$translationStrings['L_BTN_JUSTIFICAR']                                         = 'Justificar';
$translationStrings['L_BTN_LIMPAR']                                             = 'Limpar';
$translationStrings['L_BTN_NAO']                                                = 'Não';
$translationStrings['L_BTN_NAO_HOMOLOGADO']                                     = 'Não Homologado';
$translationStrings['L_BTN_NOVA_ANALISE']                                       = 'Nova Análise';
$translationStrings['L_BTN_NOVA_ANALISE_EXECUCAO']                              = 'Nova Análise de Execução';
$translationStrings['L_BTN_NOVA_ANALISE_MEDICAO']                               = 'Nova Análise de Medição';
$translationStrings['L_BTN_NOVA_BASELINE']                                      = 'Gerar Nova Baseline';
$translationStrings['L_BTN_NOVA_DEMANDA']                                       = 'Nova Demanda';
$translationStrings['L_BTN_NOVA_MEDICAO']                                       = 'Nova Medição';
$translationStrings['L_BTN_NOVA_MENSAGEM']                                      = 'Nova Mensagem';
$translationStrings['L_BTN_NOVA_OCORRENCIA']                                    = 'Nova Ocorrência';
$translationStrings['L_BTN_NOVA_PERGUNTA']                                      = 'Nova Pergunta';
$translationStrings['L_BTN_NOVA_PRE_DEMANDA']                                   = 'Nova Pré-Demanda';
$translationStrings['L_BTN_NOVA_REGRA_NEGOCIO']                                 = 'Nova Regra de Negócio';
$translationStrings['L_BTN_NOVA_SOLICITACAO']                                   = 'Nova Solicitação';
$translationStrings['L_BTN_NOVO_CONTRATO']                                      = 'Novo Contrato';
$translationStrings['L_BTN_NOVO_INVENTARIO']                                    = 'Novo Inventário';
$translationStrings['L_BTN_NOVO_PRE_PROJETO']                                   = 'Novo Pré Projeto';
$translationStrings['L_BTN_NOVO_PROFISSIONAL']                                  = 'Novo Profissional';
$translationStrings['L_BTN_NOVO_REQUISITO']                                     = 'Novo Requisito';
$translationStrings['L_BTN_NOVO_USUARIO']                                       = 'Novo Usuário';
$translationStrings['L_BTN_OK']                                                 = 'OK';
$translationStrings['L_BTN_PEDIR_MUDANCA']                                      = 'Pedir Mudança';
$translationStrings['L_BTN_PESQUISAR']                                          = 'Pesquisar';
$translationStrings['L_BTN_PROXIMO']                                            = 'Próximo';
$translationStrings['L_BTN_REABRIR']                                            = 'Reabrir';
$translationStrings['L_BTN_REENCAMINHAR']                                       = 'Reencaminhar';
$translationStrings['L_BTN_REGISTRAR_ACEITE_PRE_DEMANDA']                       = 'Registrar Aceite de Pré-Demanda';
$translationStrings['L_BTN_REGISTRAR_EXECUCAO']                                 = 'Registrar Execução';
$translationStrings['L_BTN_REGISTRAR_LEITURA']                                  = 'Registrar Leitura';
$translationStrings['L_BTN_RELATORIO_PLANO_PROJETO']                            = 'Relatório Plano Projeto';
$translationStrings['L_BTN_RESPONDER']                                          = 'Responder';
$translationStrings['L_BTN_REGISTRAR_JUSTIFICATIVA']                            = 'Registrar Justificativa';
$translationStrings['L_BTN_RETORNAR']                                           = 'Retornar';
$translationStrings['L_BTN_SALVAR']                                             = 'Salvar';
$translationStrings['L_BTN_SANAR_PENDENCIA']                                    = 'Sanar Pendência';
$translationStrings['L_BTN_SIM']                                                = 'Sim';
$translationStrings['L_BTN_SOLUCIONADO']                                        = 'Solucionado';
$translationStrings['L_BTN_SOLUCIONAR']                                         = 'Solucionar';
$translationStrings['L_BTN_TESTAR_CONEXAO_LDAP']                                = 'Testar Conexão LDAP/AD';
$translationStrings['L_BTN_VER_ANALISE']                                        = 'Visualizar Análise';
$translationStrings['L_BTN_VER_ANALISE_JUSTIFICATIVA']                          = 'Ver Análise Just.';
$translationStrings['L_BTN_VER_EXECUCAO']                                       = 'Visualizar a Execução';
$translationStrings['L_BTN_VER_EXTRATO']                                        = 'Ver Extrato';
$translationStrings['L_BTN_VER_HISTORICO']                                      = 'Ver Histórico';
$translationStrings['L_BTN_VER_JUSTIFICATIVA']                                  = 'Ver Justificativa';
$translationStrings['L_BTN_VOLTAR']                                             = 'Voltar';

/**Label's do java script **/
$translationStrings['js']['L_VIEW_SCRIPT_ACAO']                                                          = 'Ação';
$translationStrings['js']['L_VIEW_SCRIPT_ACEITAR_TERMO_LICENCA_OBRIGATORIO']                             = 'É necessário aceitar os termos da licença';
$translationStrings['js']['L_VIEW_SCRIPT_ACOMPANHAMENTO_PROPOSTA_OBRIGATORIO']                           = 'Por favor, preencha o campo <b>Acompanhamento da Proposta</b>';
$translationStrings['js']['L_VIEW_SCRIPT_AGUARDE']                                                       = 'Aguarde...';
$translationStrings['js']['L_VIEW_SCRIPT_APAGAR_PERFIL_PROF_ASSOCIADO_PROF_CONTINUAR']                   = 'Esta operação apagará o perfil profissional associado a este profissional. Deseja prosseguir?';
$translationStrings['js']['L_VIEW_SCRIPT_ASSOCIE_OBJETO_CONTROTO']                                       = 'Por favor, associe um objeto ao contrato';
$translationStrings['js']['L_VIEW_SCRIPT_AVISO']                                                         = 'Aviso';
$translationStrings['js']['L_VIEW_SCRIPT_BASELINE_GERADA_SUCESSO']                                       = 'Baseline gerada com sucesso';
$translationStrings['js']['L_VIEW_SCRIPT_BASELINE_NECESSITA_PROJETO']                                    = 'Selecione Projeto para gerar a Baseline';
$translationStrings['js']['L_VIEW_SCRIPT_CALCULO_AVALIACAO_QUALIDADE_SALVAR_QUESTIONARIO']               = 'Para realizar o cálculo é necessário salvar o Questionario. Deseja prosseguir?';
$translationStrings['js']['L_VIEW_SCRIPT_CALCULO_METRICA_NAO_EFETUADO']                                  = 'Não foi efetuado o cálculo da métrica';
$translationStrings['js']['L_VIEW_SCRIPT_CAMPO_ANTERIOR_BRANCO_ESTE_NAO_PODE_SER_PREENCHIDO']            = 'Campo anterior em branco. Este campo não pode ser preenchido';
$translationStrings['js']['L_VIEW_SCRIPT_CAMPO_OBRIGATORIO']                                             = $translationStrings['L_VIEW_CAMPO_OBRIGATORIO'];
$translationStrings['js']['L_VIEW_SCRIPT_CAPS_LOCK_ATIVO']                                               = 'Atenção: O Caps Lock está ativado';
$translationStrings['js']['L_VIEW_SCRIPT_CIFRAO_MOEDA']                                                  = 'R$';
$translationStrings['js']['L_VIEW_SCRIPT_CNPJ_INVALIDO']                                                 = 'CNPJ   inválido';
$translationStrings['js']['L_VIEW_SCRIPT_CPF_INVALIDO']                                                  = 'CPF Inválido';
$translationStrings['js']['L_VIEW_SCRIPT_CONFIRMACAO']                                                   = 'Confirmação';
$translationStrings['js']['L_VIEW_SCRIPT_CONFIRMACAO_SENHA_INCORRETA']                                   = 'A confirmação da senha está incorreta';
$translationStrings['js']['L_VIEW_SCRIPT_CONTRATO_INATIVO_INALTERAVEL']                                  = 'O Contrato está Inativo.<br />Não pode ser alterado';
$translationStrings['js']['L_VIEW_SCRIPT_CRIAR_ANALISE_FECHAR_TODAS']                                    = 'Para criar uma nova análise, todas devem estar fechadas';
$translationStrings['js']['L_VIEW_SCRIPT_DADOS_CADASTRADOS_SUCESSO']                                     = 'Dados cadastrado com sucesso';
$translationStrings['js']['L_VIEW_SCRIPT_DADO_GRAVADO_NAO_PODE_SER_EXCLUIDO_PROSSEGUIR']                 = 'Os dados gravados não poderão ser excluídos. Deseja prosseguir?';
$translationStrings['js']['L_VIEW_SCRIPT_DECISAO_EXECUTADA']                                             = 'Decisão Executada';
$translationStrings['js']['L_VIEW_SCRIPT_DECISAO_NAO_EXECUTADA']                                         = 'Decisão não Executada';
$translationStrings['js']['L_VIEW_SCRIPT_DEFINICAO_METRICA_PADRAO_OBRIGATORIO']                          = 'A definição da <b>Métrica padrão</b> é obrigatório.';
$translationStrings['js']['L_VIEW_SCRIPT_DESCREVA_MOTIVO_ALTERACAO_PROPOSTA']                            = 'Descreva o Motivo da Alteração de Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_DESEJA_CRIAR_BASELINE']                                         = 'Deseja realmente gerar uma nova Baseline?';
$translationStrings['js']['L_VIEW_SCRIPT_DESEJA_EXCLUIR']                                                = 'Deseja realmente excluir?';
$translationStrings['js']['L_VIEW_SCRIPT_DIRETORIOS_NECESSITAM_PERMISSAO_LEITURA_GRAVACAO']              = 'Os diretórios informados devem ter permissão de leitura/gravação pelo servidor';
$translationStrings['js']['L_VIEW_SCRIPT_DT_ANO_FINAL_MAIOR_ANO_INICIAL']                                = 'Ano final maior que ano inicial';
$translationStrings['js']['L_VIEW_SCRIPT_DT_ANO_FINAL_MENOR_ANO_INICIAL']                                = 'Ano final não pode ser menor que o ano inicial';
$translationStrings['js']['L_VIEW_SCRIPT_DT_FINAL_MAIOR_DT_ATUAL']                                       = 'Data final não pode ser superior à data atual';
$translationStrings['js']['L_VIEW_SCRIPT_DT_FINAL_MENOR_DT_INICIAL']                                     = 'Data final não pode ser inferior à data inicial';
$translationStrings['js']['L_VIEW_SCRIPT_DT_FINAL_MENOR_INICIO']                                         = $translationStrings['L_VIEW_DATA_FINAL_MENOR_INICIO'];
$translationStrings['js']['L_VIEW_SCRIPT_DT_INICIAL_MAIOR_DT_ATUAL']                                     = 'Data inicial não pode ser superior à data atual';
$translationStrings['js']['L_VIEW_SCRIPT_DT_MES_FINAL_MENOR_MES_INICIAL']                                = 'Mês final não pode ser menor que o mês inicial';
$translationStrings['js']['L_VIEW_SCRIPT_CRIACAO_DEMANDA_OBRIGATORIO_PARA_DESIGNACAO_PROFISSIONAL']      = 'É necessário salvar a demanda antes de designar os profissionais para sua execução';
$translationStrings['js']['L_VIEW_SCRIPT_ERRO']                                                          = 'Erro';
$translationStrings['js']['L_VIEW_SCRIPT_ERRO_ARQUIVO_NAO_ENCONTRATO']                                   = 'Erro: Arquivo não encontrado';
$translationStrings['js']['L_VIEW_SCRIPT_ERRO_CADASTRO_DADOS']                                           = 'Erro ao cadastrar os dados';
$translationStrings['js']['L_VIEW_SCRIPT_ERRO_ABRIR_PRE_PROJETO_EVOLUTIVO']                              = 'Erro ao abrir o Pré-Projeto Evolutivo';
$translationStrings['js']['L_VIEW_SCRIPT_ERRO_ABRIR_PROPOSTA']                                           = 'Erro ao abrir Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_ESCOLHA_OPCAO']                                                 = 'Escolha uma opção';
$translationStrings['js']['L_VIEW_SCRIPT_EXEMPLO']                                                       = 'Exemplo';
$translationStrings['js']['L_VIEW_SCRIPT_FECHAR_ANALISE_EXECUCAO']                                       = 'Deseja realmente fechar Análise de Execução?';
$translationStrings['js']['L_VIEW_SCRIPT_FECHAR_ITEM_RISCO']                                             = 'Deseja realmente fechar este item de risco?';
$translationStrings['js']['L_VIEW_SCRIPT_FECHAR_NIVEL_SERVICO']                                          = 'Deseja realmente finalizar nível de serviço?';
$translationStrings['js']['L_VIEW_SCRIPT_FECHAR_ROTINA']                                                 = 'Deseja realmente finalizar rotina?';
$translationStrings['js']['L_VIEW_SCRIPT_HORA_INVALIDA']                                                 = 'Hora inválida';
$translationStrings['js']['L_VIEW_SCRIPT_INDIQUE_MOTIVO_ACEITE_NEGATIVO']                                = 'Indique o Motivo do Aceite Negativo';
$translationStrings['js']['L_VIEW_SCRIPT_INDIQUE_MOTIVO_HOMOLOGACAO_NEGATIVO']                           = 'Indique o Motivo da Homologação Negativa';
$translationStrings['js']['L_VIEW_SCRIPT_INDIQUE_OBJETIVO_PRE_PROJETO_EVOLUTIVO']                        = 'Indique o Objetivo do Pré-Projeto Evolutivo';
$translationStrings['js']['L_VIEW_SCRIPT_INDIQUE_PERIODO_PESQUISA']                                      = 'Indique o período de datas para a pesquisa';
$translationStrings['js']['L_VIEW_SCRIPT_INFO_ABRIR_PRE_PROJETO_EVOLUTIVO_GERACAO_PROPOSTA']             = '<b>Atenção:</b> Ao abrir o Pré-Projeto Evolutivo, a geração de Proposta ficará impossibilitada.<br>Deseja realmente abrir Pré-Projeto Evolutivo?';
$translationStrings['js']['L_VIEW_SCRIPT_INFO_ABRIR_PROPOSTA_GERACAO_PRE_PROJETO']                       = '<b>Atenção:</b> Ao abrir a proposta, a geração de Pré-Projeto Evolutivo ficará impossibilitada.<br>Deseja realmente abrir proposta?';
$translationStrings['js']['L_VIEW_SCRIPT_INFO_IMPRESSAO_CORES_DEFAULT']                                  = '* Caso não consiga imprimir as cores, verifique as configurações de seu browser para impressão de cores e imagens de fundo.';
$translationStrings['js']['L_VIEW_SCRIPT_INFO_IMPRESSAO_CORES_IMG_PLANO_FUNDO_BROWSER']                  = '* Para impressão das cores, verifique se a opção <b>Imprimir cores e imagens do plano de fundo</b> do seu browser está habilitada.';
$translationStrings['js']['L_VIEW_SCRIPT_INFO_IMPRESSAO_CORES_MOZILLA']                                  = '<br /> &nbsp;&nbsp;&nbsp;&nbsp;Menu: Arquivo->Configurar Página.';
$translationStrings['js']['L_VIEW_SCRIPT_INFO_IMPRESSAO_CORES_MSIE']                                     = '<br /> &nbsp;&nbsp;&nbsp;&nbsp;Menu: Ferramentas->Opções da Internet->Avançadas->Impressão.';
$translationStrings['js']['L_VIEW_SCRIPT_INFO_IMPRESSAO_CORES_OPERA']                                    = '* Para impressão das cores, verifique se a opção <b>Imagem de fundo</b> do seu browser está habilitada.<br/> &nbsp;&nbsp;&nbsp;&nbsp;Menu: Arquivo->Opções de Impressão.';
$translationStrings['js']['L_VIEW_SCRIPT_INFORMACOES_GERAIS']                                            = $translationStrings['L_VIEW_INFORMACOES_GERAIS'];
$translationStrings['js']['L_VIEW_SCRIPT_INFORME_QTD_HORAS']                                             = 'Por favor, informe a quantidade de horas';
$translationStrings['js']['L_VIEW_SCRIPT_INFORME_DATA']                                                  = 'Por favor, informe uma data';
$translationStrings['js']['L_VIEW_SCRIPT_INSIRA_PRODUTO']                                                = 'Insira o Produto';
$translationStrings['js']['L_VIEW_SCRIPT_ITEM_TESTE_OBRIGATORIO_PREENCHIDO']                             = 'Todos os itens de teste que são obrigatórios já estão preenchidos';
$translationStrings['js']['L_VIEW_SCRIPT_JUSTIFICATIVA_OBRIGATORIA']                                     = 'A justificativa deve ser informada.';
$translationStrings['js']['L_VIEW_SCRIPT_NAO']                                                           = 'Não';
$translationStrings['js']['L_VIEW_SCRIPT_NENHUM_VALOR_CALCULO']                                          = 'Não foi informado nenhum valor para o cálculo';
$translationStrings['js']['L_VIEW_SCRIPT_NIVEL_SERVICO_ASSOCIADO_PROFISSIONAL_CONTINUAR']                = 'Este nível de servico está associado para outro profissional.\nDeseja continuar?';
$translationStrings['js']['L_VIEW_SCRIPT_NOME_BANCO_DADOS']                                              = $translationStrings['L_VIEW_NOME_BANCO_DADOS'];
$translationStrings['js']['L_VIEW_SCRIPT_NOME_PRE_PROJETO_OBRIGATORIO']                                  = 'O Nome do Pré-Projeto é obrigatório';
$translationStrings['js']['L_VIEW_SCRIPT_NOME_PROJETO_OBRIGATORIO']                                      = 'O Nome do Projeto é obrigatório';
$translationStrings['js']['L_VIEW_SCRIPT_NR_PENALIDADE_JA_CADASTRADO']                                   = 'Número da penalidade já cadastrado';
$translationStrings['js']['L_VIEW_SCRIPT_OBJETIVO_PRE_PROJETO_OBRIGATORIO']                              = 'O objetivo do Pré-Projeto é obrigatório';
$translationStrings['js']['L_VIEW_SCRIPT_OBSERVACAO']                                                    = 'Observação';
$translationStrings['js']['L_VIEW_SCRIPT_PERGUNTA_OBRIGATORIA_SEM_RESPOSTA']                             = 'Pergunta obrigatória sem resposta';
$translationStrings['js']['L_VIEW_SCRIPT_PERIODO_PESQUISA_LOG_MUITO_GRANDE']                             = 'Período para pesquisa de registro de log deve ser menor que 6 meses';
$translationStrings['js']['L_VIEW_SCRIPT_PREENCHA_CAMPOS_OBRIGATORIOS']                                  = 'Por favor, preencha os campos obrigatórios \n (Mês, Ano e Quantidade de Horas)';
$translationStrings['js']['L_VIEW_SCRIPT_PROFISSIONAL_JA_ASSOCIADO_NIVEL_SERVICO']                       = 'Este profissional já esta associado ao nível de serviço selecionado';
$translationStrings['js']['L_VIEW_SCRIPT_PROPOSTA_NAO_POSSUI_HORAS']                                     = 'A proposta não possui horas';
$translationStrings['js']['L_VIEW_SCRIPT_PROPOSTA_SEM_ENCERRAMENTO']                                     = 'Existem propostas sem encerramento. O Extrato Mensal do mês %0%/%1% não pode ser fechado.';
$translationStrings['js']['L_VIEW_SCRIPT_PROJETO_OBRIGATORIO']                                           = 'Projeto é obrigatório';
$translationStrings['js']['L_VIEW_SCRIPT_QTD_HORAS_SUPERIOR_QTD_DISPONIVEL']                             = 'A quantidade de horas é superior a quantidade disponível';
$translationStrings['js']['L_VIEW_SCRIPT_SAIR']                                                          = $translationStrings['L_VIEW_SAIR'];
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE']                                                     = 'Selecione';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_ACEITE']                                              = 'Selecione o Aceite';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_ANO']                                                 = 'Por favor, selecione um ano';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_ATIVIDADE_ASSOCIAR_OBJETO']                           = 'Selecione as atividades que deseja associar ao objeto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_ATIVIDADE_DESASSOCIAR_OBJETO']                        = 'Selecione as atividades que deseja desassociar do objeto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_CASO_DE_USO_ASSOCIAR']                                = 'Selecione os casos de uso que deseja associar';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_CASO_DE_USO_DESASSOCIAR']                             = 'Selecione os casos de uso que deseja excluir da associação';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_ETAPA']                                               = 'Por favor, selecione uma etapa';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_IMPACTO']                                             = 'Selecione o impacto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_MEDIDA_ASSOCIAR_MEDICAO']                             = 'Selecione as medidas que deseja associar';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_MEDIDA_DESASSOCIAR_MEDICAO']                          = 'Selecione as medidas que deseja excluir da medição';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_MODULO']                                              = 'Por favor, selecione um módulo';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_MES']                                                 = 'Por favor, selecione um mês';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_OBJETO']                                              = 'Selecione um Objeto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PAPEL_ASSOCIAR_PERFIL']                               = 'Selecione os papéis que deseja associar ao perfil';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PAPEL_ASSOCIAR_OBJETO']                               = 'Selecione os papéis que deseja associar ao objeto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PAPEL_DESASSOCIAR_PERFIL']                            = 'Selecione os papéis que deseja desassociar do perfil';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PAPEL_DESASSOCIAR_OBJETO']                            = 'Selecione os papéis que deseja desassociar do objeto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PARAMETRO_PESQUISA']                                  = 'Selecione algum parâmetro para a pesquisa';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PARAMETRO_RELATORIO']                                 = 'Por favor, selecione os parâmetros para o relatório';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PARCELA']                                             = 'Por favor, selecione uma parcela';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PERFIL_ASSOCIAR_OBJETO']                              = 'Selecione os perfis que deseja associar ao objeto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PERFIL_DESASSOCIAR_OBJETO']                           = 'Selecione os perfis que deseja desassociar do objeto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PRODUTO_ASSOCIAR_PROFISSIONAL']                       = 'Selecione o(s) produto(s) que deseja associar ao profissional';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PRODUTO_DESASSOCIAR_PROFISSIONAL']                    = 'Selecione o(s) produto(s) que deseja desassociar do profissional';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PROFISSIONAL_ASSOCIAR']                               = 'Selecione os profissionais que deseja associar';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PROFISSIONAL_DESASSOCIAR']                            = 'Selecione os profissionais que deseja desassociar';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PROJETO']                                             = 'Selecione o Projeto';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PROJETO_ASSOCIAR_CONTRATO']                           = 'Selecione os projetos que deseja associar ao contrato';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PROJETO_DESASSOCIAR_CONTRATO']                        = 'Selecione os projetos que deseja desassociar do contrato';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PROJETO_CRIAR_ANALISE']                               = 'Selecione um projeto para criar uma nova análise';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_PROPOSTA']                                            = 'Por favor, selecione uma proposta';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_REGRA_ASSOCIAR']                                      = 'Selecione as regras que deseja associar';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_REGRA_DESASSOCIAR']                                   = 'Selecione as regras que deseja excluir da associação';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_REQUISITO_ASSOCIAR']                                  = 'Selecione os requisitos que deseja associar';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_REQUISITO_DESASSOCIAR']                               = 'Selecione os requisitos que deseja excluir da associação';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_ROTINA_ASSOCIAR_OBJETO']                              = 'Selecione as rotinas que deseja associar';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_ROTINA_DESASSOCIAR_OBJETO']                           = 'Selecione as rotinas que deseja excluir da associação';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_TIPO_AVALIACAO']                                      = 'Por favor, selecione o Tipo de Avaliação';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_TIPO_HOMOLOGACAO']                                    = 'Selecione o Tipo de Homologação';
$translationStrings['js']['L_VIEW_SCRIPT_SELECIONE_TIPO_PRODUTO']                                        = 'Selecione o Tipo do Produto';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_ATIVIDADE_PARA_ETAPA']                                      = 'Não existe atividade cadastrada para esta etapa';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_CASO_DE_USO_ASSOCIADO_REQUISITO']                           = 'Não há nenhum caso de uso associado a este requisito';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_CUSTO']                                                     = 'Não há custo';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_DEPENDENCIA_PARA_ATUALIZAR']                                = 'Não há nenhuma depêndencia para ser atualizada';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_DEPENDENCIA_REQUISITO_CASO_USO_PROJETO']                    = 'Não há dependência entre os Requisitos e Casos de Uso desse Projeto';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_DEPENDENCIA_REQUISITO_PROJETO']                             = 'Não há dependência entre os requisitos desse Projeto';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_DEPENDENCIA_REQUISITO_REGRA_NEGOCIO_PROJETO']               = 'Não há dependência entre os Requisitos e Regras de Negócio desse Projeto';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_HORAS_DISPONIVEL']                                          = 'Não possui horas disponível';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_ITEM_RISCO_PARA_ATIVIDADE']                                 = 'Não existe item de risco cadastrado para esta atividade';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_PERMISSAO_ABRIR_PRE_PROJETO_EVOLUTIVO']                     = 'Você não possui permissão para abrir Pré-Projeto Evolutivo';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_PERMISSAO_ABRIR_PROPOSTA']                                  = 'Você não possui permissão para abrir proposta';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_REGISTRO_EXIBICAO']                                         = 'Sem registro para exibição';
$translationStrings['js']['L_VIEW_SCRIPT_SEM_REGRA_ASSOCIADA_REQUISITO']                                 = 'Não há nenhuma regra associada a este requisito';
$translationStrings['js']['L_VIEW_SCRIPT_SENHA_CONFIRMACAO_INCORRETA']                                   = 'Senha de confirmação esta incorreta';
$translationStrings['js']['L_VIEW_SCRIPT_SIGLA_PROJETO_OBRIGATORIO']                                     = 'A Sigla do Projeto é obrigatória';
$translationStrings['js']['L_VIEW_SCRIPT_SIM']                                                           = 'Sim';
$translationStrings['js']['L_VIEW_SCRIPT_SUCESSO']                                                       = 'Sucesso';
$translationStrings['js']['L_VIEW_SCRIPT_TIPO_PROPOSTA_OBRIGATORIO']                                     = 'O tipo de Proposta é obrigatório';
$translationStrings['js']['L_VIEW_SCRIPT_VALOR_CALCULO_METRICA_IGUAL_ZERO']                              = 'O valor do cálculo da métrica é igual a zero. Impossível prosseguir.';
$translationStrings['js']['L_VIEW_SCRIPT_VER_REUNIAO']                                                   = 'Ver Reunião';
$translationStrings['js']['L_VIEW_SCRIPT_VERICAR_NR_CONTRATO']                                           = 'Verifique o número do contrato. <br> <b>(Ex.: 00/2009 - nr/ano )</b>';
$translationStrings['js']['L_VIEW_SCRIPT_VERIFICAR_CONTRATO_ATIVO']                                      = 'Verificar se o contrato esta ativo';

//---------- MSG DOS TITULOS DE DIALOG DO JAVASCRIPT ----------//
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_ABRIR_PRE_PROJETO_EVOLUTIVO']                      = 'Abertura de Pré-Projeto Evolutivo';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_ACEITE_PARCELA']                                   = 'Aceite de Parcela';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_ACEITE_PROPOSTA']                                  = 'Aceite de Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_ALOCACAO_PROPOSTA']                                = 'Alocação de Recursos';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_ALTERACAO_PROPOSTA']                               = 'Alteração de Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_ANEXAR_IMAGEM_RELATO_TESTE']                       = 'Anexar Imagem ao Relato de Teste';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_AUTORIZAR_PARCELA']                                = 'Autorização de Parcela';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_CONCLUSAO_SOLICITACAO_SERVICO']                    = 'Conclusão de Solicitação de Serviço';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_CRIAR_PROPOSTA']                                   = 'Criação de Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_DETALHE_SOLICITACAO_SERVICO']                      = 'Detalhe da Solicitação de Serviço';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_FECHAR_PARCELA']                                   = 'Fechamento de Parcela';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_FECHAR_PROPOSTA']                                  = 'Fechamento de Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_FECHAR_SOLICITACAO_SERVICO']                       = 'Fechamento de Solicitação de Serviço';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_HOMOLOGACAO_PARCELA']                              = 'Homologação de Parcela';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_HOMOLOGACAO_PROPOSTA']                             = 'Homologação de Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_JUSTIFICATIVA_DEMANDA']                            = 'Justificativa de Demanda';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_JUSTIFICATIVA_SOLICITACAO_SERVICO']                = 'Justificativa de Solicitação de Serviço';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_LISTA_ANEXO_RELATO_TESTE']                         = 'Listagem do(s) Anexo(s) do Relato de Teste';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_MANUTENCAO_BOX']                                   = 'Manutenção de Boxes';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_MENSAGEM_NAO_LIDA']                                = 'Mensagens Não Lidas';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_NOVO_POSICIONAMENTO']                              = $translationStrings['L_VIEW_NOVO_POSICIONAMENTO'];
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_PARCER_TECNICO_PARCELA']                           = 'Parecer Técnico de Parcela';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_PARCER_TECNICO_PROPOSTA']                          = 'Parecer Técnico de Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_PARCER_REABRIR_PRE_DEMANDA']                       = 'Reabertura de Pré-Demanda';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_PRODUTO_PARCELA']                                  = 'Produtos desta parcela';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_PROFISSIONAL_PROJETO']                             = 'Profissionais deste projeto';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_REGISTRA_ACOMPACHAMENTO_PROPOSTA']                 = 'Registrar Acompanhamento da Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_TITLE_DIALOG_TROCA_CONTRATO']                                   = 'Troca de Contrato';

//---------- MSG DO JAVASCRIPT QUE CONTEM VARIAVEIS ----------//
$translationStrings['js']['L_VIEW_SCRIPT_BOX_DO_CONTRATO']                                               = 'Boxes do contrato %0%';
$translationStrings['js']['L_VIEW_SCRIPT_BOX_NR_CONTRATO']                                               = 'Boxes do contrato %0% - %1%';
$translationStrings['js']['L_VIEW_SCRIPT_CAMPO_OBRIGATORIO_VARIAVEL']                                    = 'Campo <b>%0%</b> obrigatório';
$translationStrings['js']['L_VIEW_SCRIPT_DATA_INVALIDA']                                                 = 'Data inválida: %0%';
$translationStrings['js']['L_VIEW_SCRIPT_DATA_LEITURA']                                                  = 'Data de Leitura: %0%';
$translationStrings['js']['L_VIEW_SCRIPT_DESEJA_FECHAR_EXTRATO_MENSAL']                                  = 'Deseja realmente fechar o extrato mensal do mes %0%/%1%?';
$translationStrings['js']['L_VIEW_SCRIPT_FALTA_VALOR_CONTRATADO_PARA_MES_CONTINUAR']                     = "Faltam {$translationStrings['js']['L_VIEW_SCRIPT_CIFRAO_MOEDA']} %0% para o valor contratado para o mês! Deseja prosseguir?";
$translationStrings['js']['L_VIEW_SCRIPT_FALTAM_HORAS_COMPLETAR_PROPOSTA']                               = 'Faltam %0% horas para completar proposta. Deseja prosseguir?';
$translationStrings['js']['L_VIEW_SCRIPT_HORA_ALOCADA_MAIOR_HORA_PROPOSTA']                              = 'Número de Horas Alocado (%0%) é maior que Horas da Proposta (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_HORA_ALOCADA_MENOR_HORA_PROPOSTA']                              = 'Número de Horas Alocado (%0%) é menor que Horas da Proposta (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_HORAS_ALOCADAS_MAIOR_HORAS_ALOCADAS_DENTRO_CONTRATO']           = 'Número de Horas Alocado (%0%) é maior que Horas a Serem Alocadas Dentro do Contrato (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_HORAS_ALOCADAS_MENOR_HORAS_ALOCADAS_DENTRO_CONTRATO']           = 'Número de Horas Alocado (%0%) é menor que Horas a Serem Alocadas Dentro do Contrato (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_INTERVALO_ANO_MAIOR_QUE']                                       = 'O intervalo de ano não pode ser maior que %0%';
$translationStrings['js']['L_VIEW_SCRIPT_QTD_MESES_SUPERIO_A']                                           = 'Quantidade de meses superior a %0%';
$translationStrings['js']['L_VIEW_SCRIPT_SOMA_VALOR_MAIOR_VALOR_CONTRATADO_MES']                         = 'A soma dos valores é maior que o valor contratado para o mês. (%0% > %1%)';
$translationStrings['js']['L_VIEW_SCRIPT_VALOR_ALOCADO_MAIOR_SALDO_PROJETO']                             = 'Valor Alocado (%0%) é Maior que o Saldo do Projeto (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_VALOR_ALOCADO_MODULO_PROPOSTA_DIFERENTE_HORAS_MODULO_PROPOSTA'] = 'Número de Horas Alocado para Módulo Proposta (%0%) é diferente de Horas de Módulo Proposta (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_VALOR_ALOCADO_MODULO_PROPOSTA_MAIOR_HORAS_MODULO_PROPOSTA']     = 'Número de Horas Alocado para Módulo Proposta (%0%) é maior que Horas de Módulo Proposta (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_VALOR_ALOCADO_MODULO_PROPOSTA_MAIOR_SALDO_PROJETO']             = 'Valor Alocado para Módulo Proposta (%0%) é Maior que o Saldo do Projeto (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_VALOR_ALOCADO_MODULO_PROPOSTA_MENOR_HORAS_MODULO_PROPOSTA']     = 'Número de Horas Alocado para Módulo Proposta (%0%) é menor que Horas de Módulo Proposta (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_VALOR_ALOCADO_PROPOSTA_DIFERENTE_VALOR_A_SER_ALOCADO']          = 'Unidades de Métrica Alocadas para Proposta (%0%) é diferente de Unidades de Métrica a serem alocadas para a Proposta (%1%)';
$translationStrings['js']['L_VIEW_SCRIPT_VALOR_ALOCADO_VALOR_MODULO_PROPOSTA_MAIOR_SALDO_PROJETO']       = 'Valor Alocado (%0%) + Valor do Módulo Proposta (%1%) é Maior que o Saldo do Projeto (%2%)';
//---------- MSG DO BOTOES JAVASCRIPT ----------//
$translationStrings['js']['L_VIEW_SCRIPT_BTN_ANEXAR_IMAGEM']                                             = 'Anexar Imagem';
$translationStrings['js']['L_VIEW_SCRIPT_BTN_ATUALIZAR']                                                 = $translationStrings['L_BTN_ATUALIZAR'];
$translationStrings['js']['L_VIEW_SCRIPT_BTN_CANCELAR']                                                  = $translationStrings['L_BTN_CANCELAR'];
$translationStrings['js']['L_VIEW_SCRIPT_BTN_CRIAR_PROPOSTA']                                            = 'Criar Proposta';
$translationStrings['js']['L_VIEW_SCRIPT_BTN_CONFIRMAR_LEITURA']                                         = 'Confirmar Leitura';
$translationStrings['js']['L_VIEW_SCRIPT_BTN_FECHAR']                                                    = $translationStrings['L_BTN_FECHAR'];
$translationStrings['js']['L_VIEW_SCRIPT_BTN_GRAVAR_POSICIONAMENTO']                                     = 'Gravar Posicionamento';
$translationStrings['js']['L_VIEW_SCRIPT_BTN_NAO']                                                       = $translationStrings['L_BTN_NAO'];
$translationStrings['js']['L_VIEW_SCRIPT_BTN_SALVAR']                                                    = $translationStrings['L_BTN_SALVAR'];
$translationStrings['js']['L_VIEW_SCRIPT_BTN_SIM']                                                       = $translationStrings['L_BTN_SIM'];
$translationStrings['js']['L_VIEW_SCRIPT_BTN_VOLTAR']                                                    = $translationStrings['L_BTN_VOLTAR'];
/**Label's das options das combos **/
$translationStrings['L_VIEW_ACEITE_JUSTIFICATIVA']                                                       = $translationStrings['L_BTN_ACEITE_JUSTIFICATIVA'];
$translationStrings['L_VIEW_COMBO_ABERTO']                                                               = $translationStrings['L_VIEW_ABERTO'];
$translationStrings['L_VIEW_COMBO_ABERTOS']                                                              = 'Aberto(s)';
$translationStrings['L_VIEW_COMBO_ABR']                                                                  = 'Abr'; //ABRIL
$translationStrings['L_VIEW_COMBO_ABRIL']                                                                = 'Abril';
$translationStrings['L_VIEW_COMBO_AGO']                                                                  = 'Ago'; //AGOSTO
$translationStrings['L_VIEW_COMBO_AGOSTO']                                                               = 'Agosto';
$translationStrings['L_VIEW_COMBO_ALTA']                                                                 = 'Alta';
$translationStrings['L_VIEW_COMBO_ALTISSIMA']                                                            = 'Altíssima';
$translationStrings['L_VIEW_COMBO_ALTO']                                                                 = 'Alto';
$translationStrings['L_VIEW_COMBO_AMBOS']                                                                = 'Ambos';
$translationStrings['L_VIEW_COMBO_APROVADO']                                                             = $translationStrings['L_VIEW_APROVADO'];
$translationStrings['L_VIEW_COMBO_ATIVO']                                                                = 'Ativo';
$translationStrings['L_VIEW_COMBO_ATIVOS']                                                               = 'Ativo(s)';
$translationStrings['L_VIEW_COMBO_AUTORIDADE']                                                           = $translationStrings['L_VIEW_AUTORIDADE'];
$translationStrings['L_VIEW_COMBO_BAIXA']                                                                = 'Baixa';
$translationStrings['L_VIEW_COMBO_BAIXO']                                                                = 'Baixo';
$translationStrings['L_VIEW_COMBO_CASO_USO']                                                             = 'Caso de Uso';
$translationStrings['L_VIEW_COMBO_COMITE']                                                               = $translationStrings['L_VIEW_COMITE'];
$translationStrings['L_VIEW_COMBO_COMPLETADO']                                                           = $translationStrings['L_VIEW_COMPLETADO'];
$translationStrings['L_VIEW_COMBO_CONEXAO_COM_PDO']                                                      = 'Conexão utilizando PDO';
$translationStrings['L_VIEW_COMBO_CONEXAO_SEM_PDO']                                                      = 'Conexão sem PDO';
$translationStrings['L_VIEW_COMBO_CONTRATO']                                                             = 'Contrato';
$translationStrings['L_VIEW_COMBO_CONTROLE']                                                             = 'Controle';
$translationStrings['L_VIEW_COMBO_CRONOGRAMA']                                                           = 'Cronograma';
$translationStrings['L_VIEW_COMBO_CUSTO']                                                                = 'Custo';
$translationStrings['L_VIEW_COMBO_DEMANDA']                                                              = $translationStrings['L_VIEW_DEMANDA'];
$translationStrings['L_VIEW_COMBO_DEZ']                                                                  = 'Dez'; //DEZEMBRO
$translationStrings['L_VIEW_COMBO_DEZEMBRO']                                                             = 'Dezembro';
$translationStrings['L_VIEW_COMBO_DISPONIBILIDADE_SERVICO']                                              = 'Disponibilidade de Serviço';
$translationStrings['L_VIEW_COMBO_EM_TRATAMENTO']                                                        = 'Em Tratamento';
$translationStrings['L_VIEW_COMBO_EVOLUTIVO']                                                            = 'Evolutivo';
$translationStrings['L_VIEW_COMBO_EXECUCAO_PROPOSTA']                                                    = 'Execução de Proposta';
$translationStrings['L_VIEW_COMBO_EXECUTAR_PARCELA']                                                     = 'Executar a Parcela';
$translationStrings['L_VIEW_COMBO_EXTERNO']                                                              = 'Externo';
$translationStrings['L_VIEW_COMBO_FECHADO']                                                              = $translationStrings['L_VIEW_FECHADO'];
$translationStrings['L_VIEW_COMBO_FECHADOS']                                                             = 'Fechado(s)';
$translationStrings['L_VIEW_COMBO_FEV']                                                                  = 'Fev'; //FEVEREIRO
$translationStrings['L_VIEW_COMBO_FEVEREIRO']                                                            = 'Fevereiro';
$translationStrings['L_VIEW_COMBO_INATIVO']                                                              = 'Inativo';
$translationStrings['L_VIEW_COMBO_INATIVOS']                                                             = 'Inativo(s)';
$translationStrings['L_VIEW_COMBO_INTERFACE']                                                            = 'Interface';
$translationStrings['L_VIEW_COMBO_INTERNO']                                                              = 'Interno';
$translationStrings['L_VIEW_COMBO_INTERNO_EXTERNO']                                                      = 'Interno e Externo';
$translationStrings['L_VIEW_COMBO_ITEM_TESTE']                                                           = $translationStrings['L_VIEW_TIPO_TESTE'];
$translationStrings['L_VIEW_COMBO_JAN']                                                                  = 'Jan'; //JANEIRO
$translationStrings['L_VIEW_COMBO_JANEIRO']                                                              = 'Janeiro';
$translationStrings['L_VIEW_COMBO_JUN']                                                                  = 'Jun'; //JUNHO
$translationStrings['L_VIEW_COMBO_JUNHO']                                                                = 'Junho';
$translationStrings['L_VIEW_COMBO_JUL']                                                                  = 'Jul'; //JULHO
$translationStrings['L_VIEW_COMBO_JULHO']                                                                = 'Julho';
$translationStrings['L_VIEW_COMBO_MAR']                                                                  = 'Mar'; //MARÇO
$translationStrings['L_VIEW_COMBO_MARCO']                                                                = 'Março';
$translationStrings['L_VIEW_COMBO_MAI']                                                                  = 'Mai'; //MAIO
$translationStrings['L_VIEW_COMBO_MAIO']                                                                 = 'Maio';
$translationStrings['L_VIEW_COMBO_MEDIA']                                                                = 'Média';
$translationStrings['L_VIEW_COMBO_MEDIO']                                                                = 'Médio';
$translationStrings['L_VIEW_COMBO_MES']                                                                  = 'Mês';
$translationStrings['L_VIEW_COMBO_MODERADO']                                                             = 'Moderado';
$translationStrings['L_VIEW_COMBO_MUITO_BAIXO']                                                          = 'Muito Baixo';
$translationStrings['L_VIEW_COMBO_MUITO_ALTO']                                                           = 'Muito Alto';
$translationStrings['L_VIEW_COMBO_NAO']                                                                  = 'Não';
$translationStrings['L_VIEW_COMBO_NAO_APLICA']                                                           = 'Não Aplica';
$translationStrings['L_VIEW_COMBO_NAO_ESPECIFICADO']                                                     = 'Não Especificado';
$translationStrings['L_VIEW_COMBO_NENHUM']                                                               = 'Nenhum';
$translationStrings['L_VIEW_COMBO_NENHUM_CASO_DE_USO_ABERTO']                                            = 'Nenhum Caso de Uso Aberto';
$translationStrings['L_VIEW_COMBO_NENHUM_CASO_DE_USO_FECHADO']                                           = 'Nenhum Caso de Uso Fechado';
$translationStrings['L_VIEW_COMBO_NENHUM_CONTRATO_ATIVO']                                                = 'Nenhum Contrato Ativo';
$translationStrings['L_VIEW_COMBO_NENHUM_CONTRATO_INATIVO']                                              = 'Nenhum Contrato Inativo';
$translationStrings['L_VIEW_COMBO_NIVEL_DOIS']                                                           = 'Nível 2';
$translationStrings['L_VIEW_COMBO_NIVEL_UM']                                                             = 'Nível 1';
$translationStrings['L_VIEW_COMBO_NOV']                                                                  = 'Nov'; //NOVEMBRO
$translationStrings['L_VIEW_COMBO_NOVEMBRO']                                                             = 'Novembro';
$translationStrings['L_VIEW_COMBO_NOVO']                                                                 = 'Novo';
$translationStrings['L_VIEW_COMBO_OUT']                                                                  = 'Out'; // OUTUBRO
$translationStrings['L_VIEW_COMBO_OUTUBRO']                                                              = 'Outubro';
$translationStrings['L_VIEW_COMBO_PROFISSIONAL']                                                         = $translationStrings['L_VIEW_PROFISSIONAL'];
$translationStrings['L_VIEW_COMBO_PROJETO']                                                              = $translationStrings['L_VIEW_PROJETO'];
$translationStrings['L_VIEW_COMBO_PROJETO_CONTINUO']                                                     = $translationStrings['L_VIEW_PROJETO_CONTINUO'];
$translationStrings['L_VIEW_COMBO_REQUISITO']                                                            = 'Requisito';
$translationStrings['L_VIEW_COMBO_REGRA_NEGOCIO']                                                        = 'Regra de Negócio';
$translationStrings['L_VIEW_COMBO_SELECIONE']                                                            = 'Selecione';
$translationStrings['L_VIEW_COMBO_SELECIONE_ANO']                                                        = 'Selecione um Ano';
$translationStrings['L_VIEW_COMBO_SELECIONE_CONTRATO']                                                   = 'Selecione um Contrato';
$translationStrings['L_VIEW_COMBO_SELECIONE_MES']                                                        = 'Selecione um Mês';
$translationStrings['L_VIEW_COMBO_SER_DETERMINADO']                                                      = 'A ser Determinado';
$translationStrings['L_VIEW_COMBO_SERVICE_DESK']                                                         = 'Service Desk';
$translationStrings['L_VIEW_COMBO_SERVICO']                                                              = 'Serviço';
$translationStrings['L_VIEW_COMBO_SET']                                                                  = 'Set'; //SETEMBRO
$translationStrings['L_VIEW_COMBO_SETEMBRO']                                                             = 'Setembro';
$translationStrings['L_VIEW_COMBO_SIM']                                                                  = 'Sim';
$translationStrings['L_VIEW_COMBO_SOLICITACAO_PROPOSTA']                                                 = 'Solicitação de Proposta';
$translationStrings['L_VIEW_COMBO_SUBMETIDO']                                                            = $translationStrings['L_VIEW_SUBMETIDO'];
$translationStrings['L_VIEW_COMBO_TECNICO']                                                              = 'Técnico';
$translationStrings['L_VIEW_COMBO_TODAS']                                                                = $translationStrings['L_VIEW_TODAS'];
$translationStrings['L_VIEW_COMBO_TODOS']                                                                = $translationStrings['L_VIEW_TODOS'];
$translationStrings['L_VIEW_COMBO_TIPO_SOLICITACAO']                                                     = 'Tipo de solicitação';
$translationStrings['L_VIEW_COMBO_USUARIO']                                                              = $translationStrings['L_VIEW_USUARIO'];
/**Label's dos ACCORDIONS **/
$translationStrings['L_VIEW_ACCORDION_ACRESCENTAR_PRODUTO']                     = 'Acrescentar Produtos';
$translationStrings['L_VIEW_ACCORDION_ALOCAR_PROFISSIONAL']                     = 'Alocar Profissionais';
$translationStrings['L_VIEW_ACCORDION_ANALISE_EXECUCAO']                        = 'Análise de Execução';
$translationStrings['L_VIEW_ACCORDION_ANALISE_MUDANCA']                         = 'Análise de Mudança';
$translationStrings['L_VIEW_ACCORDION_ANEXAR_DOCUMENTACAO_PROFISSIONAL']        = 'Anexar Documentação de Profissional';
$translationStrings['L_VIEW_ACCORDION_ARQUIVO_PROPOSTA']                        = 'Arquivos da Proposta';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_CONHECIMENTO_PROFISSIONAL']      = 'Associar Conhecimento ao Profissional';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_ITEM_INVENTARIO_CONTRATO']       = 'Associar Item Inventario ao Contrato';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_METRICA_CONTRATO']               = 'Associar Métrica ao Contrato';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_PERFIL_PAPEL_OBJETO_CONTRATO']   = 'Associar Perfil Profissional e Papel Profissional ao Objeto do Contrato';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_PERFIL_SISTEMA_OBJETO_CONTRATO'] = 'Associar Perfil de Sistema ao Objeto do Contrato';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_PROFISSIONAL_OBJETO_CONTRATO']   = 'Associar Profissional ao Objeto do Contrato';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_PROFISSIONAL_PERFIL_SISTEMA']    = 'Associar Profissional ao Perfil de Sistema';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_PROFISSIONAL_TREINAMENTO']       = 'Associar Profissional ao Treinamento';
$translationStrings['L_VIEW_ACCORDION_ASSOCIAR_PROJETO_CONTRATO']               = 'Associar Projeto Existente ao Contrato';
$translationStrings['L_VIEW_ACCORDION_BASELINE']                                = 'Baseline';
$translationStrings['L_VIEW_ACCORDION_CASO_DE_USO']                             = 'Caso de Uso';
$translationStrings['L_VIEW_ACCORDION_CONTRATO']                                = $translationStrings['L_VIEW_CONTRATO'];
$translationStrings['L_VIEW_ACCORDION_CRIAR_PARCELA']                           = 'Criar parcelas';
$translationStrings['L_VIEW_ACCORDION_CRONOGRAMA_AUDITORIA_QUALIDADE']          = 'Cronograma de Auditoria de Qualidade';
$translationStrings['L_VIEW_ACCORDION_CUSTO_CONTRATO_TIPO_DEMANDA']             = 'Custo de Contratos do Tipo Demanda';
$translationStrings['L_VIEW_ACCORDION_DADOS_TECNICOS']                          = 'Dados Técnicos';
$translationStrings['L_VIEW_ACCORDION_DEFINIR_BOX']                             = 'Definir Box';
$translationStrings['L_VIEW_ACCORDION_DEFINIR_METRICA']                         = 'Definir Métrica';
$translationStrings['L_VIEW_ACCORDION_DEFINIR_PROCESSO']                        = 'Definir Processos';
$translationStrings['L_VIEW_ACCORDION_DESCRICAO_PROJETO']                       = 'Descrição de Projeto';
$translationStrings['L_VIEW_ACCORDION_DICIONARIO_DADOS']                        = 'Dicionário de dados';
$translationStrings['L_VIEW_ACCORDION_DISPONIBILIDADE_SERVICO']                 = 'Disponibilidade de Serviço';
$translationStrings['L_VIEW_ACCORDION_DOCUMENTACAO_ACOMPANHAMENTO']             = 'Documentação de Acompanhamento';
$translationStrings['L_VIEW_ACCORDION_DOCUMENTACAO_PROJETO']                    = 'Documentação do Projeto';
$translationStrings['L_VIEW_ACCORDION_DOCUMENTACAO_CONTRATO']                   = 'Documentação do Contrato';
$translationStrings['L_VIEW_ACCORDION_EMPRESA']                                 = $translationStrings['L_VIEW_EMPRESA'];
$translationStrings['L_VIEW_ACCORDION_ETAPA_ATIVIDADE']                         = 'Etapas e Atividades';
$translationStrings['L_VIEW_ACCORDION_EXECUTA_SELECT']                         = 'Executa Select';
$translationStrings['L_VIEW_ACCORDION_FALE_CONOSCO']                            = 'Fale Conosco';
$translationStrings['L_VIEW_ACCORDION_FUNCIONALIDADE']                          = 'Funcionalidade';
$translationStrings['L_VIEW_ACCORDION_GERENCIAR_MODULO']                        = 'Gerenciar módulos';
$translationStrings['L_VIEW_ACCORDION_ITEM_QUESTAO_ANALISE_RISCO']              = 'Itens e Questões de Análise de Risco';
$translationStrings['L_VIEW_ACCORDION_MATRIZ_RASTREABILIDADE']                  = 'Matriz de Rastreabilidade';
$translationStrings['L_VIEW_ACCORDION_MEDICAO']                                 = 'Medição';
$translationStrings['L_VIEW_ACCORDION_MENSAGERIA']                              = 'Mensageria';
$translationStrings['L_VIEW_ACCORDION_METRICA']                                 = 'Métrica';
$translationStrings['L_VIEW_ACCORDION_MODULO']                                  = 'Módulos';
$translationStrings['L_VIEW_ACCORDION_OBJETIVO_PROPOSTA']                       = 'Objetivo da Proposta';
$translationStrings['L_VIEW_ACCORDION_OCORRENCIA_ADMINISTRATIVA']               = 'Ocorrência Administrativa';
$translationStrings['L_VIEW_ACCORDION_PARCELA']                                 = $translationStrings['L_VIEW_PARCELA'];
$translationStrings['L_VIEW_ACCORDION_PEDIDO_MUDANCA']                          = 'Pedido de Mudança';
$translationStrings['L_VIEW_ACCORDION_PENALIZACAO']                             = 'Penalização';
$translationStrings['L_VIEW_ACCORDION_PERFIL_MENU']                             = 'Perfil & Menu';
$translationStrings['L_VIEW_ACCORDION_PERFIL_PAPEL_PROFISSIONAL']               = 'Perfil Profissional e Papel Profissional';
$translationStrings['L_VIEW_ACCORDION_PLANEJAMENTO']                            = 'Planejamento';
$translationStrings['L_VIEW_ACCORDION_PLANO_IMPLANTACAO']                       = 'Plano de Implantação';
$translationStrings['L_VIEW_ACCORDION_PRODUTO']                                 = 'Produtos';
$translationStrings['L_VIEW_ACCORDION_PROFISSIONAIS']                           = $translationStrings['L_VIEW_PROFISSIONAIS'];
$translationStrings['L_VIEW_ACCORDION_PROPOSTA']                                = $translationStrings['L_VIEW_PROPOSTA'];
$translationStrings['L_VIEW_ACCORDION_QUESTIONARIO_AVALIACAO']                  = 'Questionário de Avaliação';
$translationStrings['L_VIEW_ACCORDION_REGISTRO_LOG']                            = 'Registro de Log';
$translationStrings['L_VIEW_ACCORDION_REGRA_DE_NEGOCIO']                        = 'Regras de Negócio';
$translationStrings['L_VIEW_ACCORDION_REQUISITO']                               = 'Requisitos';
$translationStrings['L_VIEW_ACCORDION_REQUISITO_CASO_DE_USO']                   = 'Requisitos e Caso de Uso';
$translationStrings['L_VIEW_ACCORDION_REQUISITO_REGRA_DE_NEGOCIO']              = 'Requisitos e Regra de Negócio';
$translationStrings['L_VIEW_ACCORDION_RISCO']                                   = 'Risco';
$translationStrings['L_VIEW_ACCORDION_ROTINA']                                  = 'Rotina';
$translationStrings['L_VIEW_ACCORDION_SUSPENSAO_PROPOSTA']                      = 'Suspensão de Proposta';
$translationStrings['L_VIEW_ACCORDION_TESTE']                                   = 'Teste';
/**Label's de ABAS **/
$translationStrings['L_VIEW_ABA_ALOCACAO']                                      = 'Alocação';
$translationStrings['L_VIEW_ABA_ALOCACAO_CONTRATO_ANTERIOR']                    = 'Alocação de Contrato Anterior';
$translationStrings['L_VIEW_ABA_ALTERACAO']                                     = 'Alteração';
$translationStrings['L_VIEW_ABA_ANALISE']                                       = $translationStrings['L_VIEW_ANALISE'];
$translationStrings['L_VIEW_ABA_ANALISE_DISPONIBILIDADE']                       = 'Análises de Disponibilidade';
$translationStrings['L_VIEW_ABA_ANALISE_EXECUCAO']                              = 'Análise de Execução';
$translationStrings['L_VIEW_ABA_ANALISE_JUSTIFICATIVA']                         = $translationStrings['L_VIEW_ANALISE_JUSTIFICATIVA'];
$translationStrings['L_VIEW_ABA_ANALISE_RISCO']                                 = 'Análise de Risco';
$translationStrings['L_VIEW_ABA_ASSOCIAR_ATIVIDADE_OBJETO_CONTRATO' ]           = 'Associar Atividade ao Objeto do Contrato';
$translationStrings['L_VIEW_ABA_ASSOCIAR_PERFIL_PROFISSIONAL_OBJETO_CONTRATO']  = 'Associar Perfil Profissional ao Objeto do Contrato';
$translationStrings['L_VIEW_ABA_ASSOCIAR_PAPEL_PROFISSIONAL_OBJETO_CONTRATO' ]  = 'Associar Papel Profissional ao Objeto do Contrato';
$translationStrings['L_VIEW_ABA_ASSOCIAR_ROTINA_OBJETO_CONTRATO' ]              = 'Associar Rotina ao Objeto do Contrato';
$translationStrings['L_VIEW_ABA_ATIVIDADE']                                     = $translationStrings['L_VIEW_ATIVIDADE'];
$translationStrings['L_VIEW_ABA_ATORES']                                        = 'Ator(es)';
$translationStrings['L_VIEW_ABA_AUTORIZACOES']                                  = $translationStrings['L_VIEW_AUTORIZACOES'];
$translationStrings['L_VIEW_ABA_BOX_INICIO']                                    = 'Box Início';
$translationStrings['L_VIEW_ABA_CADASTRAR_BASE_CONHECIMENTO']                   = 'Cadastro de Base de Conhecimento';
$translationStrings['L_VIEW_ABA_CADASTRO']                                      = $translationStrings['L_VIEW_CADASTRO'];
$translationStrings['L_VIEW_ABA_CADASTRO_DECISAO']                              = 'Cadastro da Decisão';
$translationStrings['L_VIEW_ABA_CALCULO_METRICA']                               = 'Cálculo de Métrica';
$translationStrings['L_VIEW_ABA_CASO_DE_USO']                                   = $translationStrings['L_VIEW_CASO_DE_USO'];
$translationStrings['L_VIEW_ABA_COMPLEMENTOS']                                  = 'Complemento(s)';
$translationStrings['L_VIEW_ABA_CONDICAO']                                      = $translationStrings['L_VIEW_CONDICAO'];
$translationStrings['L_VIEW_ABA_CONFIGURACOES_BANCO_DADOS']                     = 'Configurações do Banco de Dados';
$translationStrings['L_VIEW_ABA_CONHECIMENTO_UTILIZADO']                        = 'Conhecimentos Utilizados';
$translationStrings['L_VIEW_ABA_CONTATO_EMPRESA']                               = $translationStrings['L_VIEW_CONTATO_EMPRESA'];
$translationStrings['L_VIEW_ABA_CONTATO_EVENTO_ADMINISTRATIVO']                 = 'Contrato X Evento Administrativo';
$translationStrings['L_VIEW_ABA_CONSULTA' ]                                     = 'Consulta';
$translationStrings['L_VIEW_ABA_CONSULTA_TIPO_DEMANDA']                         = 'Consulta Tipo Demanda';
$translationStrings['L_VIEW_ABA_CONSULTA_TIPO_PROJETO']                         = 'Consulta Tipo Projeto';
$translationStrings['L_VIEW_ABA_DECISAO']                                       = $translationStrings['L_VIEW_DECISAO'];
$translationStrings['L_VIEW_ABA_DEFINICAO']                                     = $translationStrings['L_VIEW_DEFINICAO'];
$translationStrings['L_VIEW_ABA_DEMANDAS_ANDAMENTO']                            = 'Demanda(s) em Andamento';
$translationStrings['L_VIEW_ABA_DEMANDAS_CONCLUIDAS']                           = 'Demanda(s) Concluída(s)';
$translationStrings['L_VIEW_ABA_DEMANDAS_EXECUTADAS']                           = 'Demanda(s) Executada(s)';
$translationStrings['L_VIEW_ABA_DEMANDAS_SOLICITADAS']                          = 'Demanda(s) Solicitada(s)';
$translationStrings['L_VIEW_ABA_DEPENDENCIA_REQUISITO']                         = 'Dependência de Requisitos';
$translationStrings['L_VIEW_ABA_DESALOCACAO']                                   = 'Desalocação';
$translationStrings['L_VIEW_ABA_DESALOCACAO_RECURSO']                           = 'Desalocação de Recurso';
$translationStrings['L_VIEW_ABA_DESIGNACAO_ROTINA']                             = 'Designação de Rotina';
$translationStrings['L_VIEW_ABA_DETALHE_SOLICITACAO']                           = $translationStrings['L_VIEW_DETALHE_SOLICITACAO'];
$translationStrings['L_VIEW_ABA_DOCUMENTACAO']                                  = 'Documentação';
$translationStrings['L_VIEW_ABA_DOCUMENTACAO_PROJETO_CONTINUO']                 = 'Documentação de Projeto Contínuo';
$translationStrings['L_VIEW_ABA_DOCUMENTAR']                                    = 'Documentar';
$translationStrings['L_VIEW_ABA_ELABORACAO_PROPOSTA']                           = 'Elaboração de Proposta';
$translationStrings['L_VIEW_ABA_EMPRESA']                                       = $translationStrings['L_VIEW_EMPRESA'];
$translationStrings['L_VIEW_ABA_ENCAMINHAR']                                    = $translationStrings['L_VIEW_ENCAMINHAR'];
$translationStrings['L_VIEW_ABA_ENCERRAMENTO']                                  = 'Encerramento';
$translationStrings['L_VIEW_ABA_ETAPA']                                         = $translationStrings['L_VIEW_ETAPA'];
$translationStrings['L_VIEW_ABA_ETAPAS_CONTROLE']                               = 'Etapas de Controle';
$translationStrings['L_VIEW_ABA_EXECUCAO']                                      = $translationStrings['L_VIEW_EXECUCAO'];
$translationStrings['L_VIEW_ABA_EXECUCAO_PROPOSTA']                             = 'Execução de Proposta';
$translationStrings['L_VIEW_ABA_EXECUCAO_ROTINA']                               = 'Execução de Rotina';
$translationStrings['L_VIEW_ABA_EXTRATO_MENSAL']                                = 'Extrato Mensal';
$translationStrings['L_VIEW_ABA_FECHAMENTO_VERSAO']                             = 'Fechamento de Versão';
$translationStrings['L_VIEW_ABA_FORMULARIO']                                    = $translationStrings['L_VIEW_FORMULARIO'];
$translationStrings['L_VIEW_ABA_FUNCIONALIDADE']                                = $translationStrings['L_VIEW_FUNCIONALIDADE'];
$translationStrings['L_VIEW_ABA_FUNCIONALIDADE_MENU']                           = 'Funcionalidade & Menus';
$translationStrings['L_VIEW_ABA_GRAFICO_GANTT']                                 = $translationStrings['L_VIEW_GRAFICO_GANTT'];
$translationStrings['L_VIEW_ABA_GRUPO_FATOR']                                   = $translationStrings['L_VIEW_GRUPO_FATOR'];
$translationStrings['L_VIEW_ABA_HISTORICO']                                     = $translationStrings['L_VIEW_HISTORICO'];
$translationStrings['L_VIEW_ABA_HISTORICO_PROJETO_CONTINUO']                    = 'Histórico de Projeto Contínuo';
$translationStrings['L_VIEW_ABA_HISTORICO_ROTINA']                              = 'Histórico de Rotina';
$translationStrings['L_VIEW_ABA_HOMOLOGACAO']                                   = $translationStrings['L_VIEW_HOMOLOGACAO'];
$translationStrings['L_VIEW_ABA_INFORMACOES_TECNICAS']                          = 'Informações Técnicas';
$translationStrings['L_VIEW_ABA_INTERACAO']                                     = $translationStrings['L_VIEW_INTERACAO'];
$translationStrings['L_VIEW_ABA_INVENTARIO']                                    = 'Inventário';
$translationStrings['L_VIEW_ABA_INVENTARIOS']                                   = 'Inventários';
$translationStrings['L_VIEW_ABA_DADOS_INVENTARIADO']                            = 'Item a Inventariar';
$translationStrings['L_VIEW_ABA_DADOS_INVENTARIO']                              = 'Dados Inventário';
$translationStrings['L_VIEW_ABA_ITEM']                                          = $translationStrings['L_VIEW_ITEM'];
$translationStrings['L_VIEW_ABA_ITEM_GRUPO_FATOR']                              = $translationStrings['L_VIEW_ITEM_GRUPO_FATOR'];
$translationStrings['L_VIEW_ABA_ITEM_RISCO']                                    = $translationStrings['L_VIEW_ITEM_RISCO'];
$translationStrings['L_VIEW_ABA_LISTA']                                         = $translationStrings['L_VIEW_LISTA'];
$translationStrings['L_VIEW_ABA_LISTA_PERGUNTA']                                = 'Lista de Perguntas';
$translationStrings['L_VIEW_ABA_MEDICAO']                                       = $translationStrings['L_VIEW_MEDICAO'];
$translationStrings['L_VIEW_ABA_MEDICAO_MEDIDA']                                = 'Medição e Medida';
$translationStrings['L_VIEW_ABA_MENSAGEM']                                      = $translationStrings['L_VIEW_MENSAGEM'];
$translationStrings['L_VIEW_ABA_MENSAGEM_ABERTA']                               = 'Mensagens Abertas';
$translationStrings['L_VIEW_ABA_MENSAGEM_PENDENTE']                             = 'Mensagens Pendentes';
$translationStrings['L_VIEW_ABA_MENSAGEM_RESPONDIDA']                           = 'Mensagens Respondidas';
$translationStrings['L_VIEW_ABA_MENSAGENS']                                     = $translationStrings['L_VIEW_MENSAGENS'];
$translationStrings['L_VIEW_ABA_MENU']                                          = $translationStrings['L_VIEW_MENU'];
$translationStrings['L_VIEW_ABA_MINHAS_SOLICITACOES']                           = 'Minhas Solicitações';
$translationStrings['L_VIEW_ABA_MODULO_CONTINUO']                               = $translationStrings['L_VIEW_MODULO_CONTINUO'];
$translationStrings['L_VIEW_ABA_NIVEL_SERVICO']                                 = $translationStrings['L_VIEW_NIVEL_SERVICO'];
$translationStrings['L_VIEW_ABA_NOVA_ANALISE']                                  = 'Nova Análise';
$translationStrings['L_VIEW_ABA_NOVA_MEDICAO']                                  = 'Nova Medição';
$translationStrings['L_VIEW_ABA_NOVO_REQUISITO']                                = $translationStrings['L_VIEW_NOVO_REQUISITO'];
$translationStrings['L_VIEW_ABA_OBJETO_CONTRATO']                               = $translationStrings['L_VIEW_OBJETO_CONTRATO'];
$translationStrings['L_VIEW_ABA_OCORRENCIA_MENSAL']                             = 'Ocorrência Mensal';
$translationStrings['L_VIEW_ABA_OCORRENCIAS_ADMINISTRATIVAS']                   = 'Ocorrências Administrativas';
$translationStrings['L_VIEW_ABA_PAPEL_PROFISSIONAL']                            = 'Papel Profissional';
$translationStrings['L_VIEW_ABA_PAPEL_PROFISSIONAL_PERFIL_PROFISSIONAL']        = 'Associar Papel Profissional ao Perfil Profissional';
$translationStrings['L_VIEW_ABA_PEDIDO']                                        = 'Pedido';
$translationStrings['L_VIEW_ABA_PEDIDO_MUDANCA']                                = $translationStrings['L_VIEW_PEDIDO_MUDANCA'];
$translationStrings['L_VIEW_ABA_PEDIDOS']                                       = 'Pedidos';
$translationStrings['L_VIEW_ABA_PEDIDOS_AUTORIZADOS']                           = 'Pedidos Autorizados';
$translationStrings['L_VIEW_ABA_PEDIDOS_VALIDADOS']                             = 'Pedidos Validados';
$translationStrings['L_VIEW_ABA_PENALIDADE']                                    = $translationStrings['L_VIEW_PENALIDADE'];
$translationStrings['L_VIEW_ABA_PERFIL']                                        = $translationStrings['L_VIEW_PERFIL'];
$translationStrings['L_VIEW_ABA_PERFIL_BOX_INICIO']                             = 'Perfil Box Início';
$translationStrings['L_VIEW_ABA_PERFIL_MENU']                                   = 'Perfil e Menu';
$translationStrings['L_VIEW_ABA_PERFIL_PROFISSIONAL']                           = $translationStrings['L_VIEW_PERFIL_PROFISSIONAL'];
$translationStrings['L_VIEW_ABA_PERGUNTA']                                      = $translationStrings['L_VIEW_PERGUNTA'];
$translationStrings['L_VIEW_ABA_PESQUISA_BASE_CONHECIMENTO']                    = 'Pesquisa de Base de Conhecimento';
$translationStrings['L_VIEW_ABA_PLANEJAMENTO']                                  = $translationStrings['L_VIEW_PLANEJAMENTO'];
$translationStrings['L_VIEW_ABA_PRE_DEMANDAS']                                  = 'Pré-Demanda(s)';
$translationStrings['L_VIEW_ABA_PRE_DEMANDA_ANDAMENTO']                         = 'Pré-Demanda(s) em Andamento';
$translationStrings['L_VIEW_ABA_PRE_DEMANDA_EXECUTADA']                         = 'Pré-Demanda(s) Executada(s)';
$translationStrings['L_VIEW_ABA_PRE_PROJETO']                                   = 'Pré-Projeto';
$translationStrings['L_VIEW_ABA_PRODUTO_PROFISSIONAL']                          = 'Produto X Profissional';
$translationStrings['L_VIEW_ABA_PROFISSIONAL_DESIGNADO']                        = 'Profissional Designado';
$translationStrings['L_VIEW_ABA_PROJETO_CONTINUO']                              = $translationStrings['L_VIEW_PROJETO_CONTINUO'];
$translationStrings['L_VIEW_ABA_PROJETO_EXECUCAO']                              = 'Projeto(s) em Execução';
$translationStrings['L_VIEW_ABA_PROJETO_PREVISTO']                              = $translationStrings['L_VIEW_PROJETO_PREVISTO'];
$translationStrings['L_VIEW_ABA_PROPOSTA']                                      = $translationStrings['L_VIEW_PROPOSTA'];
$translationStrings['L_VIEW_ABA_PROPOSTAS_ANDAMENTO']                           = 'Propostas em Andamento';
$translationStrings['L_VIEW_ABA_QUESTAO_ANALISE_RISCO']                         = $translationStrings['L_VIEW_QUESTAO_ANALISE_RISCO'];
$translationStrings['L_VIEW_ABA_QUESTIONARIO_RISCO']                            = 'Questionário de Risco';
$translationStrings['L_VIEW_ABA_REGISTRAR_JUSTIFICATIVA']                       = $translationStrings['L_BTN_REGISTRAR_JUSTIFICATIVA'];
$translationStrings['L_VIEW_ABA_REGISTRAR_OCORRENCIA']                          = 'Registrar Ocorrência';
$translationStrings['L_VIEW_ABA_REGISTRAR_OCORRENCIA_ADMINISTRATIVA']           = 'Registrar Ocorrência Administrativa';
$translationStrings['L_VIEW_ABA_REGRA_DE_NEGOCIO']                              = $translationStrings['L_VIEW_REGRA_DE_NEGOCIO'];
$translationStrings['L_VIEW_ABA_REGRAS_DE_NEGOCIO']                             = 'Regras de Negócio';
$translationStrings['L_VIEW_ABA_RELATO_TESTE']                                  = $translationStrings['L_VIEW_RELATO_TESTE'];
$translationStrings['L_VIEW_ABA_REQUISITO']                                     = $translationStrings['L_VIEW_REQUISITO'];
$translationStrings['L_VIEW_ABA_REQUISITOS']                                    = $translationStrings['L_VIEW_REQUISITOS'];
$translationStrings['L_VIEW_ABA_RESPOSTA']                                      = $translationStrings['L_VIEW_RESPOSTA'];
$translationStrings['L_VIEW_ABA_REUNIAO']                                       = $translationStrings['L_VIEW_REUNIAO'];
$translationStrings['L_VIEW_ABA_REUNIAO_PROFISSIONAL']                          = 'Reunião X Profissional';
$translationStrings['L_VIEW_ABA_REUNIAO_GERAL']                                 = $translationStrings['L_VIEW_REUNIAO_GERAL'];
$translationStrings['L_VIEW_ABA_REUNIAO_GERAL_PROFISSIONAL']                    = 'Reunião Geral X Profissional';
$translationStrings['L_VIEW_ABA_ROTINA']                                        = 'Rotina';
$translationStrings['L_VIEW_ABA_SOLICITACAO_PROPOSTA']                          = $translationStrings['L_VIEW_SOLICITACAO_PROPOSTA'];
$translationStrings['L_VIEW_ABA_SOLICITACOES']                                  = 'Solicitações';
$translationStrings['L_VIEW_ABA_SOLICITACOES_COMITE']                           = 'Solicitações do Comitê';
$translationStrings['L_VIEW_ABA_SOLICITACOES_SERVICE_DESK']                     = 'Solicitações Service Desk';
$translationStrings['L_VIEW_ABA_SOLICITACOES_SERVICO']                          = 'Solicitações de Serviço';
$translationStrings['L_VIEW_ABA_SOLICITACOES_SERVICO_CONCLUIDAS']               = 'Solicitações de Serviço Concluídas';
$translationStrings['L_VIEW_ABA_SOLICITACOES_SERVICO_EXECUTADAS']               = 'Solicitações de Serviço Executadas';
$translationStrings['L_VIEW_ABA_SOLUCAO']                                       = $translationStrings['L_VIEW_SOLUCAO'];
$translationStrings['L_VIEW_ABA_SUB_ITEM']                                      = $translationStrings['L_VIEW_SUB_ITEM'];
$translationStrings['L_VIEW_ABA_TIPO_PRODUTO']                                  = $translationStrings['L_VIEW_TIPO_PRODUTO'];
$translationStrings['L_VIEW_ABA_VALIDAR_PEDIDO']                                = 'Validar Pedido';
/**Label's de GRID **/
$translationStrings['L_VIEW_GRID_ABRIR']                                        = $translationStrings['L_VIEW_ABRIR'];
$translationStrings['L_VIEW_GRID_ACAO']                                         = $translationStrings['L_VIEW_ACAO'];
$translationStrings['L_VIEW_GRID_AGENTE']                                       = 'Agente';
$translationStrings['L_VIEW_GRID_ALOCACAO']                                     = 'Alocação';
$translationStrings['L_VIEW_GRID_ALOCADO']                                      = 'Alocado';
$translationStrings['L_VIEW_GRID_ALTERACAO']                                    = 'Alteração';
$translationStrings['L_VIEW_GRID_ANALISE']                                      = $translationStrings['L_VIEW_ANALISE'];
$translationStrings['L_VIEW_GRID_AREA_ATUACAO_TI']                              = 'Área Atuação TI';
$translationStrings['L_VIEW_GRID_AREA_CONHECIMENTO']                            = $translationStrings['L_VIEW_AREA_CONHECIMENTO'];
$translationStrings['L_VIEW_GRID_ASSUNTO']                                      = 'Assunto';
$translationStrings['L_VIEW_GRID_ATIVIDADE']                                    = $translationStrings['L_VIEW_ATIVIDADE'];
$translationStrings['L_VIEW_GRID_ATIVIDADES']                                   = $translationStrings['L_VIEW_ATIVIDADES'];
$translationStrings['L_VIEW_GRID_ATIVO']                                        = $translationStrings['L_VIEW_ATIVO'];
$translationStrings['L_VIEW_GRID_ATOR']                                         = 'Ator';
$translationStrings['L_VIEW_GRID_BOX']                                          = $translationStrings['L_VIEW_BOX'];
$translationStrings['L_VIEW_GRID_CASO_DE_USO']                                  = $translationStrings['L_VIEW_CASO_DE_USO'];
$translationStrings['L_VIEW_GRID_CLAFISSICACAO']                                = 'Classificação';
$translationStrings['L_VIEW_GRID_CODIGO']                                       = 'Código';
$translationStrings['L_VIEW_GRID_COMPLEMENTOS']                                 = 'Complemento(s)';
$translationStrings['L_VIEW_GRID_CONDICAO']                                     = 'Condição';
$translationStrings['L_VIEW_GRID_CONFIRMACAO']                                  = 'Confirmação';
$translationStrings['L_VIEW_GRID_CONHECIMENTO']                                 = $translationStrings['L_VIEW_CONHECIMENTO'];
$translationStrings['L_VIEW_GRID_CONHECIMENTO_PROFISSIONAL']                    = $translationStrings['L_VIEW_CONHECIMENTO_PROFISSIONAL'];
$translationStrings['L_VIEW_GRID_CONTRATO']                                     = $translationStrings['L_VIEW_CONTRATO'];
$translationStrings['L_VIEW_GRID_CONTROLLER']                                   = 'Controller';
$translationStrings['L_VIEW_GRID_COR']                                          = 'Cor';
$translationStrings['L_VIEW_GRID_CREDITOS']                                     = 'Créditos';
$translationStrings['L_VIEW_GRID_DADOS']                                        = 'Dados';
$translationStrings['L_VIEW_GRID_DATA']                                         = $translationStrings['L_VIEW_DATA'];
$translationStrings['L_VIEW_GRID_DATA_ANALISE']                                 = $translationStrings['L_VIEW_DATA_ANALISE'];
$translationStrings['L_VIEW_GRID_DATA_ARQUIVO']                                 = 'Data do Arquivo';
$translationStrings['L_VIEW_GRID_DATA_DECISAO']                                 = $translationStrings['L_VIEW_DATA_DECISAO'];
$translationStrings['L_VIEW_GRID_DATA_FIM']                                     = $translationStrings['L_VIEW_DATA_FIM'];
$translationStrings['L_VIEW_GRID_DATA_HORA']                                    = $translationStrings['L_VIEW_DATA_HORA'];
$translationStrings['L_VIEW_GRID_DATA_HORA_DEMANDA']                            = 'Data/Hora Demanda';
$translationStrings['L_VIEW_GRID_DATA_HORA_FECHAMENTO']                         = 'Data/Hora Fechamento';
$translationStrings['L_VIEW_GRID_DATA_HORA_FIM']                                = 'Data/Hora Fim';
$translationStrings['L_VIEW_GRID_DATA_HORA_INICIO']                             = 'Data/Hora Início';
$translationStrings['L_VIEW_GRID_DATA_INICIO']                                  = $translationStrings['L_VIEW_DATA_INICIO'];
$translationStrings['L_VIEW_GRID_DATA_SOLICITACAO']                             = $translationStrings['L_VIEW_DATA_SOLICITACAO'];
$translationStrings['L_VIEW_GRID_DATA_TERMINO']                                 = $translationStrings['L_VIEW_DATA_TERMINO'];
$translationStrings['L_VIEW_GRID_DATA_ULTIMA_ATUALIZACAO']                      = 'Última Atualização';
$translationStrings['L_VIEW_GRID_DATA_ULTIMA_HOMOLOGACAO']                      = 'Data da Última Homologação';
$translationStrings['L_VIEW_GRID_DEBITOS']                                      = 'Débitos';
$translationStrings['L_VIEW_GRID_DESCRICAO']                                    = $translationStrings['L_VIEW_DESCRICAO'];
$translationStrings['L_VIEW_GRID_DESCRICAO_DEMANDA']                            = $translationStrings['L_VIEW_DESCRICAO_DEMANDA'];
$translationStrings['L_VIEW_GRID_DESCRICAO_PRE_DEMANDA']                        = $translationStrings['L_VIEW_DESCRICAO_PRE_DEMANDA'];
$translationStrings['L_VIEW_GRID_DESCRICAO_SOLICITACAO']                        = $translationStrings['L_VIEW_DESCRICAO_SOLICITACAO'];
$translationStrings['L_VIEW_GRID_DESIGNACAO']                                   = 'Designação';
$translationStrings['L_VIEW_GRID_DETALHAMENTO']                                 = $translationStrings['L_VIEW_DETALHAMENTO'];
$translationStrings['L_VIEW_GRID_DETALHE_DEMANDA']                              = $translationStrings['L_VIEW_DETALHE_DEMANDA'];
$translationStrings['L_VIEW_GRID_DICIONARIO_DADOS']                             = $translationStrings['L_VIEW_DICIONARIO_DADOS'];
$translationStrings['L_VIEW_GRID_DIFERENCA']                                    = 'Diferença';
$translationStrings['L_VIEW_GRID_DOCUMENTACAO']                                 = 'Documentação';
$translationStrings['L_VIEW_GRID_DOWNLOAD_ARQUIVO']                             = 'Download do Arquivo';
$translationStrings['L_VIEW_GRID_EMAIL']                                        = $translationStrings['L_VIEW_EMAIL'];
$translationStrings['L_VIEW_GRID_EMITIR_SOLICITACAO_PROPOSTA']                  = 'Emitir Solicitacao de Proposta';
$translationStrings['L_VIEW_GRID_EMPRESA']                                      = $translationStrings['L_VIEW_EMPRESA'];
$translationStrings['L_VIEW_GRID_ENCERRAMENTO']                                 = $translationStrings['L_VIEW_ENCERRAMENTO'];
$translationStrings['L_VIEW_GRID_ENVIADA_LIDA']                                 = 'Enviada / Lida';
$translationStrings['L_VIEW_GRID_ESCOPO_RESUMIDO']                              = $translationStrings['L_VIEW_ESCOPO_RESUMIDO'];
$translationStrings['L_VIEW_GRID_ETAPA']                                        = $translationStrings['L_VIEW_ETAPA'];
$translationStrings['L_VIEW_GRID_ETAPA_CONTROLE']                               = 'Etapas de Controle';
$translationStrings['L_VIEW_GRID_ETAPA_ELABORACAO']                             = 'Etapa de Elaboração';
$translationStrings['L_VIEW_GRID_ETAPAS_TESTES']                                = 'Etapas dos Testes';
$translationStrings['L_VIEW_GRID_EVENTO']                                       = $translationStrings['L_VIEW_EVENTO'];
$translationStrings['L_VIEW_GRID_EXCECAO']                                      = $translationStrings['L_VIEW_EXCECAO'];
$translationStrings['L_VIEW_GRID_EXECUCAO']                                     = 'Execução';
$translationStrings['L_VIEW_GRID_EXECUTADO']                                    = 'Executado';
$translationStrings['L_VIEW_GRID_EXTENSAO']                                     = 'Extensão';
$translationStrings['L_VIEW_GRID_FASE']                                         = $translationStrings['L_VIEW_FASE'];
$translationStrings['L_VIEW_GRID_FATOR']                                        = 'Fator';
$translationStrings['L_VIEW_GRID_FINALIZAR']                                    = 'Finalizar';
$translationStrings['L_VIEW_GRID_FLUXO_ALTERNATIVO']                            = $translationStrings['L_VIEW_FLUXO_ALTERNATIVO'];
$translationStrings['L_VIEW_GRID_FORMULA']                                      = $translationStrings['L_VIEW_FORMULA'];
$translationStrings['L_VIEW_GRID_FUNCIONALIDADE']                               = $translationStrings['L_VIEW_FUNCIONALIDADE'];
$translationStrings['L_VIEW_GRID_GRUPO_FATOR']                                  = $translationStrings['L_VIEW_GRUPO_FATOR'];
$translationStrings['L_VIEW_GRID_HISTORICO']                                    = $translationStrings['L_VIEW_HISTORICO'];
$translationStrings['L_VIEW_GRID_HISTORICO_GERAL']                              = 'Histórico Geral';
$translationStrings['L_VIEW_GRID_HOMOLOGACAO']                                  = 'Homologação';
$translationStrings['L_VIEW_GRID_HORA']                                         = 'Hora';
$translationStrings['L_VIEW_GRID_HORAS_ALOCACAO']                               = 'Horas Alocação';
$translationStrings['L_VIEW_GRID_HORAS_ESTIMADAS']                              = 'Horas Estimadas';
$translationStrings['L_VIEW_GRID_HORAS_MODULO_PROPOSTA']                        = 'Horas Módulo Proposta';
$translationStrings['L_VIEW_GRID_HORAS_TOTAIS']                                 = 'Horas Totais';
$translationStrings['L_VIEW_GRID_HOST']                                         = $translationStrings['L_VIEW_HOST'];
$translationStrings['L_VIEW_GRID_INDICE']                                       = $translationStrings['L_VIEW_INDICE'];
$translationStrings['L_VIEW_GRID_INFRACAO']                                     = $translationStrings['L_VIEW_INFRACAO'];
$translationStrings['L_VIEW_GRID_INTERACAO']                                    = $translationStrings['L_VIEW_INTERACAO'];
$translationStrings['L_VIEW_GRID_INVENTARIO']                                   = 'Inventário';
$translationStrings['L_VIEW_GRID_IP']                                           = $translationStrings['L_VIEW_IP'];
$translationStrings['L_VIEW_GRID_ITEM']                                         = $translationStrings['L_VIEW_ITEM'];
$translationStrings['L_VIEW_GRID_ITEM_CONTROLE_BASELINE']                       = $translationStrings['L_VIEW_ITEM_CONTROLE_BASELINE'];
$translationStrings['L_VIEW_GRID_ITEM_GRUPO_FATOR']                             = $translationStrings['L_VIEW_ITEM_GRUPO_FATOR'];
$translationStrings['L_VIEW_GRID_ITEM_INVENTARIADO']                            = $translationStrings['L_VIEW_ITEM_INVENTARIADO'];
$translationStrings['L_VIEW_GRID_ITEM_INVENTARIO']                              = $translationStrings['L_VIEW_ITEM_INVENTARIO'];
$translationStrings['L_VIEW_GRID_ITEM_PARECER_TECNICO']                         = $translationStrings['L_VIEW_ITEM_PARECER_TECNICO'];
$translationStrings['L_VIEW_GRID_ITEM_RISCO']                                   = $translationStrings['L_VIEW_ITEM_RISCO'];
$translationStrings['L_VIEW_GRID_ITEM_TESTE']                                   = $translationStrings['L_VIEW_ITEM_TESTE'];
$translationStrings['L_VIEW_GRID_JUSTIFICAR']                                   = $translationStrings['L_VIEW_JUSTIFICAR'];
$translationStrings['L_VIEW_GRID_JUSTIFICATIVO']                                = $translationStrings['L_VIEW_JUSTIFICATIVA'];
$translationStrings['L_VIEW_GRID_LISTA']                                        = $translationStrings['L_VIEW_LISTA'];
$translationStrings['L_VIEW_GRID_LOCAL_REUNIAO']                                = $translationStrings['L_VIEW_LOCAL_REUNIAO'];
$translationStrings['L_VIEW_GRID_MEDICAO']                                      = $translationStrings['L_VIEW_MEDICAO'];
$translationStrings['L_VIEW_GRID_MEDIDA']                                       = $translationStrings['L_VIEW_MEDIDA'];
$translationStrings['L_VIEW_GRID_MENSAGEM']                                     = $translationStrings['L_VIEW_MENSAGEM'];
$translationStrings['L_VIEW_GRID_MES_ANO']                                      = $translationStrings['L_VIEW_MES_ANO'];
$translationStrings['L_VIEW_GRID_METRICA']                                      = $translationStrings['L_VIEW_METRICA'];
$translationStrings['L_VIEW_GRID_MODELO_DADOS']                                 = 'Modelo de Dados';
$translationStrings['L_VIEW_GRID_MODULO']                                       = $translationStrings['L_VIEW_MODULO'];
$translationStrings['L_VIEW_GRID_MODULO_CONTINUADO']                            = 'Módulo Continuado';
$translationStrings['L_VIEW_GRID_MODULO_CONTINUO']                              = $translationStrings['L_VIEW_MODULO_CONTINUO'];
$translationStrings['L_VIEW_GRID_MODULO_PROPOSTA']                              = 'Módulo Proposta';
$translationStrings['L_VIEW_GRID_MULTIPLA']                                     = 'Múltipla';
$translationStrings['L_VIEW_GRID_NIVEL']                                        = $translationStrings['L_VIEW_NIVEL'];
$translationStrings['L_VIEW_GRID_NIVEL_SERVICO']                                = $translationStrings['L_VIEW_NIVEL_SERVICO'];
$translationStrings['L_VIEW_GRID_NOME']                                         = $translationStrings['L_VIEW_NOME'];
$translationStrings['L_VIEW_GRID_NOME_BOX']                                     = $translationStrings['L_VIEW_NOME_BOX'];
$translationStrings['L_VIEW_GRID_NOME_DOCUMENTO']                               = 'Nome do Documento';
$translationStrings['L_VIEW_GRID_NR']                                           = 'Nr.';
$translationStrings['L_VIEW_GRID_NR_CONTRATO']                                  = $translationStrings['L_VIEW_NR_CONTRATO'];
$translationStrings['L_VIEW_GRID_NR_ORDEM']                                     = $translationStrings['L_VIEW_NR_ORDEM'];
$translationStrings['L_VIEW_GRID_NUMERO']                                       = $translationStrings['L_VIEW_NUMERO'];
$translationStrings['L_VIEW_GRID_NUMERO_PARCELAS']                              = $translationStrings['L_VIEW_NUMERO_PARCELAS'];
$translationStrings['L_VIEW_GRID_OCORRENCIA']                                   = $translationStrings['L_VIEW_OCORRENCIA'];
$translationStrings['L_VIEW_GRID_OBJETO']                                       = $translationStrings['L_VIEW_OBJETO'];
$translationStrings['L_VIEW_GRID_OBJETO_EXECUTOR']                              = 'Objeto Executor';
$translationStrings['L_VIEW_GRID_OBJETO_PADRAO']                                = 'Objeto Padrão?';
$translationStrings['L_VIEW_GRID_OBRIGATORIA']                                  = $translationStrings['L_VIEW_OBRIGATORIA'];
$translationStrings['L_VIEW_GRID_OBRIGATORIO']                                  = $translationStrings['L_VIEW_OBRIGATORIO'];
$translationStrings['L_VIEW_GRID_OBSERVACAO']                                   = $translationStrings['L_VIEW_OBSERVACAO'];
$translationStrings['L_VIEW_GRID_OBSERVACAO_PEDIDO']                            = 'Observação do Pedido';
$translationStrings['L_VIEW_GRID_OPCAO']                                        = $translationStrings['L_VIEW_OPCAO'];
$translationStrings['L_VIEW_GRID_OPCAO_RESPOSTA']                               = 'Opção de Resposta';
$translationStrings['L_VIEW_GRID_ORDEM']                                        = $translationStrings['L_VIEW_ORDEM'];
$translationStrings['L_VIEW_GRID_PADRAO']                                       = 'Padrão';
$translationStrings['L_VIEW_GRID_PAPEL_PROFISSIONAL']                           = $translationStrings['L_VIEW_PAPEL_PROFISSIONAL'];
$translationStrings['L_VIEW_GRID_PARCELA']                                      = $translationStrings['L_VIEW_PARCELA'];
$translationStrings['L_VIEW_GRID_PARCELAS']                                     = 'Parcela(s)';
$translationStrings['L_VIEW_GRID_PARECER']                                      = $translationStrings['L_VIEW_PARECER'];
$translationStrings['L_VIEW_GRID_PAUTA']                                        = $translationStrings['L_VIEW_PAUTA'];
$translationStrings['L_VIEW_GRID_PENALIDADE']                                   = $translationStrings['L_VIEW_PENALIDADE'];
;
$translationStrings['L_VIEW_GRID_PENALIDADE_RESUMIDA']                          = 'Penalidade Resumida';
$translationStrings['L_VIEW_GRID_PERFIL']                                       = $translationStrings['L_VIEW_PERFIL'];
$translationStrings['L_VIEW_GRID_PERFIL_PROFISSIONAL']                          = $translationStrings['L_VIEW_PERFIL_PROFISSIONAL'];
$translationStrings['L_VIEW_GRID_PERFIS_HISTORICO']                             = 'Perfis/Histórico';
$translationStrings['L_VIEW_GRID_PERGUNTA']                                     = $translationStrings['L_VIEW_PERGUNTA'];
$translationStrings['L_VIEW_GRID_PERIODO']                                      = $translationStrings['L_VIEW_PERIODO'];
$translationStrings['L_VIEW_GRID_PESO']                                         = $translationStrings['L_VIEW_PESO'];
$translationStrings['L_VIEW_GRID_PORCENTAGEM']                                  = $translationStrings['L_VIEW_PORCENTAGEM'];
$translationStrings['L_VIEW_GRID_PORCENTAGEM_EXECUCAO']                         = '% Execução';
$translationStrings['L_VIEW_GRID_PORCENTAGEM_LIDA']                             = '% Lida';
$translationStrings['L_VIEW_GRID_POSTAGEM']                                     = 'Postagem';
$translationStrings['L_VIEW_GRID_PREVISAO']                                     = 'Previsão';
$translationStrings['L_VIEW_GRID_PRIORIDADE']                                   = $translationStrings['L_VIEW_PRIORIDADE'];
$translationStrings['L_VIEW_GRID_PROBLEMA']                                     = $translationStrings['L_VIEW_PROBLEMA'];
$translationStrings['L_VIEW_GRID_PRODUTOS']                                     = $translationStrings['L_VIEW_PRODUTOS'];
$translationStrings['L_VIEW_GRID_PROFISSIONAL']                                 = $translationStrings['L_VIEW_PROFISSIONAL'];
$translationStrings['L_VIEW_GRID_PROFISSIONAIS']                                = $translationStrings['L_VIEW_PROFISSIONAIS'];
$translationStrings['L_VIEW_GRID_PROJETO']                                      = $translationStrings['L_VIEW_PROJETO'];
$translationStrings['L_VIEW_GRID_PROJETO_CONTINUADO']                           = 'Projeto Contínuo';
$translationStrings['L_VIEW_GRID_PROJETO_CONTINUO']                             = $translationStrings['L_VIEW_PROJETO_CONTINUO'];
$translationStrings['L_VIEW_GRID_PROJETO_PREVISTO']                             = $translationStrings['L_VIEW_PROJETO_PREVISTO'];
$translationStrings['L_VIEW_GRID_PROJETO_PROPOSTA']                             = 'Projeto/Proposta';
$translationStrings['L_VIEW_GRID_PROPOSTA']                                     = $translationStrings['L_VIEW_PROPOSTA'];
$translationStrings['L_VIEW_GRID_QUEM_FAZ']                                     = $translationStrings['L_VIEW_QUEM_FAZ'];
$translationStrings['L_VIEW_GRID_QUESTAO']                                      = $translationStrings['L_VIEW_QUESTAO'];
$translationStrings['L_VIEW_GRID_QUESTAO_ANALISE_RISCO']                        = $translationStrings['L_VIEW_QUESTAO_ANALISE_RISCO'];
$translationStrings['L_VIEW_GRID_RECEBE_EMAIL']                                 = 'Recebe E-mail?';
$translationStrings['L_VIEW_GRID_REGISTRAR']                                    = 'Registrar';
$translationStrings['L_VIEW_GRID_REGRA']                                        = $translationStrings['L_VIEW_REGRA'];
$translationStrings['L_VIEW_GRID_REGRA_DE_NEGOCIO']                             = $translationStrings['L_VIEW_REGRA_DE_NEGOCIO'];
$translationStrings['L_VIEW_GRID_RELACAO_CONTRATUAL']                           = $translationStrings['L_VIEW_RELACAO_CONTRATUAL'];
$translationStrings['L_VIEW_GRID_RELATO_TESTE']                                 = $translationStrings['L_VIEW_RELATO_TESTE'];
$translationStrings['L_VIEW_GRID_REQUISITO']                                    = 'Requisito';
$translationStrings['L_VIEW_GRID_RESPOSTA']                                     = $translationStrings['L_VIEW_RESPOSTA'];
$translationStrings['L_VIEW_GRID_RISCO']                                        = 'Risco';
$translationStrings['L_VIEW_GRID_ROTINA']                                       = 'Rotina';
$translationStrings['L_VIEW_GRID_SALDO']                                        = 'Saldo';
$translationStrings['L_VIEW_GRID_SIGLA']                                        = $translationStrings['L_VIEW_SIGLA'];
$translationStrings['L_VIEW_GRID_SIGLA_UNIDADE']                                = 'Sigla Unidade';
$translationStrings['L_VIEW_GRID_SITUACAO']                                     = $translationStrings['L_VIEW_SITUACAO'];
$translationStrings['L_VIEW_GRID_SOLICITACAO']                                  = $translationStrings['L_VIEW_SOLICITACAO'];
$translationStrings['L_VIEW_GRID_SOLICITACAO_DEMANDA']                          = 'Solicitação/Demanda';
$translationStrings['L_VIEW_GRID_SOLICITANTE']                                  = $translationStrings['L_VIEW_SOLICITANTE'];
$translationStrings['L_VIEW_GRID_SOLUCAO']                                      = 'Solução';
$translationStrings['L_VIEW_GRID_STATUS']                                       = $translationStrings['L_VIEW_STATUS'];
$translationStrings['L_VIEW_GRID_STATUS_ATENDIMENTO']                           = $translationStrings['L_VIEW_STATUS_ATENDIMENTO'];
$translationStrings['L_VIEW_GRID_SUB_ITEM_METRICA']                             = $translationStrings['L_VIEW_SUB_ITEM_METRICA'];
$translationStrings['L_VIEW_GRID_SUBITENS_INVENTARIO']                          = 'Subitens de Inventário';
$translationStrings['L_VIEW_GRID_TABELA']                                       = $translationStrings['L_VIEW_TABELA'];
$translationStrings['L_VIEW_GRID_TESTE']                                        = 'Teste';
$translationStrings['L_VIEW_GRID_TEXTO_APOIO']                                  = $translationStrings['L_VIEW_TEXTO_APOIO'];
$translationStrings['L_VIEW_GRID_TIPO']                                         = $translationStrings['L_VIEW_TIPO'];
$translationStrings['L_VIEW_GRID_TIPO_ARQUIVO']                                 = $translationStrings['L_VIEW_TIPO_ARQUIVO'];
$translationStrings['L_VIEW_GRID_TIPO_BOX']                                     = $translationStrings['L_VIEW_TIPO_BOX'];
$translationStrings['L_VIEW_GRID_TIPO_CONHECIMENTO']                            = $translationStrings['L_VIEW_TIPO_CONHECIMENTO'];
$translationStrings['L_VIEW_GRID_TIPO_DADO_TECNICO']                            = $translationStrings['L_VIEW_TIPO_DADO_TECNICO'];
$translationStrings['L_VIEW_GRID_TIPO_DOCUMENTO']                               = $translationStrings['L_VIEW_TIPO_DOCUMENTO'];
$translationStrings['L_VIEW_GRID_TIPO_INVENTARIO']                              = 'Tipo de Inventário';
$translationStrings['L_VIEW_GRID_TIPO_PRODUTO']                                 = $translationStrings['L_VIEW_TIPO_PRODUTO'];
$translationStrings['L_VIEW_GRID_TIPO_PROJETO']                                 = 'Tipo do Projeto';
$translationStrings['L_VIEW_GRID_TIPO_SOLICITACAO']                             = $translationStrings['L_VIEW_TIPO_SOLICITACAO'];
$translationStrings['L_VIEW_GRID_TIPO_TESTE']                                   = $translationStrings['L_VIEW_TIPO_TESTE'];
$translationStrings['L_VIEW_GRID_TITULO_BOX']                                   = $translationStrings['L_VIEW_TITULO_BOX'];
$translationStrings['L_VIEW_GRID_TOTAIS']                                       = 'Totais';
$translationStrings['L_VIEW_GRID_TREINAMENTO']                                  = $translationStrings['L_VIEW_TREINAMENTO'];
$translationStrings['L_VIEW_GRID_UNID_METRICA']                                 = $translationStrings['L_VIEW_UNID_METRICA'];
$translationStrings['L_VIEW_GRID_UNIDADE']                                      = $translationStrings['L_VIEW_UNIDADE'];
$translationStrings['L_VIEW_GRID_UNIDADE_SOLICITANTE']                          = 'Undidade Solicitante';
$translationStrings['L_VIEW_GRID_UNIDADES_PREVISTAS']                           = 'Unidades Previstas';
$translationStrings['L_VIEW_GRID_VALOR']                                        = 'Valor';
$translationStrings['L_VIEW_GRID_VALORES']                                      = 'Valores';
$translationStrings['L_VIEW_GRID_VARIAVEL_ITEM']                                = $translationStrings['L_VIEW_VARIAVEL_ITEM'];
$translationStrings['L_VIEW_GRID_VARIAVEL_SUB_ITEM']                            = $translationStrings['L_VIEW_VARIAVEL_SUB_ITEM'];
$translationStrings['L_VIEW_GRID_VER_JUSTIFICATIVA']                            = 'Ver Justificativa';
$translationStrings['L_VIEW_GRID_VERSAO']                                       = $translationStrings['L_VIEW_VERSAO'];
$translationStrings['L_VIEW_GRID_WIREFRAME']                                    = 'Wireframe';
/** Label's MENSAGENS **/
/** Label's MENSAGENS DIVERSAS **/
$translationStrings['L_MSG_APRESENTACAO_SISTEMA_OASIS']                                             = 'O Sistema de Gestão de Projetos, Demandas e Serviços de Tecnologia da Informação - OASIS foi iniciado no ano de 2005 buscando atender aos diversos acórdãos do TCU, direcionados ao Ministério de Desenvolvimento, Industria e Comércio Exterior – MDIC, referentes às licitações realizadas. Um dos acórdãos do TCU incluiu um item dirigido à Secretaria de Logística de Tecnologia da Informação – SLTI, do Ministério do Planejamento, para que fosse elaborada uma Instrução Normativa, baseada nos acórdãos do MDIC, sobre as contratações de TI no Governo. Em 20 de maio de 2008 foi publicada a IN SLTI nº 04, que entrou em vigor no dia 02 de janeiro de 2009, normalizando todo o processo de contratação. O OASIS, vem automatizar uma grande parte das funcionalidades encontradas na IN SLTI nº 04, principalmente em relação ao artigo 20.';
$translationStrings['L_MSG_BEM_VINDO_ASSISTENTE_INSTALACAO']                                        = 'Bem-vindo ao assistente de instalação do sistema OASIS';
$translationStrings['L_MSG_BOM_FUNCIONAMENTO_LER_MANUAL_INFORMACOES_GERAIS']                        = 'Para o seu bom funcionamento sugerimos ler o manual do sistema, bem como as Infomações Gerias';
$translationStrings['L_MSG_CADASTRA_HOMOLOGACAO_CASO_DE_USO']                                       = 'Cadastra Homologação em Caso de Uso';
$translationStrings['L_MSG_CADASTRA_HOMOLOGACAO_REGRA_DE_NEGOCIO']                                  = 'Cadastra Homologação em Regra de Negócio';
$translationStrings['L_MSG_CADASTRA_HOMOLOGACAO_REQUISITO']                                         = 'Cadastra Homologação em Requisito';
$translationStrings['L_MSG_CADASTRA_RELATO_TESTE_CASO_DE_USO']                                      = 'Cadastra Relato de Teste em Caso de Uso';
$translationStrings['L_MSG_CADASTRA_RELATO_TESTE_REGRA_DE_NEGOCIO']                                 = 'Cadastra Relato de Teste em Regra de Negócio';
$translationStrings['L_MSG_CADASTRA_RELATO_TESTE_REQUISITO']                                        = 'Cadastra Relato de Teste em Requisito';
$translationStrings['L_MSG_CADASTRA_SOLUCAO_CASO_DE_USO']                                           = 'Cadastra Solução em Caso de Uso';
$translationStrings['L_MSG_CADASTRA_SOLUCAO_REGRA_DE_NEGOCIO']                                      = 'Cadastra Solução em Regra de Negócio';
$translationStrings['L_MSG_CADASTRA_SOLUCAO_REQUISITO']                                             = 'Cadastra Solução em Requisito';
$translationStrings['L_MSG_CADASTRA_TESTE_CASO_DE_USO']                                             = 'Cadastra Teste em Caso de Uso';
$translationStrings['L_MSG_CADASTRA_TESTE_REGRA_DE_NEGOCIO']                                        = 'Cadastra Teste em Regra de Negócio';
$translationStrings['L_MSG_CADASTRA_TESTE_REQUISITO']                                               = 'Cadastra Teste em Requisito';
$translationStrings['L_MSG_CONFIGURACAO_CONEXAO_LDAP']                                              = 'Configurações de conexão LDAP / Active Directory';
$translationStrings['L_MSG_CRIACAO_TABELAS_SISTEMA']                                                = 'Criação das Tabelas do Sistema';
$translationStrings['L_MSG_CRIANDO_RELACIONAMENTO_TABELA']                                          = 'Criando os relacionamentos das tabelas';
$translationStrings['L_MSG_CRIANDO_TABELAS_SISTEMA']                                                = 'Criando as tabelas do sistema';
$translationStrings['L_MSG_CUSTO_PROVAVEL_MUDANCA']                                                 = 'Custo provável da mudança (Unidades de Métrica)';
$translationStrings['L_MSG_DATA_FIM_EXECUCAO_DEMANDA_MENOR_DATA_INICIO']                            = 'Data Fim é menor que a data Início da execução da demanda';
$translationStrings['L_MSG_DATA_INICIO_EXECUCAO_DEMANDA_MENOR_DATA_NIVEL_SERVICO']                  = 'Data de início da execução da demanda é menor que a data do nível de serviço';
$translationStrings['L_MSG_DATA_INICIO_VIGENCIA_MENSAGEM']                                          = 'Data de início da vigência da mensagem';
$translationStrings['L_MSG_DATA_TERMINO_VIGENCIA_MENSAGEM']                                         = 'Data de término da vigência da mensagem';
$translationStrings['L_MSG_DEFINIR_SENHA_ADMINISTRADOR']                                            = 'Definir senha do administrador';
$translationStrings['L_MSG_DESEJO_SISTEMA_ENVIE_EMAIL_DURANTE_FLUXO_PROCESSO']                      = 'Desejo que o sistema envie e-mail durante o fluxo de processo';
$translationStrings['L_MSG_DEMANDA_ATENDIDA_ANTERIORMENTE']                                         = 'Demanda atendida corretamente?';
$translationStrings['L_MSG_ESCOLHA_IDIOMA_UTILIZADO']                                               = 'Escolha o idioma a ser utilizado';
$translationStrings['L_MSG_EXECUTAR_PARCELA_VARIAVEL_PROJETO_VARIAVEL']                             = 'Executar a Parcela %value1% do Projeto %value2%';
$translationStrings['L_MSG_FOI_REALIZADA_REUNIAO_PEDIDO_MUDANCA']                                   = 'Foi realizada reunião para pedido da mudança?';
$translationStrings['L_MSG_GRAVACAO_CONSTANTE_VARIAVEL']                                            = '<span class="bold">%value1%</span> gravada com o valor <span class="bold">%value2%</span>.';
$translationStrings['L_MSG_GRAVACAO_PERMITIDA_DIRETORIO']                                           = 'Gravação permitida no diretório';
$translationStrings['L_MSG_HORA_FIM_EXECUCAO_DEMANDA_MENOR_HORA_INICIO']                            = 'Hora Fim é menor que a hora Início da execução da demanda';
$translationStrings['L_MSG_HORA_FINAL_PRIMEIRO_PERIODO_MENOR_HORA_INICIAL_PRIMEIRO_PERIODO']        = 'Hora final do primeiro período é menor que a hora inicial do primeiro período';
$translationStrings['L_MSG_HORA_FINAL_SEGUNDO_PERIODO_MENOR_HORA_FINAL_PRIMEIRO_PERIODO']           = 'Hora final do segundo período é menor que a hora final do primeiro período';
$translationStrings['L_MSG_HORA_FINAL_SEGUNDO_PERIODO_MENOR_HORA_INICIAL_PRIMEIRO_PERIODO']         = 'Hora final do segundo período é menor que a hora inicial do primeiro período';
$translationStrings['L_MSG_HORA_FINAL_SEGUNDO_PERIODO_MENOR_HORA_INICIAL_SEGUNDO_PERIODO']          = 'Hora final do segundo período é menor que a hora inicial do segundo período';
$translationStrings['L_MSG_HORA_INICIAL_SEGUNDO_PERIODO_MENOR_HORA_FINAL_PRIMEIRO_PERIODO']         = 'Hora inicial do segundo período é menor que a hora final do primeiro período';
$translationStrings['L_MSG_HORA_INICIAL_SEGUNDO_PERIODO_MENOR_HORA_INICIAL_PRIMEIRO_PERIODO']       = 'Hora inicial do segundo período é menor que a hora inicial do primeiro período';
$translationStrings['L_MSG_HORA_INICIO_EXECUCAO_DEMANDA_MENOR_HORA_NIVEL_SERVICO']                  = 'Hora de início da execução da demanda é menor que a hora do nível de serviço';
$translationStrings['L_MSG_INFORMACAO_TROCA_SENHA']                                                 = 'Procure o administrador da rede para efetuar a troca de senha';
$translationStrings['L_MSG_INFORMACOES_ORGAO']                                                      = 'Informações do Orgão';
$translationStrings['L_MSG_INICIAR_INSTALACAO']                                                     = 'Iniciar Instalação';
$translationStrings['L_MSG_INSERINDO_DADOS_EXEMPLO_TABELA']                                         = 'Inseridos os dados de exemplos nas tabelas';
$translationStrings['L_MSG_INSERINDO_DADOS_TABELA_BASICA']                                          = 'Inseridos os dados nas tabelas básicas';
$translationStrings['L_MSG_INTRODUCAO_CASO_DE_USO']                                                 = 'A proposta desse documento é detalhar o caso de uso, descrevendo as suas instâncias (cenários) que podem ser representadas por um conjunto de passos que devem ser executados pelo sistema, com o objetivo de produzir algo significativo para o ator aqui definido.';
$translationStrings['L_MSG_LINK_ACESSO_SISTEMA']                                                    = 'Para acessar o OASIS <a href="'.SYSTEM_PATH.'">clique aqui</a>';
$translationStrings['L_MSG_MUDANCA_AFETA_METRICA']                                                  = 'Esta mudança afetará a métrica?';
$translationStrings['L_MSG_PARA_ATUALIZAR_DADOS_ATUALIZE_PAGINA']                                   = 'Para atualizar os dados, atualize a página';
$translationStrings['L_MSG_PARA_FUNCIONAMENTO_NECESSARIO_PERIMISSAO_LEITURA_ESCRITA']               = 'Para que os módulos do sistema OASIS funcionem corretamente, os diretórios informados devem possuir permissão de leitura, escrita e gravação pelo servidor';
$translationStrings['L_MSG_PERMISSOES_CORRETAS']                                                    = 'As permissões estão corretas';
$translationStrings['L_MSG_SELECIONE_PARCELA_PARA_INCLUSAO_ALTERACAO_PRODUTO']                      = 'Selecione uma parcela abaixo para inclusão de produto(s) ou alteração';
$translationStrings['L_MSG_SIGA_DEMAIS_INSTRUCOES_ASSISTENTE_INSTALACAO']                           = 'Siga as demais instruções deste assistente de instalação';
$translationStrings['L_MSG_UlTRAPASSOU_QUANTIDADE_DISPONIVEL']                                      = 'Ultrapassou o saldo disponível de métrica';
$translationStrings['L_MSG_USAR_AUTENTICACAO_LDAP']                                                 = 'Usar Autenticação LDAP?';
/** Label's MENSAGENS DE SUCESSO **/
$translationStrings['L_MSG_SUCESS_ABRIR_CASO_USO']                                                  = 'Caso de Uso aberto com sucesso';
$translationStrings['L_MSG_SUCESS_ABRIR_PROPOSTA']                                                  = 'Proposta Aberta para Alteração com Sucesso';
$translationStrings['L_MSG_SUCESS_ABRIR_REGRA_NEGOCIO']                                             = 'Regra de Negócio aberta com sucesso';
$translationStrings['L_MSG_SUCESS_ABRIR_REQUISITO']                                                 = 'Requisito aberto com sucesso';
$translationStrings['L_MSG_SUCESS_ALTERACAO']                                                       = 'Registro(s) alterado(s) com sucesso';
$translationStrings['L_MSG_SUCESS_ALTERACAO_STATUS_PROJETO']                                        = 'Alteração do Status do Projeto efetuado com sucesso';
$translationStrings['L_MSG_SUCESS_ALTERACAO_CONFIGURACOES_BANCO_DADOS']                             = 'Foi alterado com as novas configurações do banco de dados';
$translationStrings['L_MSG_SUCESS_ALTERACAO_NOVAS_CONSTANTES']                                      = 'Foi alterado com as novas constantes';
$translationStrings['L_MSG_SUCESS_ALTERAR_SENHA']                                                   = 'Senha alterada com sucesso';
$translationStrings['L_MSG_SUCESS_ANALISE_FECHADA']                                                 = 'Análise fechada com sucesso.';
$translationStrings['L_MSG_SUCESS_ATUALIZACAO']                                                     = 'Registro(s) atualizado(s) com sucesso';
$translationStrings['L_MSG_SUCESS_ATUALIZACAO_VERSAO']                                              = 'Atualização das versões realizada com sucesso';
$translationStrings['L_MSG_SUCESS_AUTORIZAR_PARCELA']                                               = 'Parcela autorizada com sucesso';
$translationStrings['L_MSG_SUCESS_AVALIACAO_QUALIDADE_PROPOSTA']                                    = 'Avaliação da qualidade da proposta: <b>%value%%</b>. Gravação realizada com sucesso';
$translationStrings['L_MSG_SUCESS_CADASTRAR_JUSTIFICATIVA_SOLICITACAO']                             = 'Justificativa de Solicitação de Serviço gravado com sucesso';
$translationStrings['L_MSG_SUCESS_CONCLUIR_SOLICITACAO_SERVICO']                                    = 'Solicitação de serviço concluída com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_CALCULO_METRICA']                                       = 'Cálculo de Métrica confirmado com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_CASO_DE_USO']                                           = 'Caso de Uso Confirmado com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_DADOS_TECNICOS']                                        = 'Dados Técnicos confirmado com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_DOCUMENTACAO']                                          = 'Documentação de Projeto confirmada com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_DESIGNACAO_PROFISSIONAL_DEMANDA']                       = 'Designação confirmada com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_DICIONARIO_DE_DADOS']                                   = 'Dicionário de Dados Confirmado com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_LEITURA']                                               = 'Leitura confirmada com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_MODULOS']                                               = 'Módulos confirmados com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_PARCELAS']                                              = 'Parcelas confirmadas com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_PRODUTOS']                                              = 'Produtos confirmados com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_PROFISSIONAIS']                                         = 'Profissionais confirmados com sucesso';
$translationStrings['L_MSG_SUCESS_CONFIRMAR_REQUISITOS']                                            = 'Requisitos confirmados com sucesso';
$translationStrings['L_MSG_SUCESS_CRIADA']                                                          = 'Criada com sucesso';
$translationStrings['L_MSG_SUCESS_CRIAR_PROPOSTA']                                                  = 'Proposta criada com sucesso';
$translationStrings['L_MSG_SUCESS_CRIAR_SOLICITACAO']                                               = 'Solicitação criada com sucesso';
$translationStrings['L_MSG_SUCESS_DEFINICAO_SENHA_ADMINISTRADOR']                                   = 'Definição da senha do administrador realizado com sucesso';
$translationStrings['L_MSG_SUCESS_DEMANDA_CONCLUIDA']                                               = 'Demanda concluída com sucesso';
$translationStrings['L_MSG_SUCESS_DESASSOCIAR_PROFISSIONAL_DEMANDA']                                = 'Profissional desassociado da demanda';
$translationStrings['L_MSG_SUCESS_DESIGNACAO_PROFISSIONAL']                                         = 'Profissional Designado com Sucesso';
$translationStrings['L_MSG_SUCESS_ENCAMINHAR_PRE_DEMANDA']                                          = 'Pré-demanda encaminhada com sucesso';
$translationStrings['L_MSG_SUCESS_ENCAMINHAR_REGISTRO']                                             = 'Registro encaminhado com sucesso';
$translationStrings['L_MSG_SUCESS_ENCERRADA_PROPOSTA']                                              = 'Proposta encerrada com sucesso';
$translationStrings['L_MSG_SUCESS_ENVIO_MENSAGEM']                                                  = 'Mensagem Enviada com sucesso';
$translationStrings['L_MSG_SUCESS_EXCLUSAO']                                                        = 'Registro(s) excluído(s) com sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_ANALISE']                                                  = 'Análise fechada com sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_CASO_DE_USO']                                              = 'Caso de Uso fechado com sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_EXTRATO_MENSAL']                                           = 'Extrato Mensal fechado com sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_ITEM_RISCO']                                               = 'Item de Risco fechado com sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_PROPOSTA']                                                 = 'Proposta fechada com sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_PARCELA']                                                  = 'Parcela Fechada com Sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_REQUISITO']                                                = 'Requisito fechado com sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_SOLICITACAO_SERVICO']                                      = 'Solicitação de Serviço Fechada com Sucesso';
$translationStrings['L_MSG_SUCESS_FECHAR_VERSAO']                                                   = 'Versão fechada com sucesso';
$translationStrings['L_MSG_SUCESS_FINALIZAR_DEMANDA']                                               = 'Nível de Serviço da Demanda finalizado com sucesso';
$translationStrings['L_MSG_SUCESS_FINALIZAR_ROTINA']                                                = 'Rotina finalizada com sucesso';
$translationStrings['L_MSG_SUCESS_GRAVAR_ACEITE_PARCELA']                                           = 'Aceite da Parcela gravado com sucesso';
$translationStrings['L_MSG_SUCESS_GRAVAR_ACEITE_PROPOSTA']                                          = 'Aceite da Proposta gravado com sucesso';
$translationStrings['L_MSG_SUCESS_GRAVAR_ALOCACAO_RECURSO_PROPOSTA']                                = 'Alocação de Recurso de Proposta gravado com sucesso';
$translationStrings['L_MSG_SUCESS_GRAVAR_SUSPENSAO_PROPOSTA']                                       = 'Suspensão de Proposta gravada com sucesso';
$translationStrings['L_MSG_SUCESS_GRAVAR_RETIRADA_SUSPENSAO_PROPOSTA']                              = 'Retirada de Suspensão de Proposta gravada com sucesso';
$translationStrings['L_MSG_SUCESS_INCLUSAO']                                                        = 'Registro(s) incluído(s) com sucesso';
$translationStrings['L_MSG_SUCESS_INCLUSAO_ARQUIVO']                                                = 'Arquivo incluído(s) com sucesso';
$translationStrings['L_MSG_SUCESS_INCLUSAO_CONFIGURACAO_BANDO_DADOS']                               = 'Configuração do Banco de Dados salva com sucesso';
$translationStrings['L_MSG_SUCESS_INCLUSAO_DESALOCACAO_RECURSO_PROPOSTA']                           = 'Desalocação de Recurso de Proposta gravada com sucesso';
$translationStrings['L_MSG_SUCESS_INCLUSAO_DOCUMENTO']                                              = 'Documento salvo com sucesso';
$translationStrings['L_MSG_SUCESS_INCLUSAO_INFORMACOES_ANALISE_QUESTIONARIO_RISCO']                 = 'Informações da Análise e do Questionário de Risco salvos com sucesso';
$translationStrings['L_MSG_SUCESS_INCLUSAO_OBSERVACAO']                                             = 'Observação incluída com sucesso';
$translationStrings['L_MSG_SUCESS_INCLUSAO_USUARIO']                                                = 'Usuário incluído com sucesso';
$translationStrings['L_MSG_SUCESS_INSTALACAO_SISTEMA']                                              = 'O sistema OASIS foi instalado com sucesso';
$translationStrings['L_MSG_SUCESS_LEITURA_DEMANDA']                                                 = 'Demanda Lida com Sucesso';
$translationStrings['L_MSG_SUCESS_LER_SOLICITACAO']                                                 = 'Solicitação Lida com Sucesso';
$translationStrings['L_MSG_SUCESS_NIVEL_SERVICO_FINALIZADO']                                        = 'Nível de serviço finalizado com sucesso';
$translationStrings['L_MSG_SUCESS_QUESTIONARIO_RESPONDIDO']                                         = 'Questionário respondido com sucesso';
$translationStrings['L_MSG_SUCESS_REABRIR_PRE_DEMANDA']                                             = 'Reabertura de Pré-Demanda realizada com sucesso';
$translationStrings['L_MSG_SUCESS_REALIZACAO_CONFIGURACOES']                                        = 'Todas as configurações foram realizadas com sucesso';
$translationStrings['L_MSG_SUCESS_REALIZACAO_OPERACAO']                                             = 'Operação realizada com sucesso';
$translationStrings['L_MSG_SUCESS_REENCAMINHAMENTO_REALIZADO']                                      = 'Reencaminhamento realizado com sucesso';
$translationStrings['L_MSG_SUCESS_VALIDAR_INFORMACOES']                                             = 'Informações validadas com sucesso';
/** Label's MENSAGENS DE ALERTA **/
$translationStrings['L_MSG_ALERT_ACEITAR_TERMO_LICENCA_OBRIGATORIO']                                = $translationStrings['js']['L_VIEW_SCRIPT_ACEITAR_TERMO_LICENCA_OBRIGATORIO'];
$translationStrings['L_MSG_ALERT_ACESSO_NEGADO']                                                    = 'Acesso Negado';
$translationStrings['L_MSG_ALERT_ANALISE_RISCO_NAO_LOCALIZADA']                                     = 'Análise de Risco não localizada';
$translationStrings['L_MSG_ALERT_ARQUIVO_PARCIALMENTE_CARREGADO']                                   = 'O arquivo foi parcialmente carregado, havendo falha em seu carregamento';
$translationStrings['L_MSG_ALERT_BANCO_DADOS_SEM_TABELA_OU_INEXISTENTE']                            = 'Banco de dados sem tabelas ou inexistente';
$translationStrings['L_MSG_ALERT_BROWSER_INCOMPATIVEL_IMAGEM_SGV']                                  = 'Você precisa de um navegador capaz de exibir imagem SVG ou instale um plugin';
$translationStrings['L_MSG_ALERT_BROWSER_INCOMPATIVEL_IMAGEM_SGV_SEM_DADOS_GERACAO_GRAFICO']        = 'Você necessita de um navegador capaz de mostrar imagens SVG ou não existe dados para geração do gráfico';
$translationStrings['L_MSG_ALERT_CALCULO_ITEM_RISCO_NAO_REALIZADO']                                 = 'Calculo do Item de Risco não realizado';
$translationStrings['L_MSG_ALERT_CALCULO_RISCO_NAO_REALIZADO']                                      = 'Calculo do Risco não realizado';
$translationStrings['L_MSG_ALERT_CAMPO_OBRIGATORIO_NAO_PREENCHIDO']                                 = 'Campos Obrigatórios não preenchidos';
$translationStrings['L_MSG_ALERT_CASO_DE_USO_FECHADO_IMPOSSIVEL_ALTERAR']                           = 'O caso de uso selecionado já está fechado, não sendo possível alterá-lo';
$translationStrings['L_MSG_ALERT_CASO_DE_USO_FECHADO_IMPOSSIVEL_INCLUIR_ALTERAR_COMPLEMENTOS']      = 'O caso de uso selecionado já está fechado, não sendo possível criar ou alterar Complementos';
$translationStrings['L_MSG_ALERT_CASO_DE_USO_FECHADO_IMPOSSIVEL_INCLUIR_ALTERAR_INTERACOES']        = 'O caso de uso selecionado já está fechado, não sendo possível criar ou alterar Interações';
$translationStrings['L_MSG_ALERT_CLIQUE_MODULO_EDITAR_OU_EXCLUIR']                                  = 'Clique para editar o módulo ou <b>X</b> para excluir';
$translationStrings['L_MSG_ALERT_CLIQUE_PARA_BAIXAR_ARQUIVO']                                       = 'Clique para baixar o %value%º arquivo';
$translationStrings['L_MSG_ALERT_CLIQUE_PARA_EFETUAR_DOWNLOAD_ARQUIVO']                             = 'Clique para efetuar o download do arquivo';
$translationStrings['L_MSG_ALERT_CLIQUE_PARA_REGISTRAR_LEITURA_SOLICITACAO']                        = 'Clique no botão <b>'.$translationStrings['L_BTN_OK'].'</b> para registrar a leitura da solicitação';
$translationStrings['L_MSG_ALERT_CLIQUE_PARA_REGISTRAR_OPERACAO']                                   = 'Clique no botão <b>%value%</b> para registrar a operação';
$translationStrings['L_MSG_ALERT_CONFERIR_VARIAVEIS_METRICA_VALOR_INFORMADO']                       = 'Conferir as Variáveis da Métrica ou os valores informados';
$translationStrings['L_MSG_ALERT_CONFIRMACAO_SENHA_INCORRETA']                                      = 'A confirmação da senha está incorreta';
$translationStrings['L_MSG_ALERT_CONTRATO_SEM_METRICA_PADRAO_CONTACTE_ADMINISTRADOR']               = 'Não foi definido a métrica padrão do contrato. Entre em contato com o administrador';
$translationStrings['L_MSG_ALERT_CONTRATO_SEM_METRICA_PADRAO_NAO_GERA_RELATORIO']                   = 'Contrato não possui Métrica Padrão definida. Relatório não pode ser apresentado';
$translationStrings['L_MSG_ALERT_CONTRATO_PROJETO_VINCULADO_SEM_METRICA_PADRAO_DEFINIDA']           = 'O contrato ao qual este projeto está vinculado não possui métrica definida ou não foi definida a métrica padrão';
$translationStrings['L_MSG_ALERT_DATA_FINAL_COMPREENDE_PERIODO_ANALISADO']                          = 'Data final está compreendida no período <b>%value1% - %value2%</b> já analisado';
$translationStrings['L_MSG_ALERT_DATA_INICIAL_COMPREENDE_PERIODO_ANALISADO']                        = 'Data inicial está compreendida no período <b>%value1% - %value2%</b> já analisado';
$translationStrings['L_MSG_ALERT_DEFINIR_PRIORIDADE_DEMANDA']                                       = 'A prioridade da Demanda deve ser definida antes da designação de profissionais para sua execução. Deseja salvar a prioridade?';
$translationStrings['L_MSG_ALERT_DEMANDA_LIDA_ANTERIORMENTE']                                       = 'Demanda Lida Anteriormente';
$translationStrings['L_MSG_ALERT_DESCRICAO_MOTIVO_INSATISFACAO']                                    = 'Descrição dos Motivos da Insatisfação';
$translationStrings['L_MSG_ALERT_DESEJA_DADOS_EXEMPLO']                                             = 'Deseja dados de exemplo?';
$translationStrings['L_MSG_ALERT_DIGITE_NOME_PRODUTO_TECLE_ENTER']                                  = 'Digite o nome do produto e tecle <b>Enter</b> para inserir';
$translationStrings['L_MSG_ALERT_DOMINIO_EMAIL_LDAP_NAO_CONFERE']                                   = 'Dominio de Email do LDAP não confere com o dominio de Email configurado no OASIS';
$translationStrings['L_MSG_ALERT_DOMINIO_EMAIL_INSTITUCIONAL_OBRIGATORIO']                          = 'Deve ser informado o dominio do E-mail Institucional';
$translationStrings['L_MSG_ALERT_EXCLUSAO_METRICA_PADRO_CONTRATO']                                  = 'Você está excluíndo a associação da Métrica definida como Padrão. Caso continue, o valor dos fatores serão excluidos. Deseja continuar?';
$translationStrings['L_MSG_ALERT_EXISTE_PARCELA_SEM_PRODUTO_CADASTRADO']                            = 'Existe parcela sem produto. Impossível continuar';
$translationStrings['L_MSG_ALERT_EXTENSAO_INCORRETA_NAO_PERMITIDA']                                 = 'Carregamento de arquivo com extensão incorreta ou não permitida';
$translationStrings['L_MSG_ALERT_EMAIL_INVALIDO']                                                   = 'E-mail inválido';
$translationStrings['L_MSG_ALERT_EMAIL_INSTITUCIONAL_INVALIDO']                                     = 'E-mail Institucional inválido';
$translationStrings['L_MSG_ALERT_EMAIL_INSTITUCIONAL_FORA_PADRAO_CONFIGURADO']                      = 'O E-mail Institucional informado não confere com o dominio de email padrão (%value%) configurado no sistema. Informe um email válido';
$translationStrings['L_MSG_ALERT_ENCAMINHADO_AUTORIDADE_ANALISAR']                                  = 'Encaminado para autoridade analisar';
$translationStrings['L_MSG_ALERT_FALHA_ESCREVER_DISCO']                                             = 'Falha ao escrever arquivo para o disco';
$translationStrings['L_MSG_ALERT_FALTA_PASTA_NAO_POSSUI_PERMISSAO']                                 = 'Falta uma pasta temporária ou não possui permissão';
$translationStrings['L_MSG_ALERT_FECHAR_DEMANDA_SE_PROFISSIONAL_NAO_PODE']                          = 'Clique no botão para fechar a demanda somente se o profissional não puder fazê-lo';
$translationStrings['L_MSG_ALERT_IDIOMA_SISTEMA_OBRIGATORIO']                                       = 'A escolha do idioma do sistema e obrigatória';
$translationStrings['L_MSG_ALERT_INFORMACOES_INCORRETAS']                                           = 'Informações enviadas incorretamente';
$translationStrings['L_MSG_ALERT_INFORME_INFRACAO']                                                 = 'Por favor, informe uma infração';
$translationStrings['L_MSG_ALERT_ITEM_METRICA_NAO_CADASTRADO']                                      = 'Item de Métrica não cadastrado';
$translationStrings['L_MSG_ALERT_ITEM_NAO_PODE_SER_HOMOLOGADO']                                     = 'Item não pode ser homologado';
$translationStrings['L_MSG_ALERT_ITEM_TESTE_COM_XX_ANEXO']                                          = 'Item de teste com %value% anexo(s)';
$translationStrings['L_MSG_ALERT_ITEM_TESTE_OBRIGATORIO']                                           = 'Item de teste obrigatório';
$translationStrings['L_MSG_ALERT_CONTATO_ASSOCIADO_CONTRATO']                                       = 'Este Contato está associado a %value% contrato(s):<br/>';
$translationStrings['L_MSG_ALERT_CONTATO_ASSOCIADO_CONTRATO_10']                                    = 'Este Contato está associado a %value% contrato(s), os dez primeiros são:<br/>';
$translationStrings['L_MSG_ALERT_MENU_ASSOCIADO']                                                   = 'Este perfil está associado a %value% menu(s):<br/>';
$translationStrings['L_MSG_ALERT_MENU_ASSOCIADO_10']                                                = 'Este perfil está associado a %value% menu(s), os dez primeiros são:<br/>';
$translationStrings['L_MSG_ALERT_MENU_ASSOCIADO_PERFIL']                                            = 'Este menu está associado a %value% perfil(is):<br/>';
$translationStrings['L_MSG_ALERT_MENU_ASSOCIADO_PERFIL_10']                                         = 'Este menu está associado a %value% perfil(is), os dez primeiros são:<br/>';
$translationStrings['L_MSG_ALERT_MENU_ASSOCIADO_PROFISSIONAL']                                                  = 'Este menu está associado a %value% profissional(is):<br/>';
$translationStrings['L_MSG_ALERT_MENU_ASSOCIADO_PROFISSIONAL_10']                                               = 'Este menu está associado a %value% profissional(is), os dez primeiros são:<br/>';
$translationStrings['L_MSG_ALERT_METRICA_POSSUI_UNIDADES_VINCULADA_PROJETO_METRICA_FORA_CONTRATO']              = 'A métrica %value1% possui %value2% unidades de métrica vinculada a este projeto. No entanto, está métrica encontra-se desvinculada do contrato vigente';
$translationStrings['L_MSG_ALERT_METRICA_VINCULADA_CONTRATO_SEM_FATOR_METRICA_PADRAO_CONTACTE_ADMINISTRADOR']   = 'Existe Métrica vinculado ao contrato que não possui fator de relação com a métrica padrao. Entre em contato com o administrador';
$translationStrings['L_MSG_ALERT_NAO_EXISTE_PROFISSIONAL_PARA_PERFIL']                                          = 'Não existe profissional com o perfil selecionado associado ao objeto selecionado.';
$translationStrings['L_MSG_ALERT_NAO_EXISTE_MENSAGEM_PERIODO']                                                  = 'Não existe mensagens para o período informado';
$translationStrings['L_MSG_ALERT_NAO_EXISTE_VERSAO_ATUALIZAR']                                                  = 'Não há versões para serem atualizadas';
$translationStrings['L_MSG_ALERT_NAO_POSSUI_INFORMACOES_ANALISE']                                   = 'Não Possui Informações Registrada para Análise';
$translationStrings['L_MSG_ALERT_NAO_POSSUI_INFORMACOES_HOMOLOGACAO']                               = 'Não Possui Informações Registrada para Homologação';
$translationStrings['L_MSG_ALERT_NAO_POSSUI_INFORMACOES_SOLUCAO']                                   = 'Não Possui Informações Registrada para Solução';
$translationStrings['L_MSG_ALERT_NAO_POSSUI_PARCELA']                                               = 'Não possui parcela';
$translationStrings['L_MSG_ALERT_NECESSARIO_USUARIO_SENHA']                                         = 'É necessario informar um usuário e uma senha';
$translationStrings['L_MSG_ALERT_NENHUM_ARQUIVO_CARREGADO']                                         = 'Nenhum arquivo foi carregado';
$translationStrings['L_MSG_ALERT_NENHUM_CODIGO_ERRO_DISPONIVEL']                                    = 'Ocorreu um erro: Nenhum código de erro disponíveis';
$translationStrings['L_MSG_ALERT_NENHUM_MODULO_CRIADO_PROJETO']                                     = 'Não foi criado nenhum Módulo para este projeto';
$translationStrings['L_MSG_ALERT_NENHUM_MODULO_VINCULADO_PROPOSTA']                                 = 'Não foi vinculado nenhum Módulo para esta proposta';
$translationStrings['L_MSG_ALERT_OBJETO_SEM_ATA_REUNIAO_GERAL']                                     = 'Objeto não possui Ata de Reunião Geral';
$translationStrings['L_MSG_ALERT_PARCELA_ACEITA_PRODUTO_VINCULADO_TESTADO_APROVADO']                = 'Esta parcela FOI ACEITA pois o produto vinculado foi testado e APROVADO';
$translationStrings['L_MSG_ALERT_PARCELA_NAO_ACEITA_PRODUTO_VINCULADO_TESTADO_NAO_APROVADO']        = 'Esta parcela NÃO FOI ACEITA pois o produto vinculado foi testado e NÃO APROVADO';
$translationStrings['L_MSG_ALERT_PARCELA_SEM_PRODUTO_CADASTRADO']                                   = 'Parcela sem Produto Cadastrado';
$translationStrings['L_MSG_ALERT_PARECER_REALIZADO_POR_EM']                                         = 'Parecer realizado por <b>%value1%</b> em <b>%value2%</b>';
$translationStrings['L_MSG_ALERT_PARECER_TECNICO_AVALIACAO_PARCELA']                                = 'Parecer Técnico para Avaliação da Parcela Nr %value1%, Proposta Nr %value2%';
$translationStrings['L_MSG_ALERT_PARECER_TECNICO_AVALIACAO_PROPOSTA']                               = 'Parecer Técnico para Avaliação da Proposta Nr %value%';
$translationStrings['L_MSG_ALERT_PENALIDADE_JUSTIFICATIVA_ACEITA']                                  = 'Penalidades com justificativa aceita';
$translationStrings['L_MSG_ALERT_PERFIL_ASSOCIADO']                                                 = 'Este perfil está associado a %value% papel(is):<br/>';
$translationStrings['L_MSG_ALERT_PERFIL_ASSOCIADO_10']                                              = 'Este perfil está associado a %value% papel(is), os dez primeiros são:<br/>';
$translationStrings['L_MSG_ALERT_PERFIL_SEM_BOX_ASSOCIADO']                                         = 'Seu perfil não possui box associado';
$translationStrings['L_MSG_ALERT_PERIODO_ABRANGE_PERIODO_ANALISADO']                                = 'O período informado abrange o período <b>%value1% - %value2%</b> já analisado. Verifique a análises já efetuadas';
$translationStrings['L_MSG_ALERT_PERIODO_ABRANGIDO_PERIODO_ANALISADO']                              = 'O período informado é abrangido pelo período <b>%value1% - %value2%</b> já analisado. Verifique a análises já efetuadas';
$translationStrings['L_MSG_ALERT_PREENCHIMENTO_CAMPO_ACOMPANHAMENTO_PROPOSTA_OBRIGATORIO']          = 'Por favor, preencha o campo Acompanhamento da Proposta';
$translationStrings['L_MSG_ALERT_PREENCHIMENTO_DADOS_ABAIXO_OBRIGATORIO']                           = 'O preenchimento dos dados abaixo é obrigatorio';
$translationStrings['L_MSG_ALERT_PRIMEIRA_PROPOSTA_MINIMO_DUAS_PARCELAS']                           = 'A primeira proposta deve ter no mínimo duas parcelas';
$translationStrings['L_MSG_ALERT_PROFISSIONAL_CADASTRATO']                                          = 'Profissional já cadastrado';
$translationStrings['L_MSG_ALERT_PROFISSIONAL_POSSUI_OBJETO_PADRAO']                                = 'Este profissional já possui um objeto padrão';
$translationStrings['L_MSG_ALERT_PROJETO_NAO_LOCALIZADO']                                           = 'Ocorreu um erro. Projeto não localizado';
$translationStrings['L_MSG_ALERT_PROJETO_SEM_ATA_REUNIAO']                                          = 'Projeto não possui Ata de Reunião';
$translationStrings['L_MSG_ALERT_PROJETO_SEM_REQUISITO_CADASTRADO']                                 = 'Não existe requisito cadastrado para este projeto. Impossível continuar';
$translationStrings['L_MSG_ALERT_PROPOSTA_MINIMO_UMA_PARCELA']                                      = 'A proposta deve ter no mínimo uma parcela';
$translationStrings['L_MSG_ALERT_PROPOSTA_PROJETO_SEM_CASO_USO']                                    = 'Proposta desse Projeto não possui Caso de Uso';
$translationStrings['L_MSG_ALERT_QUESTIONAMENTO_ATUALIZACAO_REQUISITO']                             = 'A versão anterior deste requisito possui associação(ões). Deseja atualizar para a nova versão?';
$translationStrings['L_MSG_ALERT_QUESTIONARIO_AVALIACAO_SEM_CALCULO_IMPACTO_AVALIACAO_GLOBAL']      = 'Questionário de Avaliação não respondido e/ou cálculo da avaliação da proposta não realizado. Gera impacto na avaliação Global';
$translationStrings['L_MSG_ALERT_QUESTIONARIO_PROPOSTA_NAO_RESPONDIDO']                             = 'O Questionario de Avaliação desta Proposta não foi respondido.';
$translationStrings['L_MSG_ALERT_REAVALIACAO_PARCELA_APOS_EFETUAR_CORRECAO']                        = 'Uma vez efetuada a correção abaixo listada, esta parcela deverá sofrer reavaliação em ___/___/____';
$translationStrings['L_MSG_ALERT_REGISTRO_NAO_LOCALIZADO']                                          = 'Registro não localizado';
$translationStrings['L_MSG_ALERT_REGRA_NEGOCIO_NAO_PODE_SER_ALTERADA']                              = 'Regra de Negócio não pode ser alterada';
$translationStrings['L_MSG_ALERT_REQUISITO_FECHADO_NAO_ALTERAR']                                    = 'Este requisito encontra-se fechado e não pode ser alterado';
$translationStrings['L_MSG_ALERT_RESPONDA_ITENS_QUESTIONARIO']                                      = 'Por favor, responda os itens do questionario!';
$translationStrings['L_MSG_ALERT_SCHEMA_SEM_TABELA_OU_INEXISTENTE']                                 = 'Schema sem tabela ou Inexistente';
$translationStrings['L_MSG_ALERT_SCHEMA_SERA_CRIADO']                                               = 'O schema será criado';
$translationStrings['L_MSG_ALERT_SELECIONE_PARCELA_INCLUSAO_ALTERACAO_PRODUTO']                     = 'Selecione uma parcela abaixo para inclusão de produto(s) ou alteração';
$translationStrings['L_MSG_ALERT_SELECIONE_TABELA']                                                 = 'Selecione uma tabela';
$translationStrings['L_MSG_ALERT_SEM_ATA_REUNIAO_PROJETO']                                          = 'Não possui Ata de Reunião para o Projeto';
$translationStrings['L_MSG_ALERT_SEM_AVALIACAO_PROPOSTA_IMPACTO_AVALIACAO_GLOBAL']                  = 'Avaliação das propostas não realizado. Gera impacto na avaliação global do contrato';
$translationStrings['L_MSG_ALERT_SEM_DEPENDENCIA_PARA_MESMO_REQUISITO']                             = 'Não existe depenência para o mesmo Requisito';
$translationStrings['L_MSG_ALERT_SEM_HISTORICO_REGISTRADO']                                         = 'Não há histórico registrado';
$translationStrings['L_MSG_ALERT_SEM_HISTORICO_REGISTRADO_PROFISSIONAL']                            = 'Não há histórico registrado para este profissional';
$translationStrings['L_MSG_ALERT_SEM_INFO_CRIACAO_SOLICITACAO_SERVICO']                             = 'Não foram passadas as informações necessárias à criação da Solicitação';
$translationStrings['L_MSG_ALERT_SEM_INFORMACAO_HISTORICO']                                         = 'Não possui informações de histórico';
$translationStrings['L_MSG_ALERT_SEM_PARECER_TECNICO_PROJETO']                                      = 'Não Possui Parecer Técnico desse Projeto';
$translationStrings['L_MSG_ALERT_SEM_PEDIDO_ENCONTRATO']                                            = 'Nenhum pedido encontrado';
$translationStrings['L_MSG_ALERT_SEM_PENALIDADE_JUSTIFICATIVA_NAO_ACEITA']                          = 'Penalidades sem justificativas ou não aceitas';
$translationStrings['L_MSG_ALERT_SEM_PERMISSAO_ACESSAR_AREA_OASIS']                                 = 'Você; não possui permissão para acessar esta área do OASIS. (Controller: %value%)';
$translationStrings['L_MSG_ALERT_SEM_PERMISSAO_ACESSAR_LINK']                                       = 'Não possui permissão para acessar esse link';
$translationStrings['L_MSG_ALERT_SEM_PERMISSAO_GRAVACAO_DIRETORIO']                                 = 'Gravação não permitida no diretório';
$translationStrings['L_MSG_ALERT_SEM_PROFISSIONAL_DESIGNADO']                                       = 'Não possui Profissional a ser designado';
$translationStrings['L_MSG_ALERT_SEM_PROJETO_PROPOSTA_EXECUCAO']                                    = 'Não Possui Projetos com Propostas em Execução';
$translationStrings['L_MSG_ALERT_SEM_REGISTRO_ALOCACAO_RECURSO']                                    = 'Não há registro de Alocação de Recurso';
$translationStrings['L_MSG_ALERT_SEM_REGISTRO_BASELINE']                                            = 'Não há registro na Baseline';
$translationStrings['L_MSG_ALERT_SEM_REGISTRO_CALCULO_METRICA_PROJETO']                             = 'Não há registro de cálculo de métria para este projeto';
$translationStrings['L_MSG_ALERT_SEM_REGISTRO_CONSULTA']                                            = 'Sem Registros para a consulta';
$translationStrings['L_MSG_ALERT_SEM_REGISTRO_SITUACAO']                                            = 'Não há registro de Situação';
$translationStrings['L_MSG_ALERT_SEM_ITEM_CADASTRADO_METRICA']                                      = 'Não há Itens cadastrados para esta Métrica';
$translationStrings['L_MSG_ALERT_SEM_ITEM_RISCO_CADASTRADO']                                        = 'Não exite item de risco cadastrado';
$translationStrings['L_MSG_ALERT_SENHA_INFORMADA_NAO_CONFERE_SENHA_ATUAL']                          = 'A senha informada não confere com a senha atual';
$translationStrings['L_MSG_ALERT_SESSAO_EXPIROU']                                                   = 'A sessão do usuário expirou';
$translationStrings['L_MSG_ALERT_SITUACAO_PROJETO']                                                 = 'Por favor, informe a situação do projeto';
$translationStrings['L_MSG_ALERT_SOLICITACAO_LIDA_ANTERIORMENTE']                                   = 'Solicitação Lida Anteriormente';
$translationStrings['L_MSG_ALERT_SOLICITACAO_SERVICO_AGUARDANDO_ENCAMINHAMENTO']                    = 'A Solicitação de Serviço aguarda encaminhamento';
$translationStrings['L_MSG_ALERT_SOMA_VALORES_PARCEALAS_DIFERENTE_TOTAL_PROPOSTA']                  = 'A soma de valores para as parcelas é diferente do total da proposta';
$translationStrings['L_MSG_ALERT_TABELA_SEM_COLUNA']                                                = 'Tabela sem colunas';
$translationStrings['L_MSG_ALERT_TAMANHO_SUPERIOR_XX_MB']                                           = 'Tamanho do arquivo superior à %value% MBytes';
$translationStrings['L_MSG_ALERT_TAMANHO_UTRAPASSA_DIRECTIVA_PHP']                                  = 'O tamanho do arquivo ultrapassa o upload_max_filesize da directiva no php.ini';
$translationStrings['L_MSG_ALERT_TAMANHO_ULTRAPASSA_DIRECTIVA_HTML']                                = 'O arquivo ultrapassa o MAX_FILE_SIZE da directiva que foi especificado no formulário HTML';
$translationStrings['L_MSG_ALERT_TECLE_ENTER_CLIQUE_OBJETO_CONTRATO']                               = 'Tecle "Enter" ou clique no objeto de contrato para selecioná-lo';
$translationStrings['L_MSG_ALERT_TELA_AJUDA_INDISPONIVEL']                                          = 'Tela Ajuda Indisponível';
$translationStrings['L_MSG_ALERT_USUARIO_CADASTRADO']                                               = 'Usuário já cadastrado';
$translationStrings['L_MSG_ALERT_USUARIO_INATIVO']                                                  = 'Usuário inativo no sistema';
$translationStrings['L_MSG_ALERT_USUARIO_LDAP_NAO_CADASTRO']                                        = 'Usuário não cadastrado no OASIS';
$translationStrings['L_MSG_ALERT_USUARIO_NAO_LOCALIZADO']                                           = 'Usuário não localizado';
$translationStrings['L_MSG_ALERT_USUARIO_SEM_CONTRATO']                                             = 'Usuário sem contrato ou o contrato está inativo.<br /> Contacte o administrador do sistema';
$translationStrings['L_MSG_ALERT_USUARIO_SEM_PERFIL']                                               = 'Usuário sem perfil.<br /> Contacte o administrador do sistema';
$translationStrings['L_MSG_ALERT_USUARIO_SEM_PERMISSAO_EFETURAR_OPERACAO']                          = 'Usuário sem permissão para efeturar a operação';
$translationStrings['L_MSG_ALERT_USUARIO_SEM_OBJETO']                                               = 'Usuário sem objeto ou o objeto de contrato associado está inativo.<br /> Contacte o administrador do sistema';
$translationStrings['L_MSG_ALERT_USUARIO_SENHA_INVALIDOS']                                          = 'Usuário/Senha inválidos';
$translationStrings['L_MSG_ALERT_USUARIO_SENHA_OBRIGATORIO']                                        = 'É necessario informar um usuário e uma senha';
$translationStrings['L_MSG_ALERT_VARIFICA_INFORMAÇOES']                                             = 'Por favor, verifique as informações do formulario';
$translationStrings['L_MSG_ALERT_VERIFICACAO_PERMISSAO_DIRETORIO']                                  = 'Verificação das Permissões de diretórios';
$translationStrings['L_MSG_ALERT_VERSAO_ANTERIOR_POSSUI_ASSOCIACAO']                                = 'A versão anterior deste requisito possui associação(ões). Deseja atualizar para a nova versão?';
/** Label's MENSAGENS DE ALERTA para apagar**/
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO']                                                 = 'Registro possui vínculo, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_ATIVIDADE']                                       = 'Registro possui vínculo com Atividade, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_COMPLEMENTOS']                                    = 'Registro possui vínculo com um ou mais complementos';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_DOCUMENTACAO']                                    = 'Registro possui vínculo com documentação, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_ETAPA']                                           = 'Registro possui vínculo com Etapa, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_HISTORICO']                                       = 'Registro possui vínculo com Histórico, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_INTERACOES']                                      = 'Registro possui vínculo com uma ou mais interações';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_ITEM_RISCO']                                      = 'Registro possui vínculo com Item de Risco, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_OBJETO_CONTRATO']                                 = 'Registro possui vínculo com Objeto do Contrato, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_PAPEL_PROFISSIONAL']                              = 'Registro possui vínculo com Papel Profissional, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_PERFIL_PROFISSIONAL']                             = 'Registro possui vínculo com Perfil Profissional, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_PERGUNTA']                                        = 'Registro possui vínculo com Pergunta, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_PLANEJAMENTO']                                    = 'Registro possui vínculo com Planejamento, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_PROJETO_CONTINUO']                                = 'Registro possui vínculo com Projeto Contínuo, não pode ser excluído';
$translationStrings['L_MSG_ALERT_REGISTRO_VINCULO_RESPOSTA']                                        = 'Registro possui vínculo com Resposta, não pode ser excluído';
/** Label's MENSAGENS DE ERRO**/
$translationStrings['L_MSG_ERRO_ABRIR_CASO_USO']                                                    = 'Ocorreu um erro ao criar uma nova versão do Caso de Uso';
$translationStrings['L_MSG_ERRO_ABRIR_COMPLEMENTO']                                                 = 'Ocorreu um erro ao criar uma nova versão do Complemento';
$translationStrings['L_MSG_ERRO_ABRIR_INTERACAO']                                                   = 'Ocorreu um erro ao criar uma nova versão da Interação';
$translationStrings['L_MSG_ERRO_ABRIR_REGRA_NEGOCIO']                                               = 'Ocorreu um erro ao abrir a Regra de Negócio';
$translationStrings['L_MSG_ERRO_ABRIR_REQUISITO']                                                   = 'Ocorreu um erro ao abrir o Requisito';
$translationStrings['L_MSG_ERRO_ADICIONAR_PESO']                                                    = 'Ocorreu um erro ao adicionar o peso do Grupo de Fator à fórmula do cálculo.';
$translationStrings['L_MSG_ERRO_ALTERACAO_NOVAS_CONSTANTES']                                        = 'Não foi alterado com as novas constantes';
$translationStrings['L_MSG_ERRO_ALTERACAO_CONFIGURACOES_BANCO_DADOS']                               = 'Não foi alterado com as novas configurações do banco de dados';
$translationStrings['L_MSG_ERRO_ALTERAR_REGISTRO']                                                  = 'Ocorreu um erro ao alterar o(s) registro(s)';
$translationStrings['L_MSG_ERRO_ALTERAR_SENHA']                                                     = 'Ocorreu um erro ao alterar a senha';
$translationStrings['L_MSG_ERRO_ANALISE_FECHADA']                                                   = 'Ocorreu um erro ao fechar a Análise';
$translationStrings['L_MSG_ERRO_ARQUIVO_INEXISTENTE']                                               = 'Arquivo inexistente';
$translationStrings['L_MSG_ERRO_ASSOCIAR_MENSAGEM_PROFISSIONAL']                                    = 'Ocorreu um erro ao associar a mensagem aos profissionais do perfil';
$translationStrings['L_MSG_ERRO_ATUALIZAR_DADOS_NIVEL_SERVICO']                                     = 'Ocorreu um erro ao atualizar os dados do Nível de Serviço';
$translationStrings['L_MSG_ERRO_ATUALIZAR_DADOS_PROFISSIONAL']                                      = 'Ocorreu um erro ao atualizar os dados do profissional';
$translationStrings['L_MSG_ERRO_ATUALIZAR_GERENCIA_MUDANCA']                                        = 'Ocorreu um erro ao atualizar a Gerencia de Mudança';
$translationStrings['L_MSG_ERRO_ATUALIZAR_PROFISSIONAL_MENSAGEM']                                   = 'Ocorreu um erro ao atualizar os profissionais desta mensagem';
$translationStrings['L_MSG_ERRO_ATUALIZAR_REGISTRO_BASELINE']                                       = 'Ocorreu um erro ao atualizar os registros de Baseline do referido projeto';
$translationStrings['L_MSG_ERRO_GERAR_REGISTRO_CASO_DE_USO_BASELINE']                               = 'Ocorreu um erro ao gerar os registro de Casos de Uso para a Baseline. Baseline não gerada';
$translationStrings['L_MSG_ERRO_GERAR_REGISTRO_PROPOSTA_BASELINE']                                  = 'Ocorreu um erro ao gerar os registro de Propostas para a Baseline. Baseline não gerada';
$translationStrings['L_MSG_ERRO_GERAR_REGISTRO_REGRA_DE_NEGOCIO_BASELINE']                          = 'Ocorreu um erro ao gerar os registro de Regras de Negócio para a Baseline. Baseline não gerada';
$translationStrings['L_MSG_ERRO_GERAR_REGISTRO_REQUISITO_BASELINE']                                 = 'Ocorreu um erro ao gerar os registro de Requisitos para a Baseline. Baseline não gerada';
$translationStrings['L_MSG_ERRO_ATUALIZAR_STATUS_ENCAMINHAMENTO']                                   = 'Ocorreu um erro ao atualizar o status do encaminhamento';
$translationStrings['L_MSG_ERRO_ATUALIZAR_STATUS_PEDIDO']                                           = 'Ocorreu um erro ao atualizar o status do pedido';
$translationStrings['L_MSG_ERRO_ATUALIZAR_VERSAO']                                                  = 'Ocorreu um erro ao efetuar a atualização de versão';
$translationStrings['L_MSG_ERRO_AUTORIZAR_PARCELA']                                                 = 'Ocorreu um erro ao Autorizar a Parcela';
$translationStrings['L_MSG_ERRO_BANCO_DADOS_ADAPTER_NAO_ESPECIFICADO']                              = 'O Adapter do banco de dados não foi especificado';
$translationStrings['L_MSG_ERRO_BANCO_DADOS_INEXISTENTE']                                           = 'O banco de dados é inexistente';
$translationStrings['L_MSG_ERRO_BANCO_DADOS_SEM_DRIVER_INSTALADO']                                  = 'O banco de dados não possui driver instalado';
$translationStrings['L_MSG_ERRO_CADASTRAR_JUSTIFICATIVA_SOLICITACAO']                               = 'Ocorreu um erro ao gravar Justificativa de Solicitação de Serviço';
$translationStrings['L_MSG_ERRO_CALCULAR_AVALIACAO_QUALIDADE']                                      = 'Ocorreu o seguinte erro ao calculara a Avaliação de Qualidade: ';
$translationStrings['L_MSG_ERRO_CONCLUIR_SOLICITACAO_SERVICO']                                      = 'Ocorreu um erro ao concluir Solicitação de Serviço';
$translationStrings['L_MSG_ERRO_CONFIGURAR_ARQUIVO_INSTALADOR']                                     = 'Ocorreu um erro ao configurar o arquivo do instalador';
$translationStrings['L_MSG_ERRO_CONFIRMAR_DADOS']                                                   = 'Ocorreu um erro ao confirmar dados';
$translationStrings['L_MSG_ERRO_CONFIRMAR_DESIGNACAO_PROFISSIONAL_DEMANDA']                         = 'Ocorreu um erro ao confirmar designação';
$translationStrings['L_MSG_ERRO_CONFIRMAR_DOCUMENTACAO']                                            = 'Ocorreu um erro ao confirmar Documentação de Projeto';
$translationStrings['L_MSG_ERRO_CONFIRMAR_LEITURA']                                                 = 'Ocorreu um erro ao confirmar a leitura';
$translationStrings['L_MSG_ERRO_CONFIRMAR_SENHA']                                                   = 'A confirmação da senha está incorreta';
$translationStrings['L_MSG_ERRO_CRIAR_BASELINE']                                                    = 'Ocorreu um erro ao criar uma nova Baseline';
$translationStrings['L_MSG_ERRO_CRIAR_PROPOSTA']                                                    = 'Ocorreu um erro ao criar proposta';
$translationStrings['L_MSG_ERRO_CRIAR_SOLICITACAO_SERVICO']                                         = 'Ocorreu um erro ao criar a Solicitação de Serviço';
$translationStrings['L_MSG_ERRO_CRIAR_TABELAS']                                                     = 'Ocorreu um erro ao criar tabelas';
$translationStrings['L_MSG_ERRO_DEFINICAO_SENHA_ADMINISTRADOR']                                     = 'Ocorreu um erro ao definir senha para o administrador';
$translationStrings['L_MSG_ERRO_DEFINICAO_SUBPASTA']                                                = 'Ocorreu um erro na definição da subpasta';
$translationStrings['L_MSG_ERRO_DEMANDA_CONCLUIDA']                                                 = 'Ocorreu um erro ao concluir demanda';
$translationStrings['L_MSG_ERRO_DESASSOCIAR_PROFISSIONAL_DEMANDA']                                  = 'Ocorreu um erro ao desassociar profissional da demanda';
$translationStrings['L_MSG_ERRO_DESIGNACAO_PROFISSIONAL']                                           = 'Ocorreu um erro ao designar Profissional';
$translationStrings['L_MSG_ERRO_ENCAMINHAR_PRE_DEMANDA']                                            = 'Ocorreu um erro ao encaminhar Pré-Demanda';
$translationStrings['L_MSG_ERRO_ENCERRADA_PROPOSTA']                                                = 'Ocorreu um erro ao encerrada proposta';
$translationStrings['L_MSG_ERRO_ENVIO_MENSAGEM']                                                    = 'Ocorreu um erro ao enviar a mensagem';
$translationStrings['L_MSG_ERRO_ESTABELECER_CONEXAO']                                               = 'A conexão não foi estabelecida';
$translationStrings['L_MSG_ERRO_EXCLUIR_DEPENDENCIA_MENSAGEM']                                      = 'Ocorreu um erro ao excluir as dependências desta mensagem';
$translationStrings['L_MSG_ERRO_EXECUCAO_OPERACAO']                                                 = 'Ocorreu o seguinte erro durante a operação: ';
$translationStrings['L_MSG_ERRO_EXECUCAO_OPERACAO_CALCULO_RISCO']                                   = 'Ocorreu um erro ao calcular os dados do risco: ';
$translationStrings['L_MSG_ERRO_EXCLUSAO_PARCELA_AUTORIZADA']                                       = 'Parcela já foi autorizada. Não pode ser excluída.';
$translationStrings['L_MSG_ERRO_EXCLUSAO_PARCELA_PRODUTO']                                          = 'Parcela possui produtos associados. Não pode ser excluída.';
$translationStrings['L_MSG_ERRO_EXCLUSAO_REGISTRO']                                                 = 'Ocorreu um erro ao excluir o(s) registro(s)';
$translationStrings['L_MSG_ERRO_EXTENSAO_NAO_PERMITIDA']                                            = 'Extensão não Permitida';
$translationStrings['L_MSG_ERRO_FECHAR_ANALISE']                                                    = 'Ocorreu um erro ao fechar a Análise';
$translationStrings['L_MSG_ERRO_FECHAR_CASO_DE_USO']                                                = 'Ocorreu um erro ao fechar o Caso de Uso';
$translationStrings['L_MSG_ERRO_FECHAR_EXTRATO_MENSAL']                                             = 'Ocorreu um erro ao fechar o Extrato Mensal';
$translationStrings['L_MSG_ERRO_FECHAR_PARCELA']                                                    = 'Ocorreu um erro ao fechar a Parcela';
$translationStrings['L_MSG_ERRO_FECHAR_PROPOSTA']                                                   = 'Ocorreu um erro ao fechar a Proposta';
$translationStrings['L_MSG_ERRO_FECHAR_SOLICITACAO_SERVICO']                                        = 'Ocorreu um erro ao fechar a Solicitação de Serviço';
$translationStrings['L_MSG_ERRO_FECHAR_VERSAO']                                                     = 'Ocorreu um erro durante o fechamento da versão';
$translationStrings['L_MSG_ERRO_FINALIZAR_DEMANDA']                                                 = 'Ocorreu um erro ao Finalizar Demanda';
$translationStrings['L_MSG_ERRO_FINALIZAR_NIVEL_SERVICO']                                           = 'Ocorreu um erro ao finalizar nível de serviço';
$translationStrings['L_MSG_ERRO_GERAR_HISTORICO_ANDAMENTO_PEDIDO']                                  = 'Ocorreu um erro ao gerar o histórico do andamento do pedido';
$translationStrings['L_MSG_ERRO_GRAVAR_ALOCACAO_RECURSO_PROPOSTA']                                  = 'Ocorreu um erro ao gravar a Alocação de Recurso de Proposta';
$translationStrings['L_MSG_ERRO_GRAVAR_ACEITE_PARCELA']                                             = 'Ocorreu um erro ao gravar Aceite da Parcela';
$translationStrings['L_MSG_ERRO_GRAVAR_ACEITE_PROPOSTA']                                            = 'Ocorreu um erro ao gravar Aceite da Proposta';
$translationStrings['L_MSG_ERRO_GRAVAR_SUSPENSAO_PROPOSTA']                                         = 'Ocorreu um erro ao gravar Suspensão de Proposta';
$translationStrings['L_MSG_ERRO_GRAVAR_RETIRADA_SUSPENSAO_PROPOSTA']                                = 'Ocorreu um erro ao gravar Retirada de Suspensão de Proposta';
$translationStrings['L_MSG_ERRO_INCLUIR_DATA_HORA_LEITURA_DEMANDA']                                 = 'Ocorreu um erro ao salvar Data e Hora de Leitura da Demanda';
$translationStrings['L_MSG_ERRO_INCLUSAO_ANALISE_RISCO']                                            = 'Ocorreu um erro ao salvar a Análise de Risco';
$translationStrings['L_MSG_ERRO_INCLUSAO_ARQUIVO']                                                  = 'Ocorreu um erro ao salvar o(s) arquivo(s)';
$translationStrings['L_MSG_ERRO_INCLUSAO_CONFIGURACAO_BANDO_DADOS']                                 = 'Ocorreu um erro ao salvar as Configuração do Banco de Dados';
$translationStrings['L_MSG_ERRO_INCLUSAO_DADOS_DOCUMENTO']                                          = 'Ocorreu um erro ao salvar dados do documento';
$translationStrings['L_MSG_ERRO_INCLUSAO_DESALOCACAO_RECURSO_PROPOSTA']                             = 'Ocorreu um erro ao gravar a Desalocação de Recurso de Proposta';
$translationStrings['L_MSG_ERRO_INCLUSAO_HORAS_PROPOSTA']                                           = 'Ocorreu um erro ao salvar as horas da Proposta';
$translationStrings['L_MSG_ERRO_INCLUSAO_INFORMACOES_ANALISE_QUESTIONARIO_RISCO']                   = 'Ocorreu um erro ao salvar Questionário e a Análise do risco: ';
$translationStrings['L_MSG_ERRO_INCLUSAO_QUESTIONARIO_RISCO']                                       = 'Ocorreu um erro ao salvar o Questionário de risco';
$translationStrings['L_MSG_ERRO_INCLUSAO_REGISTRO']                                                 = 'Ocorreu um erro ao salvar o(s) registro(s)';
$translationStrings['L_MSG_ERRO_INCLUSAO_SALDO_PARCIAL_CALCULO_METRICA_PROPOSTA']                   = 'Ocorreu um erro ao salvar o saldo parcial do Cálculo da Métrica para a Proposta';
$translationStrings['L_MSG_ERRO_INCLUSAO_VALOR_FATOR']                                              = 'Ocorreu um erro ao registrar o valor do(s) fator(es)';
$translationStrings['L_MSG_ERRO_INCLUSAO_VALORES_PROPOSTA']                                         = 'Ocorreu um erro ao salvar os valores da Proposta';
$translationStrings['L_MSG_ERRO_INCLUSAO_VALORES_SUB_ITEM_METRICA']                                 = 'Ocorreu um erro ao salvar os valores dos Sub-Itens da Métrica';
$translationStrings['L_MSG_ERRO_INESPERADO']                                                        = 'Ocorreu um erro inesperado';
$translationStrings['L_MSG_ERRO_LER_SOLICITACAO']                                                   = 'Ocorreu um erro ao Gravar Data e Hora de Leitura da Solicitação de Serviço';
$translationStrings['L_MSG_ERRO_NENHUN_DADO_RECEBIDO_ALTERACAO']                                    = 'Nenhum dado foi recebido para alteração';
$translationStrings['L_MSG_ERRO_NENHUN_DADO_RECEBIDO_ATUALIZACAO_STATUS_PEDIDO']                    = 'Nenhum dado foi recebido para atualizar o status do pedido';
$translationStrings['L_MSG_ERRO_NENHUN_DADO_RECEBIDO_EXCLUSAO']                                     = 'Nenhum dado foi recebido para ser excluído';
$translationStrings['L_MSG_ERRO_NENHUN_DADO_RECEBIDO_INCLUSAO']                                     = 'Nenhum dado foi recebido para ser salvo';
$translationStrings['L_MSG_ERRO_NENHUN_DADO_RECEBIDO_REGISTRAR_HISTORICO_PEDIDO']                   = 'Nenhum dado foi recebido para registrar o histórico do pedido';
$translationStrings['L_MSG_ERRO_NOME_SERVIDOR_INVALIDO']                                            = 'O nome do Servidor esta ínvalido';
$translationStrings['L_MSG_ERRO_PROCESSO_ATUALIZACAO']                                              = 'Ocorreu um erro durante o processo de atualização';
$translationStrings['L_MSG_ERRO_QUANTIDADE_INPUTS']                                                 = 'Quantidade incorreta de inputs';
$translationStrings['L_MSG_ERRO_REABRIR_PRE_DEMANDA']                                               = 'Ocorreu um erro ao reabrir Pré-Demanda';
$translationStrings['L_MSG_ERRO_RECUPERAR_REGISTRO']                                                = 'Ocorreu um erro ao recuperar o(s) registro(s)';
$translationStrings['L_MSG_ERRO_RECUPERAR_MENSAGEM']                                                = 'Ocorreu um erro ao recuperar a mensagem';
$translationStrings['L_MSG_ERRO_REENCAMINHAR_DEMANDA_PROFISSIONAL']                                 = 'Ocorreu um erro ao reencaminhar demanda para o profissional.';
$translationStrings['L_MSG_ERRO_REGISTRAR_AVALIACAO_QUALIDADE']                                     = 'Ocorreu um erro ao registrar o Avaliação de Qualidade.';
$translationStrings['L_MSG_ERRO_REQUISITO_FECHADO']                                                 = 'Ocorreu um erro ao fechar Requisito';
$translationStrings['L_MSG_ERRO_RESPONDER_QUESTIONARIO']                                            = 'Ocorreu um erro ao responder o questionário';
$translationStrings['L_MSG_ERRO_SALVAR_USUARIO']                                                    = 'Motivo da Instisfação não salvo';
$translationStrings['L_MSG_ERRO_SALVAR_MOTIVO_INSATISFACAO']                                        = 'Erro ao salvar usuário';
$translationStrings['L_MSG_ERRO_SEM_CHAVE_DO_PEDIDO_ATUALIZAR_STATUS']                              = 'Identificador do pedido não encontrado. Não será possível atualizar o status';
$translationStrings['L_MSG_ERRO_SEM_CHAVE_DO_PEDIDO_REGISTRAR_HISTORICO']                           = 'Identificador do pedido não encontrado. Não será possível registrar o histórico';
$translationStrings['L_MSG_ERRO_SEM_CODIGO']                                                        = 'ERRO: SEM O CÓDIGO';
$translationStrings['L_MSG_ERRO_SEM_CODIGO_PROJETO']                                                = 'ERRO: SEM O CÓDIGO DO PROJETO';
$translationStrings['L_MSG_ERRO_SEM_DADOS_VALIDOS_REGISTRO']                                        = 'Não existem dados válidos para o registro';
$translationStrings['L_MSG_ERRO_SEM_INDICE']                                                        = 'ERRO: SEM ÍNDICE';
$translationStrings['L_MSG_ERRO_SEM_INFORMACOES_SEREM_SALVAS']                                      = 'Não possui informações a serem salvas';
$translationStrings['L_MSG_ERRO_USUARIO_SENHA_ACESSO_INVALIDO']                                     = 'O usuário ou a senha de acesso estão inválidos';
/** Label's MENSAGENS DE SQL**/
$translationStrings['L_SQL_ABERTA']                                                                 = 'Aberta';
$translationStrings['L_SQL_ABERTO']                                                                 = 'Aberto';
$translationStrings['L_SQL_ABRIL']                                                                  = $translationStrings['L_VIEW_COMBO_ABRIL'];
$translationStrings['L_SQL_ACEITA']                                                                 = 'Aceita';
$translationStrings['L_SQL_AGOSTO']                                                                 = $translationStrings['L_VIEW_COMBO_AGOSTO'];
$translationStrings['L_SQL_AGUARDADO_ACEITE']                                                       = 'Aguardando Aceite';
$translationStrings['L_SQL_AGUARDANDO_ENCAMINHAMENTO']                                              = 'Aguardando Encaminhamento';
$translationStrings['L_SQL_ALTA']                                                                   = $translationStrings['L_VIEW_ALTA'];
$translationStrings['L_SQL_ALTISSIMA']                                                              = 'Altíssima';
$translationStrings['L_SQL_ANALIZADO_ACEITO']                                                       = 'Analisado e Aceito';
$translationStrings['L_SQL_ANALIZADO_NAO_ACEITO']                                                   = 'Analisado e não Aceito';
$translationStrings['L_SQL_ANALIZADO_COMITE']                                                       = 'Analisado pelo Comitê';
$translationStrings['L_SQL_ANDAMENTO']                                                              = 'Andamento';
$translationStrings['L_SQL_APROVADO']                                                               = $translationStrings['L_VIEW_APROVADO'];
$translationStrings['L_SQL_ARQUIVO']                                                                = $translationStrings['L_VIEW_ARQUIVO'];
$translationStrings['L_SQL_ATENDIDA']                                                               = 'Atendida';
$translationStrings['L_SQL_ATIVA']                                                                  = 'Ativa';
$translationStrings['L_SQL_ATIVO']                                                                  = $translationStrings['L_VIEW_ATIVO'];
$translationStrings['L_SQL_ATOR']                                                                   = $translationStrings['L_VIEW_ATOR'];
$translationStrings['L_SQL_AUTORIZADO']                                                             = 'Autorizado';
$translationStrings['L_SQL_BAIXA']                                                                  = $translationStrings['L_VIEW_BAIXA'];
$translationStrings['L_SQL_COMITE']                                                                 = $translationStrings['L_VIEW_COMITE'];
$translationStrings['L_SQL_COMPLETADO']                                                             = $translationStrings['L_VIEW_COMPLETADO'];
$translationStrings['L_SQL_COMPLETAR']                                                              = $translationStrings['L_VIEW_COMPLETAR'];
$translationStrings['L_SQL_CONCLUIDA']                                                              = 'Concluída';
$translationStrings['L_SQL_CONTRATO']                                                               = 'Contrato';
$translationStrings['L_SQL_COTROLE']                                                                = 'Controle';
$translationStrings['L_SQL_CRIACAO_PARCELA_AUTOMATICA_DIFERENCA_DECORRENTE_ALTERACAO']              = 'Documento Proposta - Diferença decorrente da alteração realizada no mês de %value%';
$translationStrings['L_SQL_DEMANDA']                                                                = $translationStrings['L_VIEW_DEMANDA'];
$translationStrings['L_SQL_DEZEMBRO']                                                               = $translationStrings['L_VIEW_COMBO_DEZEMBRO'];
$translationStrings['L_SQL_DISPONIBILIDADE_SERVICO']                                                = 'Disponibilidade de Serviço';
$translationStrings['L_SQL_EM_EXECUCAO']                                                            = 'Em Execução';
$translationStrings['L_SQL_ENCAMINHADA_EXECUCAO']                                                   = 'Encaminhada para Execução';
$translationStrings['L_SQL_ENCAMINHADO']                                                            = 'Encaminhado';
$translationStrings['L_SQL_ESTRATEGICO']                                                            = 'Estratégico';
$translationStrings['L_SQL_EVOLUTIVO']                                                              = 'Evolutivo';
$translationStrings['L_SQL_EXCECAO']                                                                = 'Exceção';
$translationStrings['L_SQL_EXECUCAO_PROPOSTA']                                                      = 'Execução de Proposta';
$translationStrings['L_SQL_EXECUTADA']                                                              = 'Executada';
$translationStrings['L_SQL_EXTERNO']                                                                = 'Externo';
$translationStrings['L_SQL_FECHADA']                                                                = 'Fechada';
$translationStrings['L_SQL_FECHADO']                                                                = 'Fechado';
$translationStrings['L_SQL_FEVEREIRO']                                                              = $translationStrings['L_VIEW_COMBO_FEVEREIRO'];
$translationStrings['L_SQL_FLUXO_ALTERNATIVO']                                                      = 'Fluxo Alternativo';
$translationStrings['L_SQL_FRASE']                                                                  = $translationStrings['L_VIEW_FRASE'];
$translationStrings['L_SQL_FUNCIONAL']                                                              = 'Funcional';
$translationStrings['L_SQL_INATIVA']                                                                = 'Inativa';
$translationStrings['L_SQL_INATIVO']                                                                = $translationStrings['L_VIEW_INATIVO'];
$translationStrings['L_SQL_INDEFINIDO']                                                             = 'Indefinido';
$translationStrings['L_SQL_INTERNO']                                                                = 'Interno';
$translationStrings['L_SQL_INTERNO_EXTERNO']                                                        = 'Interno e Externo';
$translationStrings['L_SQL_ITEM_TESTE']                                                             = 'Item de Teste';
$translationStrings['L_SQL_JANEIRO']                                                                = $translationStrings['L_VIEW_COMBO_JANEIRO'];
$translationStrings['L_SQL_JULHO']                                                                  = $translationStrings['L_VIEW_COMBO_JULHO'];
$translationStrings['L_SQL_JUNHO']                                                                  = $translationStrings['L_VIEW_COMBO_JUNHO'];
$translationStrings['L_SQL_MAIO']                                                                   = $translationStrings['L_VIEW_COMBO_MAIO'];
$translationStrings['L_SQL_MARCO']                                                                  = $translationStrings['L_VIEW_COMBO_MARCO'];
$translationStrings['L_SQL_MEDIA']                                                                  = 'Média';
$translationStrings['L_SQL_MODIFICAR']                                                              = 'Modificar';
$translationStrings['L_SQL_NAO']                                                                    = $translationStrings['L_VIEW_NAO'];
$translationStrings['L_SQL_NAO_ACEITA']                                                             = 'Não aceita';
$translationStrings['L_SQL_NAO_ATENDIDA']                                                           = 'Não Atendida';
$translationStrings['L_SQL_NAO_EXECUTADA']                                                          = 'Não Executada';
$translationStrings['L_SQL_NAO_FUNCIONAL']                                                          = 'Não Funcional';
$translationStrings['L_SQL_NOVEMBRO']                                                               = $translationStrings['L_VIEW_COMBO_NOVEMBRO'];
$translationStrings['L_SQL_NOVO']                                                                   = 'Novo';
$translationStrings['L_SQL_PENDENTE']                                                               = 'Pendente';
$translationStrings['L_SQL_PREENCHIDO']                                                             = 'Preenchido';
$translationStrings['L_SQL_PRIORIDADE']                                                             = $translationStrings['L_VIEW_PRIORIDADE'];
$translationStrings['L_SQL_PROFISSIONAL']                                                           = 'Profissional';
$translationStrings['L_SQL_PROJETO']                                                                = $translationStrings['L_VIEW_PROJETO'];
$translationStrings['L_SQL_PROJETO_CONTINUO']                                                       = $translationStrings['L_VIEW_PROJETO_CONTINUO'];
$translationStrings['L_SQL_PROPOSTA_NR']                                                            = 'Proposta Nr';
$translationStrings['L_SQL_OPCAO']                                                                  = $translationStrings['L_VIEW_OPCAO'];
$translationStrings['L_SQL_OUTUBRO']                                                                = $translationStrings['L_VIEW_COMBO_OUTUBRO'];
$translationStrings['L_SQL_RECUSADO']                                                               = 'Recusado';
$translationStrings['L_SQL_REGRA']                                                                  = 'Regra';
$translationStrings['L_SQL_REJEITADO']                                                              = 'Rejeitado';
$translationStrings['L_SQL_RESERVADO']                                                              = 'Reservado';
$translationStrings['L_SQL_SEM_JUSTIFICATIVA']                                                      = 'Sem Justificativa';
$translationStrings['L_SQL_SERVICO']                                                                = 'Serviço';
$translationStrings['L_SQL_SETEMBRO']                                                               = $translationStrings['L_VIEW_COMBO_SETEMBRO'];
$translationStrings['L_SQL_SIM']                                                                    = $translationStrings['L_VIEW_SIM'];
$translationStrings['L_SQL_SISTEMA']                                                                = $translationStrings['L_VIEW_SISTEMA'];
$translationStrings['L_SQL_SERVICE_DESK']                                                           = 'Service Desk';
$translationStrings['L_SQL_SOLICITACAO_PROPOSTA']                                                   = 'Solicitação de Proposta';
$translationStrings['L_SQL_SOLICITACAO_SERVICO']                                                    = 'Solicitação de Serviço';
$translationStrings['L_SQL_SOLICITACAO_SERVICO_CRIADA']                                             = 'Criada Solicitação de Serviço';
$translationStrings['L_SQL_SUBMETIDO']                                                              = $translationStrings['L_VIEW_SUBMETIDO'];
$translationStrings['L_SQL_TECNICO']                                                                = 'Técnico';
$translationStrings['L_SQL_TEMPO_RESPOSTA']                                                         = $translationStrings['L_VIEW_TEMPO_RESPOSTA'];
$translationStrings['L_SQL_TEXTO']                                                                  = $translationStrings['L_VIEW_TEXTO'];
$translationStrings['L_SQL_TODOS']                                                                  = 'Todos';
$translationStrings['L_SQL_VALIDADO']                                                               = 'Validado';
$translationStrings['L_SQL_VERSAO']                                                                 = 'Versão';
